/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 84 "src/parse.yy"


#include "decl.h"
#include "expr.h"
#include "func.h"
#include "ispc.h"
#include "module.h"
#include "stmt.h"
#include "sym.h"
#include "type.h"
#include "util.h"

#include <inttypes.h>
#include <llvm/IR/Constants.h>
#include <stdio.h>
#include <variant>

using namespace ispc;

// This macro is defined to be used in printer directives later.
#define SAFE_ACCESS(ptr, expr) ((ptr) ? (ptr)->expr : "nullptr")

#define UNIMPLEMENTED \
        Error(yylloc, "Unimplemented parser functionality %s:%d", \
        __FILE__, __LINE__);

union YYSTYPE;
extern int yylex();

extern char *yytext;

void yyerror(const char *s);

void lCleanUpString(std::string *str);
void lFreeSimpleTemplateID(void *p);
static int lYYTNameErr(char *yyres, const char *yystr);

static void lSuggestBuiltinAlternates();
static void lSuggestParamListAlternates();

static void lAddDeclaration(DeclSpecs *ds, Declarator *decl);
static void lAddTemplateDeclaration(TemplateParms *templateParmList, DeclSpecs *ds, Declarator *decl);
static void lAddTemplateSpecialization(const TemplateArgs &templArgs, DeclSpecs *ds, Declarator *decl);
static void lAddFunctionParams(Declarator *decl);
static void lAddMaskToSymbolTable(SourcePos pos);
static void lAddThreadIndexCountToSymbolTable(SourcePos pos);
static std::string lGetAlternates(std::vector<std::string> &alternates);
static bool lGetConstantIntOrSymbol(Expr *expr, std::variant<std::monostate, int, Symbol*> *value, SourcePos pos, const char *usage);
static StructType *lCreateStructType(const std::string &name, const std::vector<StructDeclaration *> *decl,
                                     AttributeList *attrs, SourcePos pos);

enum class TemplateType { Template, Instantiation, Specialization };
static void lCheckTemplateDeclSpecs(DeclSpecs *ds, SourcePos pos, TemplateType type, const char* name);

static EnumType *lCreateEnumType(const char *name, std::vector<Symbol *> *enums,
                                 SourcePos pos);
static void lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                                       const EnumType *enumType);

static const char *lBuiltinTokens[] = {
    "assert", "bool", "break", "case", "cdo",
    "cfor", "cif", "cwhile", "const", "continue", "default",
    "do", "delete", "double", "else", "enum", "export", "extern", "false",
    "float16", "float", "for", "foreach", "foreach_active", "foreach_tiled",
    "foreach_unique", "goto", "if", "in", "inline",
    "int", "int8", "int16", "int32", "int64", "invoke_sycl", "launch", "new", "NULL",
    "print", "return", "signed", "sizeof", "static", "struct", "switch",
    "sync", "task", "true", "typedef", "uniform", "unmasked", "unsigned",
    "varying", "void", "while", "__attribute__", NULL
};

static const char *lParamListTokens[] = {
    "bool", "const", "double", "enum", "false", "float16", "float", "int",
    "int8", "int16", "int32", "int64", "signed", "struct", "true",
    "uniform", "unsigned", "varying", "void", "__attribute__", NULL
};

struct ForeachDimension {
    ForeachDimension(Symbol *s = nullptr, Expr *b = nullptr, Expr *e = nullptr) {
        sym = s;
        beginExpr = b;
        endExpr = e;
    }
    Symbol *sym;
    Expr *beginExpr, *endExpr;
};


#line 160 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parse.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOKEN_INT8_CONSTANT = 3,        /* TOKEN_INT8_CONSTANT  */
  YYSYMBOL_TOKEN_UINT8_CONSTANT = 4,       /* TOKEN_UINT8_CONSTANT  */
  YYSYMBOL_TOKEN_INT16_CONSTANT = 5,       /* TOKEN_INT16_CONSTANT  */
  YYSYMBOL_TOKEN_UINT16_CONSTANT = 6,      /* TOKEN_UINT16_CONSTANT  */
  YYSYMBOL_TOKEN_INT32_CONSTANT = 7,       /* TOKEN_INT32_CONSTANT  */
  YYSYMBOL_TOKEN_UINT32_CONSTANT = 8,      /* TOKEN_UINT32_CONSTANT  */
  YYSYMBOL_TOKEN_INT64_CONSTANT = 9,       /* TOKEN_INT64_CONSTANT  */
  YYSYMBOL_TOKEN_UINT64_CONSTANT = 10,     /* TOKEN_UINT64_CONSTANT  */
  YYSYMBOL_TOKEN_INT32DOTDOTDOT_CONSTANT = 11, /* TOKEN_INT32DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_UINT32DOTDOTDOT_CONSTANT = 12, /* TOKEN_UINT32DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_INT64DOTDOTDOT_CONSTANT = 13, /* TOKEN_INT64DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_UINT64DOTDOTDOT_CONSTANT = 14, /* TOKEN_UINT64DOTDOTDOT_CONSTANT  */
  YYSYMBOL_TOKEN_FLOAT16_CONSTANT = 15,    /* TOKEN_FLOAT16_CONSTANT  */
  YYSYMBOL_TOKEN_FLOAT_CONSTANT = 16,      /* TOKEN_FLOAT_CONSTANT  */
  YYSYMBOL_TOKEN_DOUBLE_CONSTANT = 17,     /* TOKEN_DOUBLE_CONSTANT  */
  YYSYMBOL_TOKEN_STRING_C_LITERAL = 18,    /* TOKEN_STRING_C_LITERAL  */
  YYSYMBOL_TOKEN_STRING_SYCL_LITERAL = 19, /* TOKEN_STRING_SYCL_LITERAL  */
  YYSYMBOL_TOKEN_IDENTIFIER = 20,          /* TOKEN_IDENTIFIER  */
  YYSYMBOL_TOKEN_STRING_LITERAL = 21,      /* TOKEN_STRING_LITERAL  */
  YYSYMBOL_TOKEN_TYPE_NAME = 22,           /* TOKEN_TYPE_NAME  */
  YYSYMBOL_TOKEN_PRAGMA = 23,              /* TOKEN_PRAGMA  */
  YYSYMBOL_TOKEN_NULL = 24,                /* TOKEN_NULL  */
  YYSYMBOL_TOKEN_TEMPLATE_NAME = 25,       /* TOKEN_TEMPLATE_NAME  */
  YYSYMBOL_TOKEN_TEMPLATE = 26,            /* TOKEN_TEMPLATE  */
  YYSYMBOL_TOKEN_TYPENAME = 27,            /* TOKEN_TYPENAME  */
  YYSYMBOL_TOKEN_PTR_OP = 28,              /* TOKEN_PTR_OP  */
  YYSYMBOL_TOKEN_INC_OP = 29,              /* TOKEN_INC_OP  */
  YYSYMBOL_TOKEN_DEC_OP = 30,              /* TOKEN_DEC_OP  */
  YYSYMBOL_TOKEN_LEFT_OP = 31,             /* TOKEN_LEFT_OP  */
  YYSYMBOL_TOKEN_RIGHT_OP = 32,            /* TOKEN_RIGHT_OP  */
  YYSYMBOL_TOKEN_LE_OP = 33,               /* TOKEN_LE_OP  */
  YYSYMBOL_TOKEN_GE_OP = 34,               /* TOKEN_GE_OP  */
  YYSYMBOL_TOKEN_EQ_OP = 35,               /* TOKEN_EQ_OP  */
  YYSYMBOL_TOKEN_NE_OP = 36,               /* TOKEN_NE_OP  */
  YYSYMBOL_TOKEN_AND_OP = 37,              /* TOKEN_AND_OP  */
  YYSYMBOL_TOKEN_OR_OP = 38,               /* TOKEN_OR_OP  */
  YYSYMBOL_TOKEN_MUL_ASSIGN = 39,          /* TOKEN_MUL_ASSIGN  */
  YYSYMBOL_TOKEN_DIV_ASSIGN = 40,          /* TOKEN_DIV_ASSIGN  */
  YYSYMBOL_TOKEN_MOD_ASSIGN = 41,          /* TOKEN_MOD_ASSIGN  */
  YYSYMBOL_TOKEN_ADD_ASSIGN = 42,          /* TOKEN_ADD_ASSIGN  */
  YYSYMBOL_TOKEN_SUB_ASSIGN = 43,          /* TOKEN_SUB_ASSIGN  */
  YYSYMBOL_TOKEN_LEFT_ASSIGN = 44,         /* TOKEN_LEFT_ASSIGN  */
  YYSYMBOL_TOKEN_RIGHT_ASSIGN = 45,        /* TOKEN_RIGHT_ASSIGN  */
  YYSYMBOL_TOKEN_AND_ASSIGN = 46,          /* TOKEN_AND_ASSIGN  */
  YYSYMBOL_TOKEN_OR_ASSIGN = 47,           /* TOKEN_OR_ASSIGN  */
  YYSYMBOL_TOKEN_XOR_ASSIGN = 48,          /* TOKEN_XOR_ASSIGN  */
  YYSYMBOL_TOKEN_SIZEOF = 49,              /* TOKEN_SIZEOF  */
  YYSYMBOL_TOKEN_NEW = 50,                 /* TOKEN_NEW  */
  YYSYMBOL_TOKEN_DELETE = 51,              /* TOKEN_DELETE  */
  YYSYMBOL_TOKEN_IN = 52,                  /* TOKEN_IN  */
  YYSYMBOL_TOKEN_ALLOCA = 53,              /* TOKEN_ALLOCA  */
  YYSYMBOL_TOKEN_INTRINSIC_CALL = 54,      /* TOKEN_INTRINSIC_CALL  */
  YYSYMBOL_TOKEN_EXTERN = 55,              /* TOKEN_EXTERN  */
  YYSYMBOL_TOKEN_EXPORT = 56,              /* TOKEN_EXPORT  */
  YYSYMBOL_TOKEN_STATIC = 57,              /* TOKEN_STATIC  */
  YYSYMBOL_TOKEN_INLINE = 58,              /* TOKEN_INLINE  */
  YYSYMBOL_TOKEN_NOINLINE = 59,            /* TOKEN_NOINLINE  */
  YYSYMBOL_TOKEN_VECTORCALL = 60,          /* TOKEN_VECTORCALL  */
  YYSYMBOL_TOKEN_REGCALL = 61,             /* TOKEN_REGCALL  */
  YYSYMBOL_TOKEN_TASK = 62,                /* TOKEN_TASK  */
  YYSYMBOL_TOKEN_DECLSPEC = 63,            /* TOKEN_DECLSPEC  */
  YYSYMBOL_TOKEN_UNIFORM = 64,             /* TOKEN_UNIFORM  */
  YYSYMBOL_TOKEN_VARYING = 65,             /* TOKEN_VARYING  */
  YYSYMBOL_TOKEN_TYPEDEF = 66,             /* TOKEN_TYPEDEF  */
  YYSYMBOL_TOKEN_SOA = 67,                 /* TOKEN_SOA  */
  YYSYMBOL_TOKEN_UNMASKED = 68,            /* TOKEN_UNMASKED  */
  YYSYMBOL_TOKEN_INT = 69,                 /* TOKEN_INT  */
  YYSYMBOL_TOKEN_SIGNED = 70,              /* TOKEN_SIGNED  */
  YYSYMBOL_TOKEN_UNSIGNED = 71,            /* TOKEN_UNSIGNED  */
  YYSYMBOL_TOKEN_FLOAT16 = 72,             /* TOKEN_FLOAT16  */
  YYSYMBOL_TOKEN_FLOAT = 73,               /* TOKEN_FLOAT  */
  YYSYMBOL_TOKEN_DOUBLE = 74,              /* TOKEN_DOUBLE  */
  YYSYMBOL_TOKEN_INT8 = 75,                /* TOKEN_INT8  */
  YYSYMBOL_TOKEN_INT16 = 76,               /* TOKEN_INT16  */
  YYSYMBOL_TOKEN_INT64 = 77,               /* TOKEN_INT64  */
  YYSYMBOL_TOKEN_CONST = 78,               /* TOKEN_CONST  */
  YYSYMBOL_TOKEN_VOID = 79,                /* TOKEN_VOID  */
  YYSYMBOL_TOKEN_BOOL = 80,                /* TOKEN_BOOL  */
  YYSYMBOL_TOKEN_UINT8 = 81,               /* TOKEN_UINT8  */
  YYSYMBOL_TOKEN_UINT16 = 82,              /* TOKEN_UINT16  */
  YYSYMBOL_TOKEN_UINT = 83,                /* TOKEN_UINT  */
  YYSYMBOL_TOKEN_UINT64 = 84,              /* TOKEN_UINT64  */
  YYSYMBOL_TOKEN_ENUM = 85,                /* TOKEN_ENUM  */
  YYSYMBOL_TOKEN_STRUCT = 86,              /* TOKEN_STRUCT  */
  YYSYMBOL_TOKEN_TRUE = 87,                /* TOKEN_TRUE  */
  YYSYMBOL_TOKEN_FALSE = 88,               /* TOKEN_FALSE  */
  YYSYMBOL_TOKEN_CASE = 89,                /* TOKEN_CASE  */
  YYSYMBOL_TOKEN_DEFAULT = 90,             /* TOKEN_DEFAULT  */
  YYSYMBOL_TOKEN_IF = 91,                  /* TOKEN_IF  */
  YYSYMBOL_TOKEN_ELSE = 92,                /* TOKEN_ELSE  */
  YYSYMBOL_TOKEN_SWITCH = 93,              /* TOKEN_SWITCH  */
  YYSYMBOL_TOKEN_WHILE = 94,               /* TOKEN_WHILE  */
  YYSYMBOL_TOKEN_DO = 95,                  /* TOKEN_DO  */
  YYSYMBOL_TOKEN_LAUNCH = 96,              /* TOKEN_LAUNCH  */
  YYSYMBOL_TOKEN_FOREACH = 97,             /* TOKEN_FOREACH  */
  YYSYMBOL_TOKEN_FOREACH_TILED = 98,       /* TOKEN_FOREACH_TILED  */
  YYSYMBOL_TOKEN_FOREACH_UNIQUE = 99,      /* TOKEN_FOREACH_UNIQUE  */
  YYSYMBOL_TOKEN_FOREACH_ACTIVE = 100,     /* TOKEN_FOREACH_ACTIVE  */
  YYSYMBOL_TOKEN_DOTDOTDOT = 101,          /* TOKEN_DOTDOTDOT  */
  YYSYMBOL_TOKEN_FOR = 102,                /* TOKEN_FOR  */
  YYSYMBOL_TOKEN_GOTO = 103,               /* TOKEN_GOTO  */
  YYSYMBOL_TOKEN_CONTINUE = 104,           /* TOKEN_CONTINUE  */
  YYSYMBOL_TOKEN_BREAK = 105,              /* TOKEN_BREAK  */
  YYSYMBOL_TOKEN_RETURN = 106,             /* TOKEN_RETURN  */
  YYSYMBOL_TOKEN_CIF = 107,                /* TOKEN_CIF  */
  YYSYMBOL_TOKEN_CDO = 108,                /* TOKEN_CDO  */
  YYSYMBOL_TOKEN_CFOR = 109,               /* TOKEN_CFOR  */
  YYSYMBOL_TOKEN_CWHILE = 110,             /* TOKEN_CWHILE  */
  YYSYMBOL_TOKEN_SYNC = 111,               /* TOKEN_SYNC  */
  YYSYMBOL_TOKEN_PRINT = 112,              /* TOKEN_PRINT  */
  YYSYMBOL_TOKEN_ASSERT = 113,             /* TOKEN_ASSERT  */
  YYSYMBOL_TOKEN_INVOKE_SYCL = 114,        /* TOKEN_INVOKE_SYCL  */
  YYSYMBOL_TOKEN_ATTRIBUTE = 115,          /* TOKEN_ATTRIBUTE  */
  YYSYMBOL_STRUCT_WITHOUT_ATTRIBUTE = 116, /* STRUCT_WITHOUT_ATTRIBUTE  */
  YYSYMBOL_117_ = 117,                     /* '('  */
  YYSYMBOL_118_ = 118,                     /* ')'  */
  YYSYMBOL_119_ = 119,                     /* '['  */
  YYSYMBOL_120_ = 120,                     /* ']'  */
  YYSYMBOL_121_ = 121,                     /* ','  */
  YYSYMBOL_122_ = 122,                     /* '<'  */
  YYSYMBOL_123_ = 123,                     /* '>'  */
  YYSYMBOL_124_ = 124,                     /* '.'  */
  YYSYMBOL_125_ = 125,                     /* '&'  */
  YYSYMBOL_126_ = 126,                     /* '*'  */
  YYSYMBOL_127_ = 127,                     /* '+'  */
  YYSYMBOL_128_ = 128,                     /* '-'  */
  YYSYMBOL_129_ = 129,                     /* '~'  */
  YYSYMBOL_130_ = 130,                     /* '!'  */
  YYSYMBOL_131_ = 131,                     /* '/'  */
  YYSYMBOL_132_ = 132,                     /* '%'  */
  YYSYMBOL_133_ = 133,                     /* '^'  */
  YYSYMBOL_134_ = 134,                     /* '|'  */
  YYSYMBOL_135_ = 135,                     /* '?'  */
  YYSYMBOL_136_ = 136,                     /* ':'  */
  YYSYMBOL_137_ = 137,                     /* '='  */
  YYSYMBOL_138_ = 138,                     /* ';'  */
  YYSYMBOL_139_ = 139,                     /* '{'  */
  YYSYMBOL_140_ = 140,                     /* '}'  */
  YYSYMBOL_YYACCEPT = 141,                 /* $accept  */
  YYSYMBOL_string_constant = 142,          /* string_constant  */
  YYSYMBOL_primary_expression = 143,       /* primary_expression  */
  YYSYMBOL_launch_expression = 144,        /* launch_expression  */
  YYSYMBOL_invoke_sycl_expression = 145,   /* invoke_sycl_expression  */
  YYSYMBOL_postfix_expression = 146,       /* postfix_expression  */
  YYSYMBOL_intrinsic_name = 147,           /* intrinsic_name  */
  YYSYMBOL_intrincall_expression = 148,    /* intrincall_expression  */
  YYSYMBOL_funcall_expression = 149,       /* funcall_expression  */
  YYSYMBOL_argument_expression_list = 150, /* argument_expression_list  */
  YYSYMBOL_unary_expression = 151,         /* unary_expression  */
  YYSYMBOL_cast_expression = 152,          /* cast_expression  */
  YYSYMBOL_multiplicative_expression = 153, /* multiplicative_expression  */
  YYSYMBOL_additive_expression = 154,      /* additive_expression  */
  YYSYMBOL_shift_expression = 155,         /* shift_expression  */
  YYSYMBOL_relational_expression = 156,    /* relational_expression  */
  YYSYMBOL_equality_expression = 157,      /* equality_expression  */
  YYSYMBOL_and_expression = 158,           /* and_expression  */
  YYSYMBOL_exclusive_or_expression = 159,  /* exclusive_or_expression  */
  YYSYMBOL_inclusive_or_expression = 160,  /* inclusive_or_expression  */
  YYSYMBOL_logical_and_expression = 161,   /* logical_and_expression  */
  YYSYMBOL_logical_or_expression = 162,    /* logical_or_expression  */
  YYSYMBOL_conditional_expression = 163,   /* conditional_expression  */
  YYSYMBOL_rate_qualified_new = 164,       /* rate_qualified_new  */
  YYSYMBOL_rate_qualified_type_specifier = 165, /* rate_qualified_type_specifier  */
  YYSYMBOL_new_expression = 166,           /* new_expression  */
  YYSYMBOL_assignment_expression = 167,    /* assignment_expression  */
  YYSYMBOL_expression = 168,               /* expression  */
  YYSYMBOL_constant_expression = 169,      /* constant_expression  */
  YYSYMBOL_declaration_statement = 170,    /* declaration_statement  */
  YYSYMBOL_declaration = 171,              /* declaration  */
  YYSYMBOL_soa_width_specifier = 172,      /* soa_width_specifier  */
  YYSYMBOL_declspec_item = 173,            /* declspec_item  */
  YYSYMBOL_declspec_list = 174,            /* declspec_list  */
  YYSYMBOL_declspec_specifier = 175,       /* declspec_specifier  */
  YYSYMBOL_declaration_specifiers = 176,   /* declaration_specifiers  */
  YYSYMBOL_attribute_specifier = 177,      /* attribute_specifier  */
  YYSYMBOL_attribute_list = 178,           /* attribute_list  */
  YYSYMBOL_attribute = 179,                /* attribute  */
  YYSYMBOL_attribute_argument = 180,       /* attribute_argument  */
  YYSYMBOL_init_declarator_list = 181,     /* init_declarator_list  */
  YYSYMBOL_init_declarator = 182,          /* init_declarator  */
  YYSYMBOL_storage_class_specifier = 183,  /* storage_class_specifier  */
  YYSYMBOL_type_specifier = 184,           /* type_specifier  */
  YYSYMBOL_type_specifier_list = 185,      /* type_specifier_list  */
  YYSYMBOL_atomic_var_type_specifier = 186, /* atomic_var_type_specifier  */
  YYSYMBOL_short_vec_specifier = 187,      /* short_vec_specifier  */
  YYSYMBOL_struct_or_union_name = 188,     /* struct_or_union_name  */
  YYSYMBOL_struct_or_union_and_name = 189, /* struct_or_union_and_name  */
  YYSYMBOL_struct_or_union_specifier = 190, /* struct_or_union_specifier  */
  YYSYMBOL_struct_or_union = 191,          /* struct_or_union  */
  YYSYMBOL_struct_declaration_list = 192,  /* struct_declaration_list  */
  YYSYMBOL_struct_declaration = 193,       /* struct_declaration  */
  YYSYMBOL_specifier_qualifier_list = 194, /* specifier_qualifier_list  */
  YYSYMBOL_struct_declarator_list = 195,   /* struct_declarator_list  */
  YYSYMBOL_struct_declarator = 196,        /* struct_declarator  */
  YYSYMBOL_enum_identifier = 197,          /* enum_identifier  */
  YYSYMBOL_enum_specifier = 198,           /* enum_specifier  */
  YYSYMBOL_enumerator_list = 199,          /* enumerator_list  */
  YYSYMBOL_enumerator = 200,               /* enumerator  */
  YYSYMBOL_type_qualifier = 201,           /* type_qualifier  */
  YYSYMBOL_type_qualifier_list = 202,      /* type_qualifier_list  */
  YYSYMBOL_declarator = 203,               /* declarator  */
  YYSYMBOL_int_constant = 204,             /* int_constant  */
  YYSYMBOL_direct_declarator = 205,        /* direct_declarator  */
  YYSYMBOL_pointer = 206,                  /* pointer  */
  YYSYMBOL_reference = 207,                /* reference  */
  YYSYMBOL_parameter_type_list = 208,      /* parameter_type_list  */
  YYSYMBOL_parameter_list = 209,           /* parameter_list  */
  YYSYMBOL_parameter_declaration = 210,    /* parameter_declaration  */
  YYSYMBOL_type_name = 211,                /* type_name  */
  YYSYMBOL_abstract_declarator = 212,      /* abstract_declarator  */
  YYSYMBOL_direct_abstract_declarator = 213, /* direct_abstract_declarator  */
  YYSYMBOL_initializer = 214,              /* initializer  */
  YYSYMBOL_initializer_list = 215,         /* initializer_list  */
  YYSYMBOL_pragma = 216,                   /* pragma  */
  YYSYMBOL_attributed_statement = 217,     /* attributed_statement  */
  YYSYMBOL_statement = 218,                /* statement  */
  YYSYMBOL_labeled_statement = 219,        /* labeled_statement  */
  YYSYMBOL_start_scope = 220,              /* start_scope  */
  YYSYMBOL_end_scope = 221,                /* end_scope  */
  YYSYMBOL_compound_statement = 222,       /* compound_statement  */
  YYSYMBOL_statement_list = 223,           /* statement_list  */
  YYSYMBOL_expression_statement = 224,     /* expression_statement  */
  YYSYMBOL_selection_statement = 225,      /* selection_statement  */
  YYSYMBOL_for_test = 226,                 /* for_test  */
  YYSYMBOL_for_init_statement = 227,       /* for_init_statement  */
  YYSYMBOL_for_scope = 228,                /* for_scope  */
  YYSYMBOL_cfor_scope = 229,               /* cfor_scope  */
  YYSYMBOL_foreach_scope = 230,            /* foreach_scope  */
  YYSYMBOL_foreach_tiled_scope = 231,      /* foreach_tiled_scope  */
  YYSYMBOL_foreach_identifier = 232,       /* foreach_identifier  */
  YYSYMBOL_foreach_active_scope = 233,     /* foreach_active_scope  */
  YYSYMBOL_foreach_active_identifier = 234, /* foreach_active_identifier  */
  YYSYMBOL_integer_dotdotdot = 235,        /* integer_dotdotdot  */
  YYSYMBOL_foreach_dimension_specifier = 236, /* foreach_dimension_specifier  */
  YYSYMBOL_foreach_dimension_list = 237,   /* foreach_dimension_list  */
  YYSYMBOL_foreach_unique_scope = 238,     /* foreach_unique_scope  */
  YYSYMBOL_foreach_unique_identifier = 239, /* foreach_unique_identifier  */
  YYSYMBOL_iteration_statement = 240,      /* iteration_statement  */
  YYSYMBOL_241_1 = 241,                    /* $@1  */
  YYSYMBOL_242_2 = 242,                    /* $@2  */
  YYSYMBOL_243_3 = 243,                    /* $@3  */
  YYSYMBOL_244_4 = 244,                    /* $@4  */
  YYSYMBOL_goto_identifier = 245,          /* goto_identifier  */
  YYSYMBOL_jump_statement = 246,           /* jump_statement  */
  YYSYMBOL_sync_statement = 247,           /* sync_statement  */
  YYSYMBOL_delete_statement = 248,         /* delete_statement  */
  YYSYMBOL_unmasked_statement = 249,       /* unmasked_statement  */
  YYSYMBOL_print_statement = 250,          /* print_statement  */
  YYSYMBOL_assert_statement = 251,         /* assert_statement  */
  YYSYMBOL_translation_unit = 252,         /* translation_unit  */
  YYSYMBOL_external_declaration = 253,     /* external_declaration  */
  YYSYMBOL_function_definition = 254,      /* function_definition  */
  YYSYMBOL_255_5 = 255,                    /* $@5  */
  YYSYMBOL_template_type_parameter = 256,  /* template_type_parameter  */
  YYSYMBOL_int_constant_type = 257,        /* int_constant_type  */
  YYSYMBOL_template_int_constant_type = 258, /* template_int_constant_type  */
  YYSYMBOL_template_int_parameter = 259,   /* template_int_parameter  */
  YYSYMBOL_template_enum_parameter = 260,  /* template_enum_parameter  */
  YYSYMBOL_template_parameter = 261,       /* template_parameter  */
  YYSYMBOL_template_parameter_list = 262,  /* template_parameter_list  */
  YYSYMBOL_template_head = 263,            /* template_head  */
  YYSYMBOL_template_declaration = 264,     /* template_declaration  */
  YYSYMBOL_265_6 = 265,                    /* $@6  */
  YYSYMBOL_template_function_declaration_or_definition = 266, /* template_function_declaration_or_definition  */
  YYSYMBOL_template_argument = 267,        /* template_argument  */
  YYSYMBOL_template_argument_list = 268,   /* template_argument_list  */
  YYSYMBOL_template_identifier = 269,      /* template_identifier  */
  YYSYMBOL_simple_template_id = 270,       /* simple_template_id  */
  YYSYMBOL_template_function_instantiation = 271, /* template_function_instantiation  */
  YYSYMBOL_template_function_specialization_declaration = 272, /* template_function_specialization_declaration  */
  YYSYMBOL_template_function_specialization = 273 /* template_function_specialization  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  98
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   5454

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  141
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  133
/* YYNRULES -- Number of rules.  */
#define YYNRULES  442
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  806

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   371


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   130,     2,     2,     2,   132,   125,     2,
     117,   118,   126,   127,   121,   128,   124,   131,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   136,   138,
     122,   137,   123,   135,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   119,     2,   120,   133,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   139,   134,   140,   129,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   449,   449,   454,   467,   487,   491,   495,   499,   503,
     507,   511,   515,   519,   528,   533,   538,   541,   544,   549,
     550,   554,   560,   567,   573,   580,   586,   592,   598,   605,
     610,   615,   620,   627,   633,   639,   645,   654,   658,   662,
     667,   668,   670,   672,   673,   680,   685,   690,   697,   702,
     707,   709,   714,   721,   734,   750,   751,   753,   755,   757,
     779,   801,   811,   812,   826,   827,   828,   829,   831,   833,
     835,   837,   839,   841,   843,   845,   847,   849,   856,   857,
     864,   865,   867,   869,   874,   875,   877,   882,   883,   885,
     890,   891,   893,   895,   897,   902,   903,   905,   910,   911,
     916,   917,   922,   923,   928,   929,   934,   935,   940,   941,
     946,   947,   948,   952,   953,   964,   975,   999,  1000,  1004,
    1008,  1015,  1016,  1018,  1020,  1022,  1024,  1026,  1028,  1030,
    1032,  1034,  1036,  1038,  1059,  1060,  1065,  1069,  1095,  1115,
    1125,  1130,  1141,  1148,  1160,  1168,  1173,  1188,  1197,  1210,
    1216,  1227,  1231,  1237,  1250,  1271,  1275,  1282,  1292,  1305,
    1312,  1320,  1331,  1338,  1350,  1354,  1364,  1371,  1385,  1386,
    1395,  1396,  1397,  1398,  1399,  1403,  1404,  1410,  1411,  1415,
    1426,  1437,  1438,  1439,  1440,  1441,  1442,  1443,  1444,  1445,
    1446,  1447,  1448,  1449,  1453,  1457,  1466,  1471,  1479,  1503,
    1509,  1521,  1535,  1545,  1557,  1561,  1567,  1573,  1584,  1588,
    1595,  1609,  1614,  1615,  1616,  1617,  1703,  1710,  1724,  1732,
    1740,  1746,  1755,  1761,  1770,  1795,  1805,  1819,  1825,  1853,
    1854,  1855,  1856,  1857,  1858,  1859,  1860,  1861,  1862,  1863,
    1864,  1868,  1872,  1879,  1891,  1903,  1907,  1908,  1909,  1910,
    1911,  1912,  1913,  1914,  1918,  1927,  1934,  1938,  1969,  1980,
    1984,  1999,  2009,  2017,  2021,  2027,  2033,  2044,  2052,  2056,
    2063,  2072,  2080,  2084,  2093,  2100,  2117,  2118,  2130,  2134,
    2135,  2145,  2149,  2162,  2164,  2170,  2199,  2210,  2241,  2243,
    2253,  2263,  2281,  2282,  2283,  2287,  2289,  2303,  2310,  2320,
    2324,  2325,  2326,  2327,  2328,  2329,  2330,  2331,  2332,  2333,
    2334,  2335,  2336,  2344,  2350,  2368,  2373,  2377,  2381,  2382,
    2386,  2392,  2405,  2406,  2410,  2412,  2414,  2416,  2418,  2423,
    2425,  2430,  2431,  2435,  2439,  2443,  2447,  2451,  2459,  2463,
    2471,  2475,  2479,  2483,  2490,  2494,  2501,  2506,  2520,  2524,
    2532,  2534,  2536,  2538,  2540,  2544,  2548,  2552,  2557,  2556,
    2592,  2591,  2628,  2627,  2639,  2637,  2661,  2669,  2675,  2677,
    2679,  2681,  2686,  2691,  2698,  2705,  2711,  2720,  2729,  2730,
    2731,  2735,  2736,  2737,  2738,  2739,  2740,  2741,  2746,  2752,
    2757,  2756,  2794,  2799,  2809,  2810,  2811,  2812,  2813,  2814,
    2815,  2816,  2817,  2821,  2822,  2826,  2831,  2841,  2854,  2860,
    2866,  2875,  2883,  2898,  2906,  2905,  2932,  2939,  2955,  2962,
    2966,  2970,  2974,  2978,  2982,  2986,  2990,  2994,  2997,  3001,
    3022,  3031,  3042,  3050,  3062,  3079,  3105,  3126,  3136,  3158,
    3172,  3182,  3191
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOKEN_INT8_CONSTANT",
  "TOKEN_UINT8_CONSTANT", "TOKEN_INT16_CONSTANT", "TOKEN_UINT16_CONSTANT",
  "TOKEN_INT32_CONSTANT", "TOKEN_UINT32_CONSTANT", "TOKEN_INT64_CONSTANT",
  "TOKEN_UINT64_CONSTANT", "TOKEN_INT32DOTDOTDOT_CONSTANT",
  "TOKEN_UINT32DOTDOTDOT_CONSTANT", "TOKEN_INT64DOTDOTDOT_CONSTANT",
  "TOKEN_UINT64DOTDOTDOT_CONSTANT", "TOKEN_FLOAT16_CONSTANT",
  "TOKEN_FLOAT_CONSTANT", "TOKEN_DOUBLE_CONSTANT",
  "TOKEN_STRING_C_LITERAL", "TOKEN_STRING_SYCL_LITERAL",
  "TOKEN_IDENTIFIER", "TOKEN_STRING_LITERAL", "TOKEN_TYPE_NAME",
  "TOKEN_PRAGMA", "TOKEN_NULL", "TOKEN_TEMPLATE_NAME", "TOKEN_TEMPLATE",
  "TOKEN_TYPENAME", "TOKEN_PTR_OP", "TOKEN_INC_OP", "TOKEN_DEC_OP",
  "TOKEN_LEFT_OP", "TOKEN_RIGHT_OP", "TOKEN_LE_OP", "TOKEN_GE_OP",
  "TOKEN_EQ_OP", "TOKEN_NE_OP", "TOKEN_AND_OP", "TOKEN_OR_OP",
  "TOKEN_MUL_ASSIGN", "TOKEN_DIV_ASSIGN", "TOKEN_MOD_ASSIGN",
  "TOKEN_ADD_ASSIGN", "TOKEN_SUB_ASSIGN", "TOKEN_LEFT_ASSIGN",
  "TOKEN_RIGHT_ASSIGN", "TOKEN_AND_ASSIGN", "TOKEN_OR_ASSIGN",
  "TOKEN_XOR_ASSIGN", "TOKEN_SIZEOF", "TOKEN_NEW", "TOKEN_DELETE",
  "TOKEN_IN", "TOKEN_ALLOCA", "TOKEN_INTRINSIC_CALL", "TOKEN_EXTERN",
  "TOKEN_EXPORT", "TOKEN_STATIC", "TOKEN_INLINE", "TOKEN_NOINLINE",
  "TOKEN_VECTORCALL", "TOKEN_REGCALL", "TOKEN_TASK", "TOKEN_DECLSPEC",
  "TOKEN_UNIFORM", "TOKEN_VARYING", "TOKEN_TYPEDEF", "TOKEN_SOA",
  "TOKEN_UNMASKED", "TOKEN_INT", "TOKEN_SIGNED", "TOKEN_UNSIGNED",
  "TOKEN_FLOAT16", "TOKEN_FLOAT", "TOKEN_DOUBLE", "TOKEN_INT8",
  "TOKEN_INT16", "TOKEN_INT64", "TOKEN_CONST", "TOKEN_VOID", "TOKEN_BOOL",
  "TOKEN_UINT8", "TOKEN_UINT16", "TOKEN_UINT", "TOKEN_UINT64",
  "TOKEN_ENUM", "TOKEN_STRUCT", "TOKEN_TRUE", "TOKEN_FALSE", "TOKEN_CASE",
  "TOKEN_DEFAULT", "TOKEN_IF", "TOKEN_ELSE", "TOKEN_SWITCH", "TOKEN_WHILE",
  "TOKEN_DO", "TOKEN_LAUNCH", "TOKEN_FOREACH", "TOKEN_FOREACH_TILED",
  "TOKEN_FOREACH_UNIQUE", "TOKEN_FOREACH_ACTIVE", "TOKEN_DOTDOTDOT",
  "TOKEN_FOR", "TOKEN_GOTO", "TOKEN_CONTINUE", "TOKEN_BREAK",
  "TOKEN_RETURN", "TOKEN_CIF", "TOKEN_CDO", "TOKEN_CFOR", "TOKEN_CWHILE",
  "TOKEN_SYNC", "TOKEN_PRINT", "TOKEN_ASSERT", "TOKEN_INVOKE_SYCL",
  "TOKEN_ATTRIBUTE", "STRUCT_WITHOUT_ATTRIBUTE", "'('", "')'", "'['",
  "']'", "','", "'<'", "'>'", "'.'", "'&'", "'*'", "'+'", "'-'", "'~'",
  "'!'", "'/'", "'%'", "'^'", "'|'", "'?'", "':'", "'='", "';'", "'{'",
  "'}'", "$accept", "string_constant", "primary_expression",
  "launch_expression", "invoke_sycl_expression", "postfix_expression",
  "intrinsic_name", "intrincall_expression", "funcall_expression",
  "argument_expression_list", "unary_expression", "cast_expression",
  "multiplicative_expression", "additive_expression", "shift_expression",
  "relational_expression", "equality_expression", "and_expression",
  "exclusive_or_expression", "inclusive_or_expression",
  "logical_and_expression", "logical_or_expression",
  "conditional_expression", "rate_qualified_new",
  "rate_qualified_type_specifier", "new_expression",
  "assignment_expression", "expression", "constant_expression",
  "declaration_statement", "declaration", "soa_width_specifier",
  "declspec_item", "declspec_list", "declspec_specifier",
  "declaration_specifiers", "attribute_specifier", "attribute_list",
  "attribute", "attribute_argument", "init_declarator_list",
  "init_declarator", "storage_class_specifier", "type_specifier",
  "type_specifier_list", "atomic_var_type_specifier",
  "short_vec_specifier", "struct_or_union_name",
  "struct_or_union_and_name", "struct_or_union_specifier",
  "struct_or_union", "struct_declaration_list", "struct_declaration",
  "specifier_qualifier_list", "struct_declarator_list",
  "struct_declarator", "enum_identifier", "enum_specifier",
  "enumerator_list", "enumerator", "type_qualifier", "type_qualifier_list",
  "declarator", "int_constant", "direct_declarator", "pointer",
  "reference", "parameter_type_list", "parameter_list",
  "parameter_declaration", "type_name", "abstract_declarator",
  "direct_abstract_declarator", "initializer", "initializer_list",
  "pragma", "attributed_statement", "statement", "labeled_statement",
  "start_scope", "end_scope", "compound_statement", "statement_list",
  "expression_statement", "selection_statement", "for_test",
  "for_init_statement", "for_scope", "cfor_scope", "foreach_scope",
  "foreach_tiled_scope", "foreach_identifier", "foreach_active_scope",
  "foreach_active_identifier", "integer_dotdotdot",
  "foreach_dimension_specifier", "foreach_dimension_list",
  "foreach_unique_scope", "foreach_unique_identifier",
  "iteration_statement", "$@1", "$@2", "$@3", "$@4", "goto_identifier",
  "jump_statement", "sync_statement", "delete_statement",
  "unmasked_statement", "print_statement", "assert_statement",
  "translation_unit", "external_declaration", "function_definition", "$@5",
  "template_type_parameter", "int_constant_type",
  "template_int_constant_type", "template_int_parameter",
  "template_enum_parameter", "template_parameter",
  "template_parameter_list", "template_head", "template_declaration",
  "$@6", "template_function_declaration_or_definition",
  "template_argument", "template_argument_list", "template_identifier",
  "simple_template_id", "template_function_instantiation",
  "template_function_specialization_declaration",
  "template_function_specialization", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-430)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-435)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1248,   -59,  -430,  5138,   192,   -56,  -430,  -430,  -430,  -430,
    -430,  -430,   -25,  -430,  -430,  -430,   -16,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,     2,  -430,     3,  -430,  -430,  5303,
    5303,    48,  5303,  5303,  5206,  -430,    11,  -430,    -1,  -430,
    5303,   613,  -430,  -430,  -430,    98,  -430,  -430,   150,  -430,
    -430,   281,  -430,    34,   141,    30,    40,   812,   135,   818,
    -430,   168,    56,    87,  -430,  -430,  -430,  -430,    82,  -430,
     674,  -430,   -89,  -430,   136,   231,    42,    42,  -430,  -430,
     275,  -430,  4594,  -430,  -430,  4625,  -430,  -430,  -430,  -430,
    5303,  -430,    86,  1133,  -430,  -430,  -430,  -430,  -430,   248,
     257,   722,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  5303,  -430,  -430,   289,  -430,  -430,  -430,   328,  -430,
     183,   247,  5303,  5303,  -430,   -58,  -430,  -430,   -13,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,   190,   157,   -49,
    -430,   168,   396,   308,  -430,   674,  -430,    82,  -430,  1404,
     282,  4815,  2401,   231,   231,   307,   314,   355,  5271,  -430,
    4698,  -430,    82,  5368,   355,  4729,    82,  -430,   340,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
     351,  -430,  -430,  4179,  4179,  4307,  -430,  3947,   374,  -430,
     445,   480,   377,  -430,  -430,  4359,   389,   458,   470,   472,
    1133,   698,  -430,  -430,  -430,  -430,  -430,   523,   460,   464,
    1668,   483,  1133,  -430,   487,   476,   499,   519,   521,  1873,
    4179,  4179,  4359,  4359,  4359,  4359,  -430,  -430,  -430,  -430,
     203,   526,  -430,  -430,   177,  -430,   130,   196,   304,   194,
     322,   495,   516,   566,   675,   -10,  -430,   694,  -430,  -430,
     -51,  -430,  -430,    48,  1133,  -430,  -430,  -430,  -430,   853,
    -430,  -430,   594,   600,   603,   604,   606,   607,  -430,   583,
    -430,  -430,  -430,  -430,  -430,  -430,   -75,   608,  -430,   589,
    -430,   141,   592,   768,  -430,  5162,  4901,   591,   597,   812,
     605,  -430,   135,  -430,  4359,    -5,  -430,   -46,   623,     9,
    -430,  -430,  -430,  -430,  -430,   609,  -430,   445,   480,  1404,
    -430,  -430,  -430,    16,  -430,    51,   629,   620,  -430,   628,
    -430,  -430,  -430,   630,  -430,  -430,  -430,   624,  -430,   355,
    -430,   -43,  -430,  -430,  -430,  -430,   355,  -430,  -430,  2263,
    -430,  -430,  1873,  -430,    -2,  3947,  -430,  -430,  1133,   617,
    1133,  3947,  3947,  3947,   662,  3947,  2068,   230,  -430,   619,
    -430,  -430,  -430,    25,  3947,   666,  3947,  -430,   741,   741,
     336,   646,    64,   285,   647,  -430,  -430,  -430,  -430,  -430,
    -430,   286,  -430,  -430,  2003,  2332,   372,  2539,  3947,  3947,
    3947,  3947,  3947,  3947,  3947,  3947,  3947,  3947,  3947,  4359,
    4359,  4359,  4359,  4359,  4359,  4359,  4359,  4359,  4359,  4359,
    4359,  4359,  4359,  4359,  4359,  4359,  4359,  3947,   812,   812,
     246,   812,  -430,  3947,  -430,  -430,  -430,  -430,  -430,  1532,
    1532,   761,   761,   762,   763,  1133,  2133,   812,   667,   818,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,   426,   134,   649,   670,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,     0,  -430,   602,   671,
     396,  -430,   -44,  -430,  -430,  4437,  3999,   655,    61,    61,
    -430,   462,  -430,  5303,  -430,  -430,   673,   678,  -430,    82,
    -430,  -430,   690,  -430,   691,   993,  1133,  -430,   180,   200,
     207,   676,   280,   242,  2667,  -430,  -430,   297,   693,   310,
    -430,    27,    37,   695,   172,  -430,  -430,  4523,   466,   466,
    -430,  4359,  -430,  -430,  -430,   700,  -430,   323,  -430,   692,
     442,  -430,  -430,  -430,  -430,   329,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,
     130,   130,   196,   196,   304,   304,   304,   304,   194,   194,
     322,   495,   516,   566,   675,   -24,  -430,  -430,  1404,  3947,
    -430,  -430,  -430,  -430,  1737,  1737,  -430,   679,  -430,   343,
     367,  -430,   711,  -430,   759,  -430,   712,  -430,   384,  -430,
    4987,  -430,  5162,  -430,   701,  -430,   702,  -430,   810,   715,
    -430,  -430,  -430,  1335,  -430,   717,  -430,   723,   728,  -430,
     727,  1404,   462,   462,  5073,  4127,  -430,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  1133,  1133,  1133,  3947,  1274,  3947,
    2795,  -430,   386,  1133,  3947,  1133,  -430,   726,  3947,  3947,
    -430,  -430,  3947,  -430,  -430,  -430,  3947,  -430,  -430,  -430,
    4359,   388,   520,  -430,   113,  2923,  3051,  2470,  -430,   761,
    -430,  -430,  3947,  -430,  -430,   392,  -430,   735,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,  -430,   737,
    -430,   745,   775,  -430,  -430,   393,  3947,  2068,   274,   525,
     748,   397,  -430,   780,   399,  -430,  -430,   403,   405,   418,
    -430,  -430,  -430,  1404,  -430,  -430,  1133,   420,  1133,   430,
    -430,  -430,  -430,  -430,   773,  3947,  1133,  -430,  1133,  1133,
     437,  -430,  -430,  -430,  -430,  1133,   742,   770,   303,  3179,
    2068,  3947,  -430,   756,  1133,   767,   807,   816,  -430,  -430,
    1133,  -430,  1133,  3947,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,  1696,  3307,  -430,   443,   379,   779,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,  1133,  3947,   410,   777,   449,
    -430,  3435,  2068,  -430,   849,  3563,  -430,   848,  -430,   451,
     454,  2068,  -430,   475,  -430,  -430,  3691,   471,  -430,  -430,
     497,  3819,  -430,  -430,   503,  -430
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       0,     0,   176,     0,   171,   234,   174,   235,   236,   237,
     238,   232,     0,   230,   231,   170,     0,   233,   187,   239,
     240,   189,   190,   191,   183,   185,   192,   229,   181,   182,
     184,   186,   188,   193,     0,   208,     0,   389,   388,   149,
     147,     0,   157,   145,   151,   175,   199,   177,     0,   178,
     155,     0,   378,   381,   414,     0,   382,   384,     0,   383,
     380,   171,   234,     0,     0,   172,   173,     0,     0,     0,
     219,     0,   224,     0,   150,   148,   254,   255,     0,   267,
     263,   138,     0,   166,   168,   245,     0,     0,   158,   146,
       0,   154,     0,   196,   197,     0,   198,   156,     1,   379,
       0,   416,   316,     0,   417,   441,   442,   172,   173,     0,
       0,     0,   396,   394,   395,   397,   402,   398,   399,   400,
     401,     0,   408,   404,     0,   409,   410,   411,     0,   432,
     434,     0,     0,     0,   179,     0,   141,   142,     0,   246,
     247,   248,   249,   250,   251,   252,   253,     0,   227,     0,
     225,     0,     0,     0,   241,   264,   265,     0,   139,     0,
       0,     0,     0,   243,   244,     0,     0,   206,   213,   214,
       0,   209,     0,     0,   204,     0,     0,   318,     0,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
       4,   297,    18,     0,     0,     0,   110,     0,     0,    52,
     230,   231,   233,    16,    17,     0,     0,     0,     0,     0,
       0,     0,   335,   336,   348,   338,   333,     0,     0,     0,
       0,     0,     0,   334,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   322,    40,    43,    66,
      55,     0,    65,    64,    78,    80,    84,    87,    90,    95,
      98,   100,   102,   104,   106,   108,   117,     0,   121,   134,
       0,   306,   137,     0,     0,   320,   299,   300,   301,     0,
     302,   303,     0,     0,     0,     0,     0,     0,   304,     0,
     305,   309,   310,   311,   307,   308,   133,     0,   407,   392,
     403,     0,   405,     0,   413,     0,     0,     0,     0,     0,
       0,   144,     0,   140,     0,     0,   220,     0,   162,     0,
     160,   256,   242,   266,   167,   168,     4,     0,     0,     0,
     292,   169,   391,     0,   261,   275,     0,   268,   269,     0,
     258,    78,   136,     0,   153,   152,   207,     0,   212,   200,
     210,     0,   216,   218,   215,   205,   202,   415,   312,     0,
      67,    68,     0,    75,     0,     0,   111,   112,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   366,     0,
     368,   369,   370,     0,     0,     0,     0,   372,     0,     0,
       0,     0,     0,   276,     0,    69,    70,    71,    72,    73,
      74,     0,    50,    51,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     118,     0,   113,     0,   323,   298,   317,   321,   319,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     412,   419,   420,   421,   422,   423,   424,   425,   426,   429,
     427,   428,   418,   430,     0,     0,     0,     0,   385,   386,
     180,   387,   143,   228,   222,   226,     0,   221,     0,     0,
       0,   295,     0,   262,   271,     0,     0,   272,   278,   281,
     274,   279,   260,     0,   259,   257,     0,     0,   201,     0,
     211,   203,     0,   373,     0,     0,     0,   315,     0,     0,
       0,     0,     0,     0,     0,   367,   371,     0,     0,     0,
       2,     0,     0,     0,     0,    20,    19,     0,   278,   281,
     277,     0,    47,    48,    49,     0,    56,     0,    62,     0,
       0,    44,    45,    46,    53,     0,   123,   124,   125,   126,
     127,   128,   129,   130,   132,   131,   122,    81,    82,    83,
      85,    86,    88,    89,    93,    94,    91,    92,    96,    97,
      99,   101,   103,   105,   107,     0,   114,   115,     0,     0,
     116,   135,   332,   331,     0,     0,   337,     0,   346,     0,
       0,   339,     0,   349,     0,   313,     0,    59,     0,   393,
       0,   406,     0,   433,     0,   436,     0,   223,   165,     0,
     164,   159,   161,     0,   293,     0,   288,     0,     0,   284,
       0,     0,   280,   282,     0,     0,   270,   195,   194,   217,
      76,    77,   374,   314,     0,     0,     0,     0,     0,     0,
       0,    22,     0,     0,     0,     0,     3,     0,     0,     0,
      39,    37,     0,    79,    58,    57,     0,    42,    41,    54,
       0,     0,     0,   329,     0,     0,     0,     0,   358,     0,
     360,   362,     0,    61,    60,     0,   439,     0,   431,   437,
     435,   163,   294,   296,   289,   283,   285,   273,   290,     0,
     286,     0,   324,   328,   350,     0,     0,     0,     0,     0,
       0,     0,    21,   326,     0,   351,   375,     0,     0,     0,
      63,   109,   119,     0,   120,   330,     0,     0,     0,     0,
     340,   341,   342,   343,     0,     0,     0,   347,     0,     0,
       0,   440,   438,   291,   287,     0,     0,     0,     0,     0,
       0,     0,    34,     0,     0,     0,     0,     0,    38,   354,
       0,   356,     0,     0,   345,   359,   361,   363,   364,   325,
     352,     0,     0,    24,     0,     0,     0,    33,   327,   353,
     376,   377,   355,   357,   344,     0,     0,     0,     0,     0,
      23,     0,     0,   365,     0,     0,    36,     0,    26,     0,
       0,     0,    28,     0,    35,    25,     0,     0,    27,    30,
       0,     0,    29,    32,     0,    31
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -430,  -355,  -430,  -430,  -430,  -205,  -430,  -430,  -430,  -333,
     241,  -197,   -17,    28,  -152,   171,   550,   551,   549,   552,
     558,  -430,  -148,  -430,   718,  -430,  -159,   170,  -200,   208,
      39,  -240,   683,  -430,  -430,     1,  -141,  -430,   496,  -430,
    -430,   829,  -430,   -42,  -430,  -430,  -430,  -430,  -430,  -430,
    -430,   892,   -90,  -155,  -430,   489,   955,  -430,   839,  -293,
     -26,  -430,   -33,   -61,   -76,   -71,  -318,  -145,  -430,   502,
     652,  -294,  -429,  -156,   427,  -430,  -176,  -430,  -430,  -430,
    -430,   -28,   648,   270,  -430,   422,   571,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,  -430,   345,   570,  -430,  -430,  -430,
    -430,  -430,  -430,  -430,   802,  -430,  -430,  -430,  -430,  -430,
    -430,  -430,   969,  -430,  -430,  -430,   910,  -430,  -430,  -430,
     731,  -430,  -430,  -430,  -430,  -430,   423,  -430,   -41,   -62,
    -430,  -430,  -430
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,   521,   237,   238,   239,   240,   241,   242,   243,   537,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   462,   258,   259,   260,   333,   261,
     262,    39,   137,   138,    40,   263,    42,   309,   310,   609,
      82,    83,    43,    44,   135,    45,   169,    96,    46,    47,
      48,   170,   171,   172,   341,   342,   148,    49,   149,   150,
      50,   155,   153,   147,    85,    86,    87,   617,   327,   328,
     384,   618,   491,   481,   482,   264,   265,   266,   267,   103,
     438,   268,   269,   270,   271,   665,   584,   272,   273,   274,
     275,   587,   276,   592,   725,   588,   589,   277,   594,   278,
     726,   728,   729,   775,   279,   280,   281,   282,   283,   284,
     285,    51,    52,    53,   160,   122,   123,   124,   125,   126,
     127,   128,    54,    55,   100,    56,   463,   464,   286,   287,
      57,    58,    59
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     320,    41,   131,   321,    64,   359,   367,   489,    84,   156,
     163,   164,   475,   338,   332,    70,   326,   431,   344,    93,
      70,    94,    70,   130,   522,   134,   336,   104,   426,   166,
     106,   490,   157,   345,   364,   387,   388,   389,   390,    38,
      74,    75,  -434,    88,    89,    91,   375,   295,   646,   158,
     168,    97,    41,   168,   154,   431,   109,   332,   646,   622,
     623,   110,    76,   299,   545,   529,   173,    77,    76,   173,
     433,    76,   305,    77,   383,   476,    77,   613,   499,    60,
     340,    76,   300,    67,   313,   340,    77,   434,   435,   530,
      38,   306,    68,   437,   477,   500,   614,   433,   111,   622,
     623,   176,    76,   112,   473,   301,    69,    77,   302,   113,
     114,   115,   660,   598,   116,   117,   118,   119,   120,   433,
      73,   130,   291,   608,   315,   427,   168,   479,   168,   312,
     480,   168,   322,   168,   483,   474,   503,   484,    95,   343,
     607,    71,   173,   347,   173,   647,   433,   173,   648,   173,
      92,   467,   130,   130,   130,   136,   332,   121,   649,    78,
     320,   513,   325,   516,   130,    78,   129,   489,   485,   132,
     486,   297,   298,    79,    80,   524,    79,    80,   485,   133,
     486,   642,   526,   475,   507,   433,    81,   168,    70,   130,
     130,   130,   130,   130,   130,   151,   504,   383,   498,    78,
     391,   392,   393,   173,   152,   501,   512,    79,    80,   529,
      65,    66,   557,   558,   559,   432,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   177,   416,   417,   448,
     315,   391,   392,   393,   433,   538,   101,   102,   538,   546,
     547,   548,   549,   550,   551,   552,   553,   554,   555,   556,
     130,   715,   604,   432,   488,   484,   409,   470,   391,   392,
     393,   410,   411,   130,   564,   565,   566,   567,   288,   595,
     391,   392,   393,   159,   581,  -390,   497,   289,   139,   140,
     141,   142,   143,   144,   145,   146,   620,   538,   105,   102,
     651,   395,   487,   652,   304,   165,   396,   325,   634,   107,
     108,   433,   391,   392,   393,   295,   532,   701,   533,   292,
     168,   534,   528,   303,   408,   707,   418,   419,   635,   709,
     394,   433,   395,   412,   413,   636,   173,   396,   433,   437,
     633,   391,   392,   393,   653,   414,   415,   523,   332,   179,
     180,   181,   182,   183,   184,   185,   186,   514,   161,   395,
     162,   187,   188,   189,   396,   538,   316,   420,   421,   640,
     192,   395,   431,   578,   296,   579,   396,   354,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   576,   577,   601,   580,
     373,   739,   541,   395,   542,   560,   561,   543,   396,   382,
     638,   639,   527,   331,   486,   599,   764,   391,   392,   393,
      79,    80,   163,   164,   488,   643,   308,   610,   433,   320,
     762,   102,   395,   203,   204,   691,   311,   396,   645,   779,
     334,   433,   211,   698,   350,   351,   353,   335,   391,   392,
     393,   655,   562,   563,   656,   130,   331,   659,   789,   293,
     656,   294,   793,   349,   320,   677,   528,   683,   692,   693,
     694,   668,   320,   800,   669,   687,   343,   703,   804,   705,
      36,   385,   386,   331,   331,   331,   331,   332,   348,   689,
     699,   538,   391,   392,   393,   670,   325,  -366,   669,   538,
     130,   355,   738,   538,   325,   356,   781,   710,   395,   391,
     392,   393,   674,   396,   702,   656,   712,   656,   724,   713,
     731,   736,   711,   484,   433,   743,   358,   745,   656,   382,
     433,   746,   382,   747,   656,   360,   433,   785,   325,   395,
     357,   508,   509,   510,   396,   765,   748,   737,   750,   656,
     749,   433,   751,   368,   517,   331,   519,   602,   752,   603,
     755,   433,   756,   757,   320,   758,   777,   683,   433,   759,
     432,   780,   658,   433,   656,   540,   754,   787,   768,   795,
     656,   796,   656,   395,   772,   361,   773,   790,   396,   624,
     538,   625,   766,   527,   130,   486,   797,   362,   801,   363,
     395,   568,   569,   798,   774,   396,   656,   575,   370,   783,
     374,   325,   371,   538,   376,   139,   140,   141,   142,   143,
     144,   145,   146,    98,   377,   802,   378,   784,   656,   130,
     422,   805,   538,   520,   656,   325,   538,   139,   140,   141,
     142,   143,   144,   145,   146,     2,   379,   538,   380,     3,
     714,   433,   538,   397,   496,   740,   741,   582,   582,   423,
     331,   331,   331,   331,   331,   331,   331,   331,   331,   331,
     331,   331,   331,   331,   331,   331,   331,   331,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
     424,   179,   180,   181,   182,   183,   184,   185,   186,   583,
     583,   439,   425,   187,   188,   189,     2,   440,   316,   445,
     441,   442,   192,   443,   444,   446,   447,   331,    36,   449,
      62,   468,     7,     8,     9,    10,    11,   469,    13,    14,
     478,   493,    17,   471,    19,    20,   159,   492,   494,   662,
     495,    37,    27,   506,   664,   664,   511,   515,   428,   429,
     518,    16,   520,    18,   525,   531,    21,    22,    23,    24,
      25,    26,   331,    28,    29,    30,    31,    32,    33,    34,
      35,   586,   591,   593,   600,   203,   204,   605,   606,   611,
     109,   112,   621,   637,   211,   110,   627,   113,   114,   115,
      80,   628,   116,   117,   118,   119,   120,   695,   630,   631,
     644,   672,   657,   650,   704,   349,   667,   365,   654,   708,
     366,   139,   140,   141,   142,   143,   144,   145,   146,   671,
     673,   646,   111,   681,     2,   717,   719,   112,   484,   679,
     680,   684,   730,   113,   114,   115,   685,   686,   116,   117,
     118,   119,   120,   732,   178,   733,   179,   180,   181,   182,
     183,   184,   185,   186,   706,   734,   331,   735,   187,   188,
     189,   742,   744,   190,   753,     2,   191,   192,   129,   767,
     760,    18,   193,   194,    21,    22,    23,    24,    25,    26,
     761,    28,    29,    30,    31,    32,    33,    34,    35,   782,
     786,   331,   195,   196,   197,   769,   198,   199,    61,    62,
       6,     7,     8,     9,    10,    11,    12,   200,   201,    15,
      16,   202,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
     203,   204,   205,   206,   207,   770,   208,   209,   210,   211,
     212,   213,   214,   215,   771,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,    36,   791,
     229,   794,   570,   572,   571,   430,   612,   573,   230,   231,
     232,   233,   234,   235,   574,   472,   314,   175,   629,    72,
     307,   236,   102,   436,   178,   626,   179,   180,   181,   182,
     183,   184,   185,   186,   502,   661,   505,   666,   187,   188,
     189,   585,   590,   190,   727,     2,   191,   192,   129,   369,
      99,   290,   193,   194,   450,   678,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   195,   196,   197,     0,   198,   199,    61,    62,
       6,     7,     8,     9,    10,    11,    12,   200,   201,    15,
      16,   202,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
     203,   204,   205,   206,   207,     0,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,    36,     0,
     229,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       0,   236,   102,   632,   178,     0,   179,   180,   181,   182,
     183,   184,   185,   186,     0,     0,     0,     0,   187,   188,
     189,     0,     0,   190,     0,     2,   191,   192,   129,     0,
       0,     0,   193,   194,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   195,   196,   197,     0,   198,   199,    61,    62,
       6,     7,     8,     9,    10,    11,    12,   200,   201,    15,
      16,   202,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
     203,   204,   205,   206,   207,     0,   208,   209,   210,   211,
     212,   213,   214,   215,     0,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,    36,     1,
     229,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,     0,     0,     0,     0,     0,     0,
       2,   236,   102,     0,     3,     0,     0,   179,   180,   181,
     182,   183,   184,   185,   186,     0,     0,     0,     0,   187,
     188,   189,     0,     0,   316,     0,     0,     0,   192,     0,
       0,     0,     0,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,     0,     0,     0,   179,   180,
     181,   182,   183,   184,   185,   186,     0,     0,     0,     0,
     187,   188,   189,     0,     0,   316,     0,     0,     0,   192,
     129,   203,   204,    36,   193,   194,     0,     0,     0,     0,
     211,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   195,   196,    37,     0,   198,   199,
       0,   349,     0,   696,     0,     0,   697,     0,     0,   317,
     318,     0,     0,     0,     0,     0,     0,   179,   180,   181,
     182,   183,   184,   185,   186,     0,     0,     0,     0,   187,
     188,   189,   203,   204,   316,     0,     0,     0,   192,   129,
       0,   211,     0,   193,   194,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   228,
       0,     0,   229,   195,   196,     0,     0,   198,   199,     0,
     230,   231,   232,   233,   234,   235,     0,     0,   317,   318,
       0,     0,     0,     0,   319,   682,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,     0,     0,     0,     0,     0,     0,
     211,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   228,     0,
       0,   229,     0,     0,     0,     0,     0,     0,     0,   230,
     231,   232,   233,   234,   235,   179,   180,   181,   182,   183,
     184,   185,   186,   319,     0,     0,     0,   187,   188,   189,
       0,     0,   316,     0,     2,     0,   192,   129,     0,     0,
       0,   193,   194,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   195,   196,     0,     0,   198,   199,    61,    62,     6,
       7,     8,     9,    10,    11,    12,   200,   201,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,   203,
     204,     0,     0,     0,     0,     0,     0,     0,   211,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   228,    36,     0,   229,
       0,     0,     0,     0,     0,     0,     0,   230,   231,   232,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
     236,   179,   180,   181,   182,   183,   184,   185,   186,     0,
       0,     0,     0,   187,   188,   189,     0,     0,   316,     0,
       0,     0,   192,   129,     0,     0,     0,   193,   194,   179,
     180,   181,   182,   183,   184,   185,   186,     0,     0,     0,
       0,   187,   188,   189,     0,     0,   316,   195,   196,     0,
     192,   198,   199,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   317,   318,     0,     0,     0,     0,     0,     0,
     179,   180,   181,   182,   183,   184,   185,   186,     0,     0,
       0,     0,   187,   188,   189,   203,   204,   316,     0,     0,
       0,   192,   129,     0,   211,     0,   193,   194,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   228,   203,   204,   229,   195,   196,     0,     0,
     198,   199,   211,   230,   231,   232,   233,   234,   235,     0,
       0,   317,   318,     0,     0,     0,   372,     0,     0,     0,
       0,     0,     0,   349,     0,   776,     0,     0,     0,     0,
       0,     0,     0,     0,   203,   204,     0,     0,     0,     0,
       0,     0,     0,   211,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   228,     0,     0,   229,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,     0,     0,
       0,     0,     0,     0,   381,   663,   179,   180,   181,   182,
     183,   184,   185,   186,     0,     0,     0,     0,   187,   188,
     189,     0,     0,   316,     0,     2,     0,   192,   129,     0,
       0,     0,   193,   194,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   195,   196,     0,     0,   198,   199,     0,    62,
       0,     7,     8,     9,    10,    11,     0,   200,   201,     0,
       0,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
     203,   204,     0,     0,     0,     0,     0,     0,     0,   211,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   228,     0,     0,
     229,     0,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   535,     0,   179,   180,   181,   182,
     183,   184,   185,   186,     0,     0,     0,     0,   187,   188,
     189,     0,     0,   316,     0,     0,     0,   192,   129,     0,
       0,     0,   193,   194,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   195,   196,     0,     0,   198,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   317,   318,     0,
       0,   179,   180,   181,   182,   183,   184,   185,   186,     0,
       0,     0,     0,   187,   188,   189,     0,     0,   316,     0,
     203,   204,   192,     0,     0,     0,     0,     0,     0,   211,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   228,     0,     0,
     229,   536,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   596,     0,   179,   180,   181,   182,
     183,   184,   185,   186,     0,     0,     0,     0,   187,   188,
     189,     0,     0,   316,     0,   203,   204,   192,   129,     0,
       0,     0,   193,   194,   211,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   195,   196,     0,   349,   198,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   317,   318,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     203,   204,     0,     0,     0,     0,     0,     0,     0,   211,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   228,     0,     0,
     229,   597,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   381,     0,   179,   180,   181,   182,
     183,   184,   185,   186,     0,     0,     0,     0,   187,   188,
     189,     0,     0,   316,     0,     0,     0,   192,   129,     0,
       0,     0,   193,   194,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   195,   196,     0,     0,   198,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   317,   318,     0,
       0,     0,     0,   539,     0,   179,   180,   181,   182,   183,
     184,   185,   186,     0,     0,     0,     0,   187,   188,   189,
     203,   204,   316,     0,     0,     0,   192,   129,     0,   211,
       0,   193,   194,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   228,     0,     0,
     229,   195,   196,     0,     0,   198,   199,     0,   230,   231,
     232,   233,   234,   235,     0,     0,   317,   318,     0,     0,
       0,     0,   329,     0,   179,   180,   181,   182,   183,   184,
     185,   186,     0,     0,     0,     0,   187,   188,   189,   203,
     204,   316,     0,     0,     0,   192,   129,     0,   211,     0,
     193,   194,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   228,     0,     0,   229,
     195,     0,     0,     0,   198,   199,     0,   230,   231,   232,
     233,   234,   235,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   179,   180,   181,   182,   183,   184,   185,
     186,   720,   721,   722,   723,   187,   188,   189,   203,   204,
     316,     0,     0,     0,   192,   129,     0,   211,     0,   193,
     194,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   228,     0,     0,   229,   195,
     196,   330,     0,   198,   199,     0,   230,   231,   232,   233,
     234,   235,     0,     0,   317,   318,     0,     0,     0,     0,
       0,     0,   179,   180,   181,   182,   183,   184,   185,   186,
       0,     0,     0,     0,   187,   188,   189,   203,   204,   316,
       0,     0,     0,   192,   129,     0,   211,     0,   193,   194,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   228,     0,     0,   229,   195,   196,
       0,     0,   198,   199,     0,   230,   231,   232,   233,   234,
     235,     0,     0,   317,   318,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   203,   204,     0,     0,
       0,     0,     0,     0,     0,   211,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   228,     0,     0,   229,   544,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     179,   180,   181,   182,   183,   184,   185,   186,     0,     0,
       0,     0,   187,   188,   189,     0,     0,   316,     0,     0,
       0,   192,   129,     0,     0,     0,   193,   194,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   195,   196,     0,     0,
     198,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   317,   318,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   203,   204,     0,     0,     0,     0,
       0,     0,     0,   211,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   228,     0,     0,   229,   641,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   179,   180,
     181,   182,   183,   184,   185,   186,     0,     0,     0,     0,
     187,   188,   189,     0,     0,   316,     0,     0,     0,   192,
     129,     0,     0,     0,   193,   194,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   195,   196,     0,     0,   198,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   317,
     318,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   203,   204,     0,     0,     0,     0,     0,     0,
       0,   211,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   228,
       0,     0,   229,   700,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   179,   180,   181,   182,
     183,   184,   185,   186,     0,     0,     0,     0,   187,   188,
     189,     0,     0,   316,     0,     0,     0,   192,   129,     0,
       0,     0,   193,   194,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   195,   196,     0,     0,   198,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   317,   318,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     203,   204,     0,     0,     0,     0,     0,     0,     0,   211,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   228,     0,     0,
     229,   716,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   179,   180,   181,   182,   183,   184,
     185,   186,     0,     0,     0,     0,   187,   188,   189,     0,
       0,   316,     0,     0,     0,   192,   129,     0,     0,     0,
     193,   194,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     195,   196,     0,     0,   198,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   317,   318,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   203,   204,
       0,     0,     0,     0,     0,     0,     0,   211,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   228,     0,     0,   229,   718,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   179,   180,   181,   182,   183,   184,   185,   186,
       0,     0,     0,     0,   187,   188,   189,     0,     0,   316,
       0,     0,     0,   192,   129,     0,     0,     0,   193,   194,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   195,   196,
       0,     0,   198,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   317,   318,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   203,   204,     0,     0,
       0,     0,     0,     0,     0,   211,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   228,     0,     0,   229,   763,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     179,   180,   181,   182,   183,   184,   185,   186,     0,     0,
       0,     0,   187,   188,   189,     0,     0,   316,     0,     0,
       0,   192,   129,     0,     0,     0,   193,   194,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   195,   196,     0,     0,
     198,   199,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   317,   318,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   203,   204,     0,     0,     0,     0,
       0,     0,     0,   211,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   228,     0,     0,   229,   778,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   179,   180,
     181,   182,   183,   184,   185,   186,     0,     0,     0,     0,
     187,   188,   189,     0,     0,   316,     0,     0,     0,   192,
     129,     0,     0,     0,   193,   194,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   195,   196,     0,     0,   198,   199,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   317,
     318,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   203,   204,     0,     0,     0,     0,     0,     0,
       0,   211,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   228,
       0,     0,   229,   788,     0,     0,     0,     0,     0,     0,
     230,   231,   232,   233,   234,   235,   179,   180,   181,   182,
     183,   184,   185,   186,     0,     0,     0,     0,   187,   188,
     189,     0,     0,   316,     0,     0,     0,   192,   129,     0,
       0,     0,   193,   194,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   195,   196,     0,     0,   198,   199,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   317,   318,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     203,   204,     0,     0,     0,     0,     0,     0,     0,   211,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   228,     0,     0,
     229,   792,     0,     0,     0,     0,     0,     0,   230,   231,
     232,   233,   234,   235,   179,   180,   181,   182,   183,   184,
     185,   186,     0,     0,     0,     0,   187,   188,   189,     0,
       0,   316,     0,     0,     0,   192,   129,     0,     0,     0,
     193,   194,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     195,   196,     0,     0,   198,   199,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   317,   318,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   203,   204,
       0,     0,     0,     0,     0,     0,     0,   211,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   228,     0,     0,   229,   799,
       0,     0,     0,     0,     0,     0,   230,   231,   232,   233,
     234,   235,   179,   180,   181,   182,   183,   184,   185,   186,
       0,     0,     0,     0,   187,   188,   189,     0,     0,   316,
       0,     0,     0,   192,   129,     0,     0,     0,   193,   194,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   195,   196,
       0,     0,   198,   199,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   317,   318,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   203,   204,     0,     0,
       0,     0,     0,     0,     0,   211,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   228,     0,     0,   229,   803,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     179,   180,   181,   182,   183,   184,   185,   186,     0,     0,
       0,     0,   187,   188,   189,     0,     0,   316,     0,     0,
       0,   192,   129,     0,     0,     0,   193,   194,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   195,   196,     0,     0,
     198,   199,   179,   180,   181,   182,   183,   184,   185,   186,
       0,   317,   318,     0,   187,   188,   189,     0,     0,   316,
       0,     0,     0,   192,   129,     0,     0,     0,   193,   194,
       0,     0,     0,     0,   203,   204,     0,     0,     0,     0,
       0,     0,     0,   211,     0,     0,     0,     0,   195,     0,
       0,     0,   198,   199,     0,     0,     0,     0,     0,     0,
       0,   228,     0,     0,   229,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,     0,   203,   204,     0,     0,
       0,     0,     0,     0,     0,   211,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   228,     0,     0,   229,     0,     0,   619,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     179,   180,   181,   182,   183,   184,   185,   186,     0,     0,
       0,     0,   187,   188,   189,     0,     0,   316,     0,     0,
       0,   192,   129,     0,     0,     0,   193,   194,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   195,     0,     0,     0,
     198,   199,   179,   180,   181,   182,   183,   184,   185,   186,
       0,     0,     0,     0,   187,   188,   189,     0,     0,   316,
       0,     0,     0,   192,   129,     0,     0,     0,   193,   194,
       0,     0,     0,     0,   203,   204,     0,     0,     0,     0,
       0,     0,     0,   211,     0,     0,     0,     0,   195,     0,
       0,     0,   198,   199,     0,     0,     0,     0,     0,     0,
       0,   228,     0,     0,   229,     0,     0,   690,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,     0,     0,
       0,     0,     0,     0,     0,     0,   203,   204,     0,     0,
       0,     0,     0,     0,     0,   211,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   228,     0,     0,   349,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
     179,   180,   181,   182,   183,   184,   185,   186,     0,     0,
       0,     0,   187,   188,   189,     0,     0,   316,     0,     0,
       0,   192,   129,     0,     0,     0,   193,   194,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   195,     0,     0,     0,
     198,   199,   179,   180,   181,   182,   183,   184,   185,   186,
       0,     0,     0,     0,   187,   188,   189,     0,     0,   316,
       0,     0,     0,   192,   129,     0,     0,     0,   193,   194,
       0,     0,     0,     0,   203,   204,     0,     0,     0,     0,
       0,     0,     0,   211,     0,     0,     0,     0,   195,     0,
       0,     0,   198,   199,     0,     0,     0,     0,     0,     0,
       0,   228,     0,     0,   352,     0,     0,     0,     0,     0,
       0,     0,   230,   231,   232,   233,   234,   235,   615,     0,
       0,     0,     0,     0,     0,     0,   203,   204,     0,     0,
       0,     0,     0,     0,     0,   211,     0,    76,     0,     2,
       0,     0,    77,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   228,     0,     0,   229,     0,     0,     0,
       0,     0,     0,     0,   230,   231,   232,   233,   234,   235,
       0,     0,    61,    62,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,   615,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     2,     0,     0,     0,     0,
       0,     0,    36,     0,   485,   616,   486,     0,     0,     0,
       0,     0,    79,    80,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    61,    62,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
       0,     0,     0,     0,     0,     0,     2,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    36,     0,
     527,   616,   486,     0,     0,     0,     0,     2,    79,    80,
      62,     0,     7,     8,     9,    10,    11,     0,    13,    14,
       0,     0,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    62,     0,     7,     8,     9,    10,    11,     0,    13,
      14,     0,     0,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,     0,     0,     0,     0,     0,     0,     0,     0,
       2,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   167,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     2,     0,     0,    62,     0,     7,     8,     9,    10,
      11,     0,    13,    14,     0,   174,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    62,     0,     7,     8,     9,
      10,    11,     0,    13,    14,     0,     0,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,   323,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     2,   339,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   346,
      61,    62,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,   465,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     2,     0,     0,     0,     0,     0,     0,
      36,     0,     0,   324,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    61,    62,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,   675,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     2,
       0,     0,     0,     0,     0,     0,    36,     0,     0,   466,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    61,    62,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,   615,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     2,     0,     0,     0,     0,
       0,     0,    36,     0,     0,   676,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    61,    62,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
       2,     0,     0,     0,     0,   451,   452,   453,   454,   455,
     456,   457,   458,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   459,     0,     2,     0,     0,     0,    36,     0,
       0,   688,     0,    61,    62,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,     0,   428,   429,     2,    16,
       0,    18,     0,     0,    21,    22,    23,    24,    25,    26,
       0,    28,    29,    30,    31,    32,    33,    34,    35,   460,
     461,     0,     0,    36,     0,     0,     0,     0,     0,     0,
      63,    61,    62,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,     2,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    36,     0,     0,     0,     2,     0,    62,    90,     7,
       8,     9,    10,    11,     0,    13,    14,     0,     0,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    61,    62,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
       2,     0,     0,   337,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    36,     0,
       0,     0,     0,     0,    62,     0,     7,     8,     9,    10,
      11,     0,    13,    14,     0,     0,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35
};

static const yytype_int16 yycheck[] =
{
     159,     0,    64,   159,     3,   205,   211,   325,    41,    80,
      86,    87,   305,   168,   162,    20,   161,   257,   173,    20,
      20,    22,    20,    64,   379,    67,   167,    55,    38,    90,
      58,   325,   121,   174,   210,   232,   233,   234,   235,     0,
      39,    40,   117,    42,    43,    44,   222,   122,    21,   138,
      92,    50,    51,    95,    80,   295,    22,   205,    21,   488,
     489,    27,    20,   121,   397,   383,    92,    25,    20,    95,
     121,    20,   121,    25,   229,   121,    25,   121,   121,   138,
     170,    20,   140,   139,   155,   175,    25,   138,   264,   383,
      51,   140,   117,   269,   140,   138,   140,   121,    64,   528,
     529,   100,    20,    69,   304,   118,   122,    25,   121,    75,
      76,    77,   136,   446,    80,    81,    82,    83,    84,   121,
     117,   162,   121,   478,   157,   135,   168,   118,   170,   155,
     121,   173,   160,   175,   118,   140,   138,   121,   139,   172,
     140,   139,   168,   176,   170,   118,   121,   173,   121,   175,
     139,   296,   193,   194,   195,    20,   304,   123,   121,   117,
     319,   366,   161,   138,   205,   117,    25,   485,   117,   139,
     119,   132,   133,   125,   126,   380,   125,   126,   117,   139,
     119,   514,   118,   476,   360,   121,   138,   229,    20,   230,
     231,   232,   233,   234,   235,   139,   355,   352,   339,   117,
      28,    29,    30,   229,   117,   346,   365,   125,   126,   527,
      18,    19,   409,   410,   411,   257,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,   140,    33,    34,   291,
     263,    28,    29,    30,   121,   394,   138,   139,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
     291,   138,   118,   295,   325,   121,   126,   299,    28,    29,
      30,   131,   132,   304,   416,   417,   418,   419,    20,   445,
      28,    29,    30,   137,   433,   139,   337,    20,     3,     4,
       5,     6,     7,     8,     9,    10,   486,   446,   138,   139,
     118,   119,   325,   121,   137,    20,   124,   296,   118,    18,
      19,   121,    28,    29,    30,   122,    20,   640,    22,    20,
     352,    25,   383,   123,   137,   648,   122,   123,   118,   652,
     117,   121,   119,   127,   128,   118,   352,   124,   121,   505,
     506,    28,    29,    30,   531,    31,    32,     1,   486,     3,
       4,     5,     6,     7,     8,     9,    10,   117,   117,   119,
     119,    15,    16,    17,   124,   514,    20,    35,    36,   117,
      24,   119,   602,   117,   117,   119,   124,   197,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     421,   422,   423,   424,   425,   426,   428,   429,   449,   431,
     220,   117,    20,   119,    22,   412,   413,    25,   124,   229,
     120,   121,   117,   162,   119,   447,   739,    28,    29,    30,
     125,   126,   488,   489,   485,   118,    20,   478,   121,   578,
     117,   139,   119,    87,    88,   625,   118,   124,   118,   762,
     123,   121,    96,   638,   193,   194,   195,   123,    28,    29,
      30,   118,   414,   415,   121,   486,   205,   118,   781,   121,
     121,   123,   785,   117,   613,   600,   527,   613,   634,   635,
     636,   118,   621,   796,   121,   621,   499,   643,   801,   645,
     115,   230,   231,   232,   233,   234,   235,   625,   138,   624,
     639,   640,    28,    29,    30,   118,   485,   136,   121,   648,
     531,   117,   697,   652,   493,    50,   117,   656,   119,    28,
      29,    30,   118,   124,   118,   121,   118,   121,   667,   121,
     118,   118,   660,   121,   121,   118,   139,   118,   121,   349,
     121,   118,   352,   118,   121,   136,   121,   117,   527,   119,
      50,   361,   362,   363,   124,   740,   118,   696,   118,   121,
     716,   121,   718,    20,   374,   304,   376,   121,   118,   123,
     726,   121,   728,   729,   713,   118,   761,   713,   121,   735,
     602,   118,   120,   121,   121,   395,   725,   118,   744,   118,
     121,   117,   121,   119,   750,   117,   752,   782,   124,   117,
     739,   119,   741,   117,   625,   119,   791,   117,   117,   117,
     119,   420,   421,   118,   753,   124,   121,   427,   138,   775,
     117,   600,   138,   762,   117,     3,     4,     5,     6,     7,
       8,     9,    10,     0,   138,   118,   117,   776,   121,   660,
     125,   118,   781,    21,   121,   624,   785,     3,     4,     5,
       6,     7,     8,     9,    10,    22,   117,   796,   117,    26,
     120,   121,   801,   117,    20,   120,   121,   439,   440,   133,
     409,   410,   411,   412,   413,   414,   415,   416,   417,   418,
     419,   420,   421,   422,   423,   424,   425,   426,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
     134,     3,     4,     5,     6,     7,     8,     9,    10,   439,
     440,   117,    37,    15,    16,    17,    22,   117,    20,   136,
     117,   117,    24,   117,   117,   117,   137,   486,   115,   137,
      56,   140,    58,    59,    60,    61,    62,   140,    64,    65,
     117,   121,    68,   138,    70,    71,   137,   118,   120,   579,
     120,   138,    78,   136,   584,   585,    94,   138,    64,    65,
      94,    67,    21,    69,   118,   118,    72,    73,    74,    75,
      76,    77,   531,    79,    80,    81,    82,    83,    84,    85,
      86,    20,    20,    20,   117,    87,    88,   138,   118,   118,
      22,    69,   137,   117,    96,    27,   123,    75,    76,    77,
     126,   123,    80,    81,    82,    83,    84,   637,   118,   118,
     117,    52,   120,   118,   644,   117,   137,   119,   118,   649,
     122,     3,     4,     5,     6,     7,     8,     9,    10,   118,
     118,    21,    64,   118,    22,   665,   666,    69,   121,   138,
     138,   118,   672,    75,    76,    77,   118,   120,    80,    81,
      82,    83,    84,   118,     1,   118,     3,     4,     5,     6,
       7,     8,     9,    10,   138,   120,   625,    92,    15,    16,
      17,   123,    92,    20,   101,    22,    23,    24,    25,   123,
     138,    69,    29,    30,    72,    73,    74,    75,    76,    77,
     120,    79,    80,    81,    82,    83,    84,    85,    86,   120,
     123,   660,    49,    50,    51,   138,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,   138,    93,    94,    95,    96,
      97,    98,    99,   100,   138,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   120,
     117,   123,   422,   424,   423,   257,   480,   425,   125,   126,
     127,   128,   129,   130,   426,   302,   157,    95,   499,    34,
     151,   138,   139,   140,     1,   493,     3,     4,     5,     6,
       7,     8,     9,    10,   352,   578,   358,   585,    15,    16,
      17,   440,   442,    20,   669,    22,    23,    24,    25,   217,
      51,   111,    29,    30,   293,   602,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    50,    51,    -1,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,    -1,
     117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   125,   126,
     127,   128,   129,   130,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   138,   139,   140,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    20,    -1,    22,    23,    24,    25,    -1,
      -1,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    50,    51,    -1,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    -1,    93,    94,    95,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,     1,
     117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   125,   126,
     127,   128,   129,   130,    -1,    -1,    -1,    -1,    -1,    -1,
      22,   138,   139,    -1,    26,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,    -1,
      -1,    -1,    -1,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    -1,    -1,    -1,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,
      25,    87,    88,   115,    29,    30,    -1,    -1,    -1,    -1,
      96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    49,    50,   138,    -1,    53,    54,
      -1,   117,    -1,   119,    -1,    -1,   122,    -1,    -1,    64,
      65,    -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      16,    17,    87,    88,    20,    -1,    -1,    -1,    24,    25,
      -1,    96,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
      -1,    -1,   117,    49,    50,    -1,    -1,    53,    54,    -1,
     125,   126,   127,   128,   129,   130,    -1,    -1,    64,    65,
      -1,    -1,    -1,    -1,   139,   140,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,
      -1,   117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   125,
     126,   127,   128,   129,   130,     3,     4,     5,     6,     7,
       8,     9,    10,   139,    -1,    -1,    -1,    15,    16,    17,
      -1,    -1,    20,    -1,    22,    -1,    24,    25,    -1,    -1,
      -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    50,    -1,    -1,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,   115,    -1,   117,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     138,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,
      -1,    -1,    24,    25,    -1,    -1,    -1,    29,    30,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    16,    17,    -1,    -1,    20,    49,    50,    -1,
      24,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    17,    87,    88,    20,    -1,    -1,
      -1,    24,    25,    -1,    96,    -1,    29,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   114,    87,    88,   117,    49,    50,    -1,    -1,
      53,    54,    96,   125,   126,   127,   128,   129,   130,    -1,
      -1,    64,    65,    -1,    -1,    -1,   138,    -1,    -1,    -1,
      -1,    -1,    -1,   117,    -1,   119,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,    -1,   117,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   125,   126,   127,   128,   129,   130,    -1,    -1,
      -1,    -1,    -1,    -1,     1,   138,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    20,    -1,    22,    -1,    24,    25,    -1,
      -1,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    50,    -1,    -1,    53,    54,    -1,    56,
      -1,    58,    59,    60,    61,    62,    -1,    64,    65,    -1,
      -1,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,
     117,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   125,   126,
     127,   128,   129,   130,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    20,    -1,    -1,    -1,    24,    25,    -1,
      -1,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    50,    -1,    -1,    53,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,    -1,
      -1,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,
      87,    88,    24,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,
     117,   118,    -1,    -1,    -1,    -1,    -1,    -1,   125,   126,
     127,   128,   129,   130,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    20,    -1,    87,    88,    24,    25,    -1,
      -1,    -1,    29,    30,    96,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    50,    -1,   117,    53,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,
     117,   118,    -1,    -1,    -1,    -1,    -1,    -1,   125,   126,
     127,   128,   129,   130,     1,    -1,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    20,    -1,    -1,    -1,    24,    25,    -1,
      -1,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    50,    -1,    -1,    53,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,    -1,
      -1,    -1,    -1,     1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,
      87,    88,    20,    -1,    -1,    -1,    24,    25,    -1,    96,
      -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,
     117,    49,    50,    -1,    -1,    53,    54,    -1,   125,   126,
     127,   128,   129,   130,    -1,    -1,    64,    65,    -1,    -1,
      -1,    -1,     1,    -1,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,    87,
      88,    20,    -1,    -1,    -1,    24,    25,    -1,    96,    -1,
      29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,   117,
      49,    -1,    -1,    -1,    53,    54,    -1,   125,   126,   127,
     128,   129,   130,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    87,    88,
      20,    -1,    -1,    -1,    24,    25,    -1,    96,    -1,    29,
      30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,   117,    49,
      50,   120,    -1,    53,    54,    -1,   125,   126,   127,   128,
     129,   130,    -1,    -1,    64,    65,    -1,    -1,    -1,    -1,
      -1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    17,    87,    88,    20,
      -1,    -1,    -1,    24,    25,    -1,    96,    -1,    29,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   114,    -1,    -1,   117,    49,    50,
      -1,    -1,    53,    54,    -1,   125,   126,   127,   128,   129,
     130,    -1,    -1,    64,    65,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,    -1,   117,   118,    -1,    -1,
      -1,    -1,    -1,    -1,   125,   126,   127,   128,   129,   130,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,    -1,
      -1,    24,    25,    -1,    -1,    -1,    29,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,    -1,
      53,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,    -1,   117,   118,    -1,    -1,    -1,    -1,
      -1,    -1,   125,   126,   127,   128,   129,   130,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,
      25,    -1,    -1,    -1,    29,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    49,    50,    -1,    -1,    53,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
      -1,    -1,   117,   118,    -1,    -1,    -1,    -1,    -1,    -1,
     125,   126,   127,   128,   129,   130,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    20,    -1,    -1,    -1,    24,    25,    -1,
      -1,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    50,    -1,    -1,    53,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,
     117,   118,    -1,    -1,    -1,    -1,    -1,    -1,   125,   126,
     127,   128,   129,   130,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,    20,    -1,    -1,    -1,    24,    25,    -1,    -1,    -1,
      29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    50,    -1,    -1,    53,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    65,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,   117,   118,
      -1,    -1,    -1,    -1,    -1,    -1,   125,   126,   127,   128,
     129,   130,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,
      -1,    -1,    -1,    24,    25,    -1,    -1,    -1,    29,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    50,
      -1,    -1,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    65,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,    -1,   117,   118,    -1,    -1,
      -1,    -1,    -1,    -1,   125,   126,   127,   128,   129,   130,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,    -1,
      -1,    24,    25,    -1,    -1,    -1,    29,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,    -1,
      53,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    64,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,    -1,   117,   118,    -1,    -1,    -1,    -1,
      -1,    -1,   125,   126,   127,   128,   129,   130,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,
      25,    -1,    -1,    -1,    29,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    49,    50,    -1,    -1,    53,    54,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,
      65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    87,    88,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    96,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,
      -1,    -1,   117,   118,    -1,    -1,    -1,    -1,    -1,    -1,
     125,   126,   127,   128,   129,   130,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    16,
      17,    -1,    -1,    20,    -1,    -1,    -1,    24,    25,    -1,
      -1,    -1,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    50,    -1,    -1,    53,    54,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    64,    65,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    88,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,
     117,   118,    -1,    -1,    -1,    -1,    -1,    -1,   125,   126,
     127,   128,   129,   130,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    16,    17,    -1,
      -1,    20,    -1,    -1,    -1,    24,    25,    -1,    -1,    -1,
      29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    50,    -1,    -1,    53,    54,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    64,    65,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    88,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   114,    -1,    -1,   117,   118,
      -1,    -1,    -1,    -1,    -1,    -1,   125,   126,   127,   128,
     129,   130,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,
      -1,    -1,    -1,    24,    25,    -1,    -1,    -1,    29,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    49,    50,
      -1,    -1,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    64,    65,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,    -1,   117,   118,    -1,    -1,
      -1,    -1,    -1,    -1,   125,   126,   127,   128,   129,   130,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,    -1,
      -1,    24,    25,    -1,    -1,    -1,    29,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    50,    -1,    -1,
      53,    54,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    64,    65,    -1,    15,    16,    17,    -1,    -1,    20,
      -1,    -1,    -1,    24,    25,    -1,    -1,    -1,    29,    30,
      -1,    -1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,    -1,   117,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   125,   126,   127,   128,   129,   130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,    -1,   117,    -1,    -1,   120,
      -1,    -1,    -1,    -1,   125,   126,   127,   128,   129,   130,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,    -1,
      -1,    24,    25,    -1,    -1,    -1,    29,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      53,    54,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,
      -1,    -1,    -1,    24,    25,    -1,    -1,    -1,    29,    30,
      -1,    -1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,    -1,   117,    -1,    -1,   120,    -1,    -1,
      -1,    -1,   125,   126,   127,   128,   129,   130,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,    -1,   117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   125,   126,   127,   128,   129,   130,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    16,    17,    -1,    -1,    20,    -1,    -1,
      -1,    24,    25,    -1,    -1,    -1,    29,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      53,    54,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    16,    17,    -1,    -1,    20,
      -1,    -1,    -1,    24,    25,    -1,    -1,    -1,    29,    30,
      -1,    -1,    -1,    -1,    87,    88,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    96,    -1,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    53,    54,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   114,    -1,    -1,   117,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   125,   126,   127,   128,   129,   130,     1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    87,    88,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    20,    -1,    22,
      -1,    -1,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   114,    -1,    -1,   117,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   125,   126,   127,   128,   129,   130,
      -1,    -1,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,     1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    -1,   115,    -1,   117,   118,   119,    -1,    -1,    -1,
      -1,    -1,   125,   126,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,    -1,
     117,   118,   119,    -1,    -1,    -1,    -1,    22,   125,   126,
      56,    -1,    58,    59,    60,    61,    62,    -1,    64,    65,
      -1,    -1,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    56,    -1,    58,    59,    60,    61,    62,    -1,    64,
      65,    -1,    -1,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   140,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    -1,    -1,    56,    -1,    58,    59,    60,    61,
      62,    -1,    64,    65,    -1,   140,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    56,    -1,    58,    59,    60,
      61,    62,    -1,    64,    65,    -1,    -1,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,     1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,   140,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   140,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,     1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,    -1,    -1,
     115,    -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,     1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    22,
      -1,    -1,    -1,    -1,    -1,    -1,   115,    -1,    -1,   118,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,     1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    22,    -1,    -1,    -1,    -1,
      -1,    -1,   115,    -1,    -1,   118,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      22,    -1,    -1,    -1,    -1,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    20,    -1,    22,    -1,    -1,    -1,   115,    -1,
      -1,   118,    -1,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    -1,    64,    65,    22,    67,
      -1,    69,    -1,    -1,    72,    73,    74,    75,    76,    77,
      -1,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    -1,    -1,   115,    -1,    -1,    -1,    -1,    -1,    -1,
     122,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   115,    -1,    -1,    -1,    22,    -1,    56,   122,    58,
      59,    60,    61,    62,    -1,    64,    65,    -1,    -1,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      22,    -1,    -1,   122,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   115,    -1,
      -1,    -1,    -1,    -1,    56,    -1,    58,    59,    60,    61,
      62,    -1,    64,    65,    -1,    -1,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     1,    22,    26,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,   115,   138,   171,   172,
     175,   176,   177,   183,   184,   186,   189,   190,   191,   198,
     201,   252,   253,   254,   263,   264,   266,   271,   272,   273,
     138,    55,    56,   122,   176,    18,    19,   139,   117,   122,
      20,   139,   197,   117,   176,   176,    20,    25,   117,   125,
     126,   138,   181,   182,   203,   205,   206,   207,   176,   176,
     122,   176,   139,    20,    22,   139,   188,   176,     0,   253,
     265,   138,   139,   220,   222,   138,   222,    18,    19,    22,
      27,    64,    69,    75,    76,    77,    80,    81,    82,    83,
      84,   123,   256,   257,   258,   259,   260,   261,   262,    25,
     269,   270,   139,   139,   184,   185,    20,   173,   174,     3,
       4,     5,     6,     7,     8,     9,    10,   204,   197,   199,
     200,   139,   117,   203,   201,   202,   206,   121,   138,   137,
     255,   117,   119,   205,   205,    20,   204,   140,   184,   187,
     192,   193,   194,   201,   140,   192,   176,   140,     1,     3,
       4,     5,     6,     7,     8,     9,    10,    15,    16,    17,
      20,    23,    24,    29,    30,    49,    50,    51,    53,    54,
      64,    65,    68,    87,    88,    89,    90,    91,    93,    94,
      95,    96,    97,    98,    99,   100,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   117,
     125,   126,   127,   128,   129,   130,   138,   143,   144,   145,
     146,   147,   148,   149,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   166,   167,
     168,   170,   171,   176,   216,   217,   218,   219,   222,   223,
     224,   225,   228,   229,   230,   231,   233,   238,   240,   245,
     246,   247,   248,   249,   250,   251,   269,   270,    20,    20,
     257,   176,    20,   121,   123,   122,   117,   171,   171,   121,
     140,   118,   121,   123,   137,   121,   140,   199,    20,   178,
     179,   118,   201,   206,   182,   203,    20,    64,    65,   139,
     167,   214,   222,     1,   118,   176,   208,   209,   210,     1,
     120,   151,   163,   169,   123,   123,   177,   122,   194,   140,
     193,   195,   196,   203,   194,   177,   140,   203,   138,   117,
     151,   151,   117,   151,   168,   117,    50,    50,   139,   169,
     136,   117,   117,   117,   217,   119,   122,   146,    20,   245,
     138,   138,   138,   168,   117,   217,   117,   138,   117,   117,
     117,     1,   168,   194,   211,   151,   151,   152,   152,   152,
     152,    28,    29,    30,   117,   119,   124,   117,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,   137,   126,
     131,   132,   127,   128,    31,    32,    33,    34,   122,   123,
      35,    36,   125,   133,   134,    37,    38,   135,    64,    65,
     165,   172,   184,   121,   138,   217,   140,   217,   221,   117,
     117,   117,   117,   117,   117,   136,   117,   137,   270,   137,
     261,     3,     4,     5,     6,     7,     8,     9,    10,    20,
      87,    88,   165,   267,   268,     1,   118,   208,   140,   140,
     184,   138,   173,   169,   140,   200,   121,   140,   117,   118,
     121,   214,   215,   118,   121,   117,   119,   203,   206,   207,
     212,   213,   118,   121,   120,   120,    20,   204,   177,   121,
     138,   177,   211,   138,   167,   223,   136,   217,   168,   168,
     168,    94,   167,   146,   117,   138,   138,   168,    94,   168,
      21,   142,   142,     1,   146,   118,   118,   117,   206,   207,
     212,   118,    20,    22,    25,     1,   118,   150,   167,     1,
     168,    20,    22,    25,   118,   150,   167,   167,   167,   167,
     167,   167,   167,   167,   167,   167,   167,   152,   152,   152,
     153,   153,   154,   154,   155,   155,   155,   155,   156,   156,
     157,   158,   159,   160,   161,   168,   184,   184,   117,   119,
     184,   167,   170,   224,   227,   227,    20,   232,   236,   237,
     237,    20,   234,    20,   239,   217,     1,   118,   150,   184,
     117,   204,   121,   123,   118,   138,   118,   140,   142,   180,
     204,   118,   179,   121,   140,     1,   118,   208,   212,   120,
     169,   137,   213,   213,   117,   119,   210,   123,   123,   196,
     118,   118,   140,   217,   118,   118,   118,   117,   120,   121,
     117,   118,   150,   118,   117,   118,    21,   118,   121,   121,
     118,   118,   121,   152,   118,   118,   121,   120,   120,   118,
     136,   215,   168,   138,   168,   226,   226,   137,   118,   121,
     118,   118,    52,   118,   118,     1,   118,   208,   267,   138,
     138,   118,   140,   214,   118,   118,   120,   214,   118,   208,
     120,   169,   217,   217,   217,   168,   119,   122,   146,   167,
     118,   150,   118,   217,   168,   217,   138,   150,   168,   150,
     167,   163,   118,   121,   120,   138,   118,   168,   118,   168,
      11,    12,    13,    14,   167,   235,   241,   236,   242,   243,
     168,   118,   118,   118,   120,    92,   118,   167,   146,   117,
     120,   121,   123,   118,    92,   118,   118,   118,   118,   217,
     118,   217,   118,   101,   167,   217,   217,   217,   118,   217,
     138,   120,   117,   118,   150,   146,   167,   123,   217,   138,
     138,   138,   217,   217,   167,   244,   119,   146,   118,   150,
     118,   117,   120,   217,   167,   117,   123,   118,   118,   150,
     146,   120,   118,   150,   123,   118,   117,   146,   118,   118,
     150,   117,   118,   118,   150,   118
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   141,   142,   142,   143,   143,   143,   143,   143,   143,
     143,   143,   143,   143,   143,   143,   143,   143,   143,   143,
     143,   144,   144,   144,   144,   144,   144,   144,   144,   144,
     144,   144,   144,   144,   144,   144,   144,   145,   145,   145,
     146,   146,   146,   146,   146,   146,   146,   146,   146,   146,
     146,   146,   147,   148,   148,   149,   149,   149,   149,   149,
     149,   149,   150,   150,   151,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   151,   151,   151,   152,   152,
     153,   153,   153,   153,   154,   154,   154,   155,   155,   155,
     156,   156,   156,   156,   156,   157,   157,   157,   158,   158,
     159,   159,   160,   160,   161,   161,   162,   162,   163,   163,
     164,   164,   164,   165,   165,   165,   165,   166,   166,   166,
     166,   167,   167,   167,   167,   167,   167,   167,   167,   167,
     167,   167,   167,   167,   168,   168,   169,   170,   171,   171,
     172,   173,   174,   174,   175,   176,   176,   176,   176,   176,
     176,   176,   176,   176,   176,   176,   176,   176,   176,   177,
     178,   178,   179,   179,   180,   180,   181,   181,   182,   182,
     183,   183,   183,   183,   183,   184,   184,   184,   184,   185,
     185,   186,   186,   186,   186,   186,   186,   186,   186,   186,
     186,   186,   186,   186,   187,   187,   188,   188,   189,   190,
     190,   190,   190,   190,   190,   190,   190,   190,   191,   192,
     192,   193,   194,   194,   194,   194,   195,   195,   196,   197,
     198,   198,   198,   198,   198,   199,   199,   200,   200,   201,
     201,   201,   201,   201,   201,   201,   201,   201,   201,   201,
     201,   202,   202,   203,   203,   203,   204,   204,   204,   204,
     204,   204,   204,   204,   205,   205,   205,   205,   205,   205,
     205,   205,   205,   206,   206,   206,   206,   207,   208,   209,
     209,   209,   210,   210,   210,   210,   211,   211,   212,   212,
     212,   212,   212,   213,   213,   213,   213,   213,   213,   213,
     213,   213,   214,   214,   214,   215,   215,   216,   217,   217,
     218,   218,   218,   218,   218,   218,   218,   218,   218,   218,
     218,   218,   218,   219,   219,   219,   220,   221,   222,   222,
     223,   223,   224,   224,   225,   225,   225,   225,   225,   226,
     226,   227,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   235,   235,   235,   236,   236,   237,   237,   238,   239,
     240,   240,   240,   240,   240,   240,   240,   240,   241,   240,
     242,   240,   243,   240,   244,   240,   245,   246,   246,   246,
     246,   246,   247,   248,   249,   250,   250,   251,   252,   252,
     252,   253,   253,   253,   253,   253,   253,   253,   253,   253,
     255,   254,   256,   256,   257,   257,   257,   257,   257,   257,
     257,   257,   257,   258,   258,   259,   259,   260,   261,   261,
     261,   262,   262,   263,   265,   264,   266,   266,   267,   267,
     267,   267,   267,   267,   267,   267,   267,   267,   267,   267,
     268,   268,   269,   270,   270,   271,   271,   271,   272,   272,
     272,   273,   273
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3,
       3,     5,     4,     8,     7,    10,     9,    11,    10,    12,
      11,    14,    13,     7,     6,    10,     9,     4,     6,     4,
       1,     4,     4,     1,     3,     3,     3,     3,     3,     3,
       2,     2,     1,     3,     4,     1,     3,     4,     4,     3,
       4,     4,     1,     3,     1,     1,     1,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     4,     4,     1,     4,
       1,     3,     3,     3,     1,     3,     3,     1,     3,     3,
       1,     3,     3,     3,     3,     1,     3,     3,     1,     3,
       1,     3,     1,     3,     1,     3,     1,     3,     1,     5,
       1,     2,     2,     1,     2,     2,     2,     1,     2,     5,
       5,     1,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     1,     3,     1,     1,     2,     3,
       4,     1,     1,     3,     4,     1,     2,     1,     2,     1,
       2,     1,     4,     4,     2,     1,     2,     1,     2,     6,
       1,     3,     1,     4,     1,     1,     1,     3,     1,     3,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     4,     4,     1,     1,     2,     1,
       4,     5,     4,     5,     3,     4,     3,     4,     1,     1,
       2,     3,     2,     1,     1,     2,     1,     3,     1,     1,
       4,     5,     5,     6,     2,     1,     3,     1,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     4,     3,     4,
       4,     3,     4,     1,     2,     2,     3,     1,     1,     1,
       3,     2,     2,     4,     2,     1,     1,     2,     1,     1,
       2,     1,     2,     3,     2,     3,     3,     4,     2,     3,
       3,     4,     1,     3,     4,     1,     3,     1,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     3,     4,     3,     1,     1,     2,     3,
       1,     2,     1,     2,     5,     7,     5,     7,     5,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     5,     4,     1,     3,     1,     1,
       5,     5,     7,     7,     6,     7,     6,     7,     0,     6,
       0,     6,     0,     6,     0,     8,     1,     3,     2,     2,
       2,     3,     2,     3,     4,     5,     7,     7,     1,     2,
       2,     1,     1,     1,     1,     5,     5,     5,     1,     1,
       0,     4,     2,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     1,     2,     4,     2,     1,     1,
       1,     1,     3,     4,     0,     4,     2,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     1,     4,     1,     7,     6,     7,     8,     7,
       8,     2,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YYLOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YYLOCATION_PRINT

#  if defined YY_LOCATION_PRINT

   /* Temporary convenience wrapper in case some people defined the
      undocumented and private YY_LOCATION_PRINT macros.  */
#   define YYLOCATION_PRINT(File, Loc)  YY_LOCATION_PRINT(File, *(Loc))

#  elif defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
}

#   define YYLOCATION_PRINT  yy_location_print_

    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT(File, Loc)  YYLOCATION_PRINT(File, &(Loc))

#  else

#   define YYLOCATION_PRINT(File, Loc) ((void) 0)
    /* Temporary convenience wrapper in case some people defined the
       undocumented and private YY_LOCATION_PRINT macros.  */
#   define YY_LOCATION_PRINT  YYLOCATION_PRINT

#  endif
# endif /* !defined YYLOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (yylocationp);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_TOKEN_FLOAT16_CONSTANT: /* TOKEN_FLOAT16_CONSTANT  */
#line 331 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stringVal), c_str())); }
#line 2694 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_IDENTIFIER: /* TOKEN_IDENTIFIER  */
#line 331 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stringVal), c_str())); }
#line 2700 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_STRING_LITERAL: /* TOKEN_STRING_LITERAL  */
#line 331 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stringVal), c_str())); }
#line 2706 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_TYPE_NAME: /* TOKEN_TYPE_NAME  */
#line 331 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stringVal), c_str())); }
#line 2712 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_TEMPLATE_NAME: /* TOKEN_TEMPLATE_NAME  */
#line 331 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stringVal), c_str())); }
#line 2718 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_INTRINSIC_CALL: /* TOKEN_INTRINSIC_CALL  */
#line 331 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stringVal), c_str())); }
#line 2724 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_string_constant: /* string_constant  */
#line 331 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stringVal), c_str())); }
#line 2730 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_primary_expression: /* primary_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2736 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_launch_expression: /* launch_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2742 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_invoke_sycl_expression: /* invoke_sycl_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2748 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_postfix_expression: /* postfix_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2754 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_intrinsic_name: /* intrinsic_name  */
#line 331 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stringVal), c_str())); }
#line 2760 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_intrincall_expression: /* intrincall_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2766 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_funcall_expression: /* funcall_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2772 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_argument_expression_list: /* argument_expression_list  */
#line 335 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).exprList), GetString().c_str())); }
#line 2778 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_unary_expression: /* unary_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2784 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_cast_expression: /* cast_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2790 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_multiplicative_expression: /* multiplicative_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2796 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_additive_expression: /* additive_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2802 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_shift_expression: /* shift_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2808 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_relational_expression: /* relational_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2814 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_equality_expression: /* equality_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2820 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_and_expression: /* and_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2826 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_exclusive_or_expression: /* exclusive_or_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2832 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_inclusive_or_expression: /* inclusive_or_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2838 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_logical_and_expression: /* logical_and_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2844 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_logical_or_expression: /* logical_or_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2850 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_conditional_expression: /* conditional_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2856 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_rate_qualified_new: /* rate_qualified_new  */
#line 333 "src/parse.yy"
         { fprintf(yyo, "%" PRIu64, ((*yyvaluep).intVal)); }
#line 2862 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_rate_qualified_type_specifier: /* rate_qualified_type_specifier  */
#line 377 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).type), GetString().c_str())); }
#line 2868 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_new_expression: /* new_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2874 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_assignment_expression: /* assignment_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2880 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_expression: /* expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2886 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_constant_expression: /* constant_expression  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 2892 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_declaration_statement: /* declaration_statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 2898 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_declaration: /* declaration  */
#line 337 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).declaration), GetString().c_str())); }
#line 2904 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_soa_width_specifier: /* soa_width_specifier  */
#line 333 "src/parse.yy"
         { fprintf(yyo, "%" PRIu64, ((*yyvaluep).intVal)); }
#line 2910 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_declspec_item: /* declspec_item  */
#line 404 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).declspecPair), first.c_str())); }
#line 2916 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_declspec_list: /* declspec_list  */
#line 405 "src/parse.yy"
         {
  fprintf(yyo, "<");
  for (auto &i : *((*yyvaluep).declspecList)) {
    fprintf(yyo, "%s,", i.first.c_str());
  }
  fprintf(yyo, ">");
}
#line 2928 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_declspec_specifier: /* declspec_specifier  */
#line 405 "src/parse.yy"
         {
  fprintf(yyo, "<");
  for (auto &i : *((*yyvaluep).declspecList)) {
    fprintf(yyo, "%s,", i.first.c_str());
  }
  fprintf(yyo, ">");
}
#line 2940 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_declaration_specifiers: /* declaration_specifiers  */
#line 387 "src/parse.yy"
         { fprintf(yyo, "%s:", SAFE_ACCESS(((*yyvaluep).declSpecs), GetString().c_str())); }
#line 2946 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_attribute_specifier: /* attribute_specifier  */
#line 388 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).attributeList), GetString().c_str())); }
#line 2952 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_attribute_list: /* attribute_list  */
#line 388 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).attributeList), GetString().c_str())); }
#line 2958 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_attribute: /* attribute  */
#line 389 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).attr), GetString().c_str())); }
#line 2964 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_attribute_argument: /* attribute_argument  */
#line 390 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).attrArg), GetString().c_str())); }
#line 2970 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_init_declarator_list: /* init_declarator_list  */
#line 346 "src/parse.yy"
         {
  fprintf(yyo, "<");
  for(auto &i : *((*yyvaluep).declarators)) {
    fprintf(yyo, "%s,", SAFE_ACCESS(i, GetString().c_str()));
  }
  fprintf(yyo, ">");
}
#line 2982 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_init_declarator: /* init_declarator  */
#line 345 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).declarator), GetString().c_str())); }
#line 2988 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_storage_class_specifier: /* storage_class_specifier  */
#line 386 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).storageClass), GetString().c_str())); }
#line 2994 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_type_specifier: /* type_specifier  */
#line 377 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).type), GetString().c_str())); }
#line 3000 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_type_specifier_list: /* type_specifier_list  */
#line 378 "src/parse.yy"
         {
  fprintf(yyo, "<");
  for(auto &i : *((*yyvaluep).typeList)) {
    fprintf(yyo, "%s,", SAFE_ACCESS(i.first, GetString().c_str()));
  }
  fprintf(yyo, ">");
}
#line 3012 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_atomic_var_type_specifier: /* atomic_var_type_specifier  */
#line 377 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).type), GetString().c_str())); }
#line 3018 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_short_vec_specifier: /* short_vec_specifier  */
#line 377 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).type), GetString().c_str())); }
#line 3024 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_struct_or_union_name: /* struct_or_union_name  */
#line 332 "src/parse.yy"
         { fprintf(yyo, "%s", ((*yyvaluep).constCharPtr)); }
#line 3030 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_struct_or_union_and_name: /* struct_or_union_and_name  */
#line 377 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).type), GetString().c_str())); }
#line 3036 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_struct_or_union_specifier: /* struct_or_union_specifier  */
#line 377 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).type), GetString().c_str())); }
#line 3042 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_struct_declaration_list: /* struct_declaration_list  */
#line 361 "src/parse.yy"
         {
  fprintf(yyo, "<");
  for(auto &i : *((*yyvaluep).structDeclarationList)) {
    fprintf(yyo, "%s,", SAFE_ACCESS(i, GetString().c_str()));
  }
  fprintf(yyo, ">");
}
#line 3054 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_struct_declaration: /* struct_declaration  */
#line 360 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).structDeclaration), GetString().c_str())); }
#line 3060 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_specifier_qualifier_list: /* specifier_qualifier_list  */
#line 377 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).type), GetString().c_str())); }
#line 3066 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_struct_declarator_list: /* struct_declarator_list  */
#line 353 "src/parse.yy"
         {
  fprintf(yyo, "<");
  for(auto &i : *((*yyvaluep).structDeclaratorList)) {
    fprintf(yyo, "%s,", SAFE_ACCESS(i, GetString().c_str()));
  }
  fprintf(yyo, ">");
}
#line 3078 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_struct_declarator: /* struct_declarator  */
#line 345 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).declarator), GetString().c_str())); }
#line 3084 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_enum_identifier: /* enum_identifier  */
#line 332 "src/parse.yy"
         { fprintf(yyo, "%s", ((*yyvaluep).constCharPtr)); }
#line 3090 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_enum_specifier: /* enum_specifier  */
#line 376 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).enumType), GetString().c_str())); }
#line 3096 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_enumerator_list: /* enumerator_list  */
#line 368 "src/parse.yy"
         {
  fprintf(yyo, "<");
  for(auto &i : *((*yyvaluep).symbolList)) {
    fprintf(yyo, "%s,", SAFE_ACCESS(i, name.c_str()));
  }
  fprintf(yyo, ">");
}
#line 3108 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_enumerator: /* enumerator  */
#line 375 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).symbol), name.c_str())); }
#line 3114 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_type_qualifier: /* type_qualifier  */
#line 385 "src/parse.yy"
         { fprintf(yyo, "%s", DeclSpecs::GetTypeQualifiersString(((*yyvaluep).typeQualifier)).c_str()); }
#line 3120 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_type_qualifier_list: /* type_qualifier_list  */
#line 385 "src/parse.yy"
         { fprintf(yyo, "%s", DeclSpecs::GetTypeQualifiersString(((*yyvaluep).typeQualifier)).c_str()); }
#line 3126 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_declarator: /* declarator  */
#line 345 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).declarator), GetString().c_str())); }
#line 3132 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_int_constant: /* int_constant  */
#line 333 "src/parse.yy"
         { fprintf(yyo, "%" PRIu64, ((*yyvaluep).intVal)); }
#line 3138 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_direct_declarator: /* direct_declarator  */
#line 345 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).declarator), GetString().c_str())); }
#line 3144 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_pointer: /* pointer  */
#line 345 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).declarator), GetString().c_str())); }
#line 3150 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_reference: /* reference  */
#line 345 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).declarator), GetString().c_str())); }
#line 3156 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_parameter_type_list: /* parameter_type_list  */
#line 338 "src/parse.yy"
         {
  fprintf(yyo, "<");
  for(auto &i : *((*yyvaluep).declarationList)) {
    fprintf(yyo, "%s:", SAFE_ACCESS(i, GetString().c_str()));
  }
  fprintf(yyo, ">");
}
#line 3168 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_parameter_list: /* parameter_list  */
#line 338 "src/parse.yy"
         {
  fprintf(yyo, "<");
  for(auto &i : *((*yyvaluep).declarationList)) {
    fprintf(yyo, "%s:", SAFE_ACCESS(i, GetString().c_str()));
  }
  fprintf(yyo, ">");
}
#line 3180 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_parameter_declaration: /* parameter_declaration  */
#line 337 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).declaration), GetString().c_str())); }
#line 3186 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_type_name: /* type_name  */
#line 377 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).type), GetString().c_str())); }
#line 3192 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_abstract_declarator: /* abstract_declarator  */
#line 345 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).declarator), GetString().c_str())); }
#line 3198 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_direct_abstract_declarator: /* direct_abstract_declarator  */
#line 345 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).declarator), GetString().c_str())); }
#line 3204 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_initializer: /* initializer  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 3210 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_initializer_list: /* initializer_list  */
#line 335 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).exprList), GetString().c_str())); }
#line 3216 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_pragma: /* pragma  */
#line 391 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).pragmaAttributes), GetString().c_str())); }
#line 3222 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_attributed_statement: /* attributed_statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3228 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_statement: /* statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3234 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_labeled_statement: /* labeled_statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3240 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_compound_statement: /* compound_statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3246 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_statement_list: /* statement_list  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3252 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_expression_statement: /* expression_statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3258 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_selection_statement: /* selection_statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3264 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_for_test: /* for_test  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 3270 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_for_init_statement: /* for_init_statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3276 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_foreach_identifier: /* foreach_identifier  */
#line 375 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).symbol), name.c_str())); }
#line 3282 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_foreach_active_identifier: /* foreach_active_identifier  */
#line 375 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).symbol), name.c_str())); }
#line 3288 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_integer_dotdotdot: /* integer_dotdotdot  */
#line 334 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).expr), GetString().c_str())); }
#line 3294 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_foreach_dimension_specifier: /* foreach_dimension_specifier  */
#line 392 "src/parse.yy"
         { fprintf(yyo, "%s", ((*yyvaluep).foreachDimension)->sym->name.c_str()); }
#line 3300 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_foreach_dimension_list: /* foreach_dimension_list  */
#line 393 "src/parse.yy"
         {
  fprintf(yyo, "<");
  for (auto &i : *((*yyvaluep).foreachDimensionList)) {
    if (i && i->sym) {
      fprintf(yyo, "%s,", i->sym->name.c_str());
    } else {
      fprintf(yyo, "nullptr");
    }
  }
  fprintf(yyo, ">");
}
#line 3316 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_foreach_unique_identifier: /* foreach_unique_identifier  */
#line 332 "src/parse.yy"
         { fprintf(yyo, "%s", ((*yyvaluep).constCharPtr)); }
#line 3322 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_iteration_statement: /* iteration_statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3328 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_goto_identifier: /* goto_identifier  */
#line 332 "src/parse.yy"
         { fprintf(yyo, "%s", ((*yyvaluep).constCharPtr)); }
#line 3334 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_jump_statement: /* jump_statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3340 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_sync_statement: /* sync_statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3346 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_delete_statement: /* delete_statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3352 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_unmasked_statement: /* unmasked_statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3358 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_print_statement: /* print_statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3364 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_assert_statement: /* assert_statement  */
#line 336 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).stmt), GetString().c_str())); }
#line 3370 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_template_type_parameter: /* template_type_parameter  */
#line 432 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).templateTypeParm), GetString().c_str())); }
#line 3376 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_int_constant_type: /* int_constant_type  */
#line 377 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).type), GetString().c_str())); }
#line 3382 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_template_int_constant_type: /* template_int_constant_type  */
#line 377 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).type), GetString().c_str())); }
#line 3388 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_template_int_parameter: /* template_int_parameter  */
#line 375 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).symbol), name.c_str())); }
#line 3394 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_template_enum_parameter: /* template_enum_parameter  */
#line 375 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).symbol), name.c_str())); }
#line 3400 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_template_parameter: /* template_parameter  */
#line 433 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).templateParm), GetName().c_str())); }
#line 3406 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_template_parameter_list: /* template_parameter_list  */
#line 434 "src/parse.yy"
         {
  fprintf(yyo, "<");
  if (((*yyvaluep).templateParmList)) {
    for (size_t i = 0; i < ((*yyvaluep).templateParmList)->GetCount(); ++i) {
      fprintf(yyo, "%s,", SAFE_ACCESS((*((*yyvaluep).templateParmList))[i], GetName().c_str()));
    }
  }
  fprintf(yyo, ">");
}
#line 3420 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_template_head: /* template_head  */
#line 434 "src/parse.yy"
         {
  fprintf(yyo, "<");
  if (((*yyvaluep).templateParmList)) {
    for (size_t i = 0; i < ((*yyvaluep).templateParmList)->GetCount(); ++i) {
      fprintf(yyo, "%s,", SAFE_ACCESS((*((*yyvaluep).templateParmList))[i], GetName().c_str()));
    }
  }
  fprintf(yyo, ">");
}
#line 3434 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_template_declaration: /* template_declaration  */
#line 443 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).functionTemplateSym), name.c_str())); }
#line 3440 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_template_argument: /* template_argument  */
#line 412 "src/parse.yy"
         { fprintf(yyo, "%s", SAFE_ACCESS(((*yyvaluep).templateArg), GetString().c_str())); }
#line 3446 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_template_argument_list: /* template_argument_list  */
#line 413 "src/parse.yy"
         {
  fprintf(yyo, "<");
  for (auto &i : *((*yyvaluep).templateArgs)) {
    fprintf(yyo, "%s,", i.GetString().c_str());
  }
  fprintf(yyo, ">");
}
#line 3458 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_template_identifier: /* template_identifier  */
#line 332 "src/parse.yy"
         { fprintf(yyo, "%s", ((*yyvaluep).constCharPtr)); }
#line 3464 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_simple_template_id: /* simple_template_id  */
#line 420 "src/parse.yy"
         {
  if (((*yyvaluep).simpleTemplateID) && ((*yyvaluep).simpleTemplateID)->first) {
    fprintf(yyo, "%s: ", ((*yyvaluep).simpleTemplateID)->first->name.c_str());
  }
  fprintf(yyo, "<");
  if (((*yyvaluep).simpleTemplateID) && ((*yyvaluep).simpleTemplateID)->second) {
    for (auto &i : *((*yyvaluep).simpleTemplateID)->second) {
      fprintf(yyo, "%s,", i.GetString().c_str());
    }
  }
  fprintf(yyo, ">");
}
#line 3481 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_template_function_specialization_declaration: /* template_function_specialization_declaration  */
#line 420 "src/parse.yy"
         {
  if (((*yyvaluep).simpleTemplateID) && ((*yyvaluep).simpleTemplateID)->first) {
    fprintf(yyo, "%s: ", ((*yyvaluep).simpleTemplateID)->first->name.c_str());
  }
  fprintf(yyo, "<");
  if (((*yyvaluep).simpleTemplateID) && ((*yyvaluep).simpleTemplateID)->second) {
    for (auto &i : *((*yyvaluep).simpleTemplateID)->second) {
      fprintf(yyo, "%s,", i.GetString().c_str());
    }
  }
  fprintf(yyo, ">");
}
#line 3498 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YYLOCATION_PRINT (yyo, yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YY_USE (yyvaluep);
  YY_USE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  switch (yykind)
    {
    case YYSYMBOL_TOKEN_FLOAT16_CONSTANT: /* TOKEN_FLOAT16_CONSTANT  */
#line 322 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 3900 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_IDENTIFIER: /* TOKEN_IDENTIFIER  */
#line 322 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 3906 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_STRING_LITERAL: /* TOKEN_STRING_LITERAL  */
#line 322 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 3912 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_TYPE_NAME: /* TOKEN_TYPE_NAME  */
#line 322 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 3918 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_TEMPLATE_NAME: /* TOKEN_TEMPLATE_NAME  */
#line 322 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 3924 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_TOKEN_INTRINSIC_CALL: /* TOKEN_INTRINSIC_CALL  */
#line 322 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 3930 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_string_constant: /* string_constant  */
#line 322 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 3936 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_intrinsic_name: /* intrinsic_name  */
#line 322 "src/parse.yy"
            { lCleanUpString(((*yyvaluep).stringVal)); }
#line 3942 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_attribute_specifier: /* attribute_specifier  */
#line 324 "src/parse.yy"
            { delete ((*yyvaluep).attributeList); }
#line 3948 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_attribute_list: /* attribute_list  */
#line 324 "src/parse.yy"
            { delete ((*yyvaluep).attributeList); }
#line 3954 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_attribute: /* attribute  */
#line 325 "src/parse.yy"
            { delete ((*yyvaluep).attr); }
#line 3960 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_attribute_argument: /* attribute_argument  */
#line 326 "src/parse.yy"
            { delete ((*yyvaluep).attrArg); }
#line 3966 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

    case YYSYMBOL_storage_class_specifier: /* storage_class_specifier  */
#line 323 "src/parse.yy"
            { delete ((*yyvaluep).storageClass); }
#line 3972 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
        break;

      default:
        break;
    }
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* string_constant: TOKEN_STRING_LITERAL  */
#line 450 "src/parse.yy"
    {
        (yyval.stringVal) = new std::string(*(yyvsp[0].stringVal));
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 4273 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 3: /* string_constant: string_constant TOKEN_STRING_LITERAL  */
#line 455 "src/parse.yy"
    {
        std::string *p_str_cst = new std::string();
        p_str_cst->append(*(yyvsp[-1].stringVal));
        p_str_cst->append(*(yyvsp[0].stringVal));
        (yyval.stringVal) = p_str_cst;
        // Allocated in lStringConst
        lCleanUpString((yyvsp[-1].stringVal));
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 4287 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 4: /* primary_expression: TOKEN_IDENTIFIER  */
#line 467 "src/parse.yy"
                       {
        const char *name = (yyvsp[0].stringVal)->c_str();
        Symbol *s = m->symbolTable->LookupVariable(name);
        (yyval.expr) = nullptr;
        if (s)
            (yyval.expr) = new SymbolExpr(s, (yylsp[0]));
        else {
            std::vector<Symbol *> funs;
            m->symbolTable->LookupFunction(name, &funs);
            if (funs.size() > 0)
                (yyval.expr) = new FunctionSymbolExpr(name, funs, {}, TemplateArgs(), (yylsp[0]));
        }
        if ((yyval.expr) == nullptr) {
            std::vector<std::string> alternates =
                m->symbolTable->ClosestVariableOrFunctionMatch(name);
            std::string alts = lGetAlternates(alternates);
            Error((yylsp[0]), "Undeclared symbol \"%s\".%s", name, alts.c_str());
        }
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 4312 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 5: /* primary_expression: TOKEN_INT8_CONSTANT  */
#line 487 "src/parse.yy"
                          {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt8->GetAsConstType(),
                           (int8_t)yylval.intVal, (yylsp[0]));
    }
#line 4321 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 6: /* primary_expression: TOKEN_UINT8_CONSTANT  */
#line 491 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt8->GetAsConstType(),
                           (uint8_t)yylval.intVal, (yylsp[0]));
    }
#line 4330 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 7: /* primary_expression: TOKEN_INT16_CONSTANT  */
#line 495 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt16->GetAsConstType(),
                           (int16_t)yylval.intVal, (yylsp[0]));
    }
#line 4339 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 8: /* primary_expression: TOKEN_UINT16_CONSTANT  */
#line 499 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt16->GetAsConstType(),
                           (uint16_t)yylval.intVal, (yylsp[0]));
    }
#line 4348 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 9: /* primary_expression: TOKEN_INT32_CONSTANT  */
#line 503 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 4357 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 10: /* primary_expression: TOKEN_UINT32_CONSTANT  */
#line 507 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 4366 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 11: /* primary_expression: TOKEN_INT64_CONSTANT  */
#line 511 "src/parse.yy"
                           {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 4375 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 12: /* primary_expression: TOKEN_UINT64_CONSTANT  */
#line 515 "src/parse.yy"
                            {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 4384 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 13: /* primary_expression: TOKEN_FLOAT16_CONSTANT  */
#line 519 "src/parse.yy"
                             {
         std::string sval = *(yyvsp[0].stringVal);
         lCleanUpString((yyvsp[0].stringVal));
         llvm::Type *hType = llvm::Type::getHalfTy(*g->ctx);
         const llvm::fltSemantics &FS = hType->getFltSemantics();
         llvm::APFloat f16(FS, sval);
         (yyval.expr) = new ConstExpr(AtomicType::UniformFloat16->GetAsConstType(),
                           f16, (yylsp[0]));
    }
#line 4398 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 14: /* primary_expression: TOKEN_FLOAT_CONSTANT  */
#line 528 "src/parse.yy"
                           {
        llvm::APFloat f(yylval.floatVal);
        (yyval.expr) = new ConstExpr(AtomicType::UniformFloat->GetAsConstType(),
                           f, (yylsp[0]));
    }
#line 4408 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 15: /* primary_expression: TOKEN_DOUBLE_CONSTANT  */
#line 533 "src/parse.yy"
                            {
        llvm::APFloat d(yylval.doubleVal);
        (yyval.expr) = new ConstExpr(AtomicType::UniformDouble->GetAsConstType(),
                           d, (yylsp[0]));
    }
#line 4418 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 16: /* primary_expression: TOKEN_TRUE  */
#line 538 "src/parse.yy"
                 {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), true, (yylsp[0]));
    }
#line 4426 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 17: /* primary_expression: TOKEN_FALSE  */
#line 541 "src/parse.yy"
                  {
        (yyval.expr) = new ConstExpr(AtomicType::UniformBool->GetAsConstType(), false, (yylsp[0]));
    }
#line 4434 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 18: /* primary_expression: TOKEN_NULL  */
#line 544 "src/parse.yy"
                 {
        (yyval.expr) = new NullPointerExpr((yylsp[0]));
    }
#line 4442 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 19: /* primary_expression: '(' expression ')'  */
#line 549 "src/parse.yy"
                         { (yyval.expr) = (yyvsp[-1].expr); }
#line 4448 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 20: /* primary_expression: '(' error ')'  */
#line 550 "src/parse.yy"
                    { (yyval.expr) = nullptr; }
#line 4454 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 21: /* launch_expression: TOKEN_LAUNCH postfix_expression '(' argument_expression_list ')'  */
#line 555 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]), (yylsp[0])), true, launchCount);
      }
#line 4464 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 22: /* launch_expression: TOKEN_LAUNCH postfix_expression '(' ')'  */
#line 561 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {oneExpr, oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-1]),(yylsp[0]))), Union((yylsp[-2]), (yylsp[0])), true, launchCount);
       }
#line 4474 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 23: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 568 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 4484 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 24: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 574 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), oneExpr, oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 4494 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 25: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 581 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-7].expr), (yyvsp[-5].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 4504 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 26: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ']' postfix_expression '(' ')'  */
#line 587 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-6].expr), (yyvsp[-4].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 4514 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 27: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 593 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-3]));
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 4524 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 28: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 599 "src/parse.yy"
      {
          ConstExpr *oneExpr = new ConstExpr(AtomicType::UniformInt32, (int32_t)1, (yylsp[-2]));
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), oneExpr};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 4534 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 29: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ',' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 606 "src/parse.yy"
      {
          Expr *launchCount[3] = {(yyvsp[-9].expr), (yyvsp[-7].expr), (yyvsp[-5].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 4543 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 30: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ',' assignment_expression ',' assignment_expression ']' postfix_expression '(' ')'  */
#line 611 "src/parse.yy"
      {
          Expr *launchCount[3] = {(yyvsp[-8].expr), (yyvsp[-6].expr), (yyvsp[-4].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 4552 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 31: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' argument_expression_list ')'  */
#line 616 "src/parse.yy"
      {
          Expr *launchCount[3] = {(yyvsp[-5].expr), (yyvsp[-8].expr), (yyvsp[-11].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])), true, launchCount);
      }
#line 4561 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 32: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '[' assignment_expression ']' '[' assignment_expression ']' postfix_expression '(' ')'  */
#line 621 "src/parse.yy"
      {
          Expr *launchCount[3] = {(yyvsp[-4].expr), (yyvsp[-7].expr), (yyvsp[-10].expr)};
          (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])), true, launchCount);
      }
#line 4570 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 33: /* launch_expression: TOKEN_LAUNCH '<' postfix_expression '(' argument_expression_list ')' '>'  */
#line 628 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = nullptr;
       }
#line 4580 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 34: /* launch_expression: TOKEN_LAUNCH '<' postfix_expression '(' ')' '>'  */
#line 634 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = nullptr;
       }
#line 4590 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 35: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '<' postfix_expression '(' argument_expression_list ')' '>'  */
#line 640 "src/parse.yy"
       {
          Error(Union((yylsp[-5]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = nullptr;
       }
#line 4600 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 36: /* launch_expression: TOKEN_LAUNCH '[' assignment_expression ']' '<' postfix_expression '(' ')' '>'  */
#line 646 "src/parse.yy"
       {
          Error(Union((yylsp[-4]), (yylsp[0])), "\"launch\" expressions no longer take '<' '>' "
                "around function call expression.");
          (yyval.expr) = nullptr;
       }
#line 4610 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 37: /* invoke_sycl_expression: TOKEN_INVOKE_SYCL '(' postfix_expression ')'  */
#line 655 "src/parse.yy"
      {
          (yyval.expr) = new FunctionCallExpr((yyvsp[-1].expr), new ExprList((yylsp[0])), Union((yylsp[-3]),(yylsp[0])), false, nullptr, true);
      }
#line 4618 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 38: /* invoke_sycl_expression: TOKEN_INVOKE_SYCL '(' postfix_expression ',' argument_expression_list ')'  */
#line 659 "src/parse.yy"
      {
          (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-5]),(yylsp[0])), false, nullptr, true);
      }
#line 4626 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 39: /* invoke_sycl_expression: TOKEN_INVOKE_SYCL '(' error ')'  */
#line 663 "src/parse.yy"
      { (yyval.expr) = nullptr; }
#line 4632 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 41: /* postfix_expression: postfix_expression '[' expression ']'  */
#line 669 "src/parse.yy"
      { (yyval.expr) = new IndexExpr((yyvsp[-3].expr), (yyvsp[-1].expr), Union((yylsp[-3]),(yylsp[0]))); }
#line 4638 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 42: /* postfix_expression: postfix_expression '[' error ']'  */
#line 671 "src/parse.yy"
      { (yyval.expr) = nullptr; }
#line 4644 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 44: /* postfix_expression: postfix_expression '.' TOKEN_IDENTIFIER  */
#line 674 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), false);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 4653 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 45: /* postfix_expression: postfix_expression '.' TOKEN_TYPE_NAME  */
#line 681 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), false);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 4662 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 46: /* postfix_expression: postfix_expression '.' TOKEN_TEMPLATE_NAME  */
#line 686 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), false);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 4671 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 47: /* postfix_expression: postfix_expression TOKEN_PTR_OP TOKEN_IDENTIFIER  */
#line 691 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), true);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 4680 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 48: /* postfix_expression: postfix_expression TOKEN_PTR_OP TOKEN_TYPE_NAME  */
#line 698 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), true);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 4689 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 49: /* postfix_expression: postfix_expression TOKEN_PTR_OP TOKEN_TEMPLATE_NAME  */
#line 703 "src/parse.yy"
      {
          (yyval.expr) = MemberExpr::create((yyvsp[-2].expr), yytext, Union((yylsp[-2]),(yylsp[0])), (yylsp[0]), true);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 4698 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 50: /* postfix_expression: postfix_expression TOKEN_INC_OP  */
#line 708 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostInc, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 4704 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 51: /* postfix_expression: postfix_expression TOKEN_DEC_OP  */
#line 710 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PostDec, (yyvsp[-1].expr), Union((yylsp[-1]),(yylsp[0]))); }
#line 4710 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 52: /* intrinsic_name: TOKEN_INTRINSIC_CALL  */
#line 715 "src/parse.yy"
      {
          (yyval.stringVal) = (yyvsp[0].stringVal);
      }
#line 4718 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 53: /* intrincall_expression: intrinsic_name '(' ')'  */
#line 722 "src/parse.yy"
      {
          std::string *name = (yyvsp[-2].stringVal);
          name->erase(0, 1);
          Symbol* sym = m->AddLLVMIntrinsicDecl(*name, nullptr, Union((yylsp[-2]),(yylsp[0])));
          const char *fname = name->c_str();
          const std::vector<Symbol *> funcs{sym};
          FunctionSymbolExpr *fSym = nullptr;
          if (sym != nullptr)
              fSym = new FunctionSymbolExpr(fname, funcs, {}, TemplateArgs(), (yylsp[-2]));
          (yyval.expr) = new FunctionCallExpr(fSym, new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])));
          delete name;
      }
#line 4735 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 54: /* intrincall_expression: intrinsic_name '(' argument_expression_list ')'  */
#line 735 "src/parse.yy"
      {
          std::string *name = (yyvsp[-3].stringVal);
          name->erase(0, 1);
          Symbol* sym = m->AddLLVMIntrinsicDecl(*name, (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])));
          const char *fname = name->c_str();
          const std::vector<Symbol *> funcs{sym};
          FunctionSymbolExpr *fSym = nullptr;
          if (sym != nullptr)
              fSym = new FunctionSymbolExpr(fname, funcs, {}, TemplateArgs(), (yylsp[-3]));
          (yyval.expr) = new FunctionCallExpr(fSym, (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])));
          delete name;
      }
#line 4752 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 56: /* funcall_expression: postfix_expression '(' ')'  */
#line 752 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-2].expr), new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0]))); }
#line 4758 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 57: /* funcall_expression: postfix_expression '(' argument_expression_list ')'  */
#line 754 "src/parse.yy"
      { (yyval.expr) = new FunctionCallExpr((yyvsp[-3].expr), (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0]))); }
#line 4764 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 58: /* funcall_expression: postfix_expression '(' error ')'  */
#line 756 "src/parse.yy"
      { (yyval.expr) = nullptr; }
#line 4770 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 59: /* funcall_expression: simple_template_id '(' ')'  */
#line 758 "src/parse.yy"
      {
          // Create FunctionSymbolExpr with a candidate functions list
          Expr *functionSymbolExpr = nullptr;
          const std::string name = (yyvsp[-2].simpleTemplateID)->first->name;
          std::vector<Symbol *> funcs;
          m->symbolTable->LookupFunction(name.c_str(), &funcs);
          std::vector<TemplateSymbol *> funcTempls;
          m->symbolTable->LookupFunctionTemplate(name, &funcTempls);
          if (funcs.size() > 0 || funcTempls.size() > 0) {
              TemplateArgs *templArgs = (yyvsp[-2].simpleTemplateID)->second;
              Assert(templArgs);
              functionSymbolExpr = new FunctionSymbolExpr(name.c_str(), funcs, funcTempls, *templArgs, (yylsp[-2]));
              (yyval.expr) = new FunctionCallExpr(functionSymbolExpr, new ExprList(Union((yylsp[-2]),(yylsp[-1]))), Union((yylsp[-2]),(yylsp[0])));
          } else {
              Error((yylsp[-2]), "No matching functions were declared.");
              (yyval.expr) = nullptr;
          }

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID((yyvsp[-2].simpleTemplateID));
      }
#line 4796 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 60: /* funcall_expression: simple_template_id '(' argument_expression_list ')'  */
#line 780 "src/parse.yy"
      {
          // Create FunctionSymbolExpr with a candidate functions list
          Expr *functionSymbolExpr = nullptr;
          const std::string name = (yyvsp[-3].simpleTemplateID)->first->name;
          std::vector<Symbol *> funcs;
          m->symbolTable->LookupFunction(name.c_str(), &funcs);
          std::vector<TemplateSymbol *> funcTempls;
          m->symbolTable->LookupFunctionTemplate(name, &funcTempls);
          if (funcs.size() > 0 || funcTempls.size() > 0) {
              TemplateArgs *templArgs = (yyvsp[-3].simpleTemplateID)->second;
              Assert(templArgs);
              functionSymbolExpr = new FunctionSymbolExpr(name.c_str(), funcs, funcTempls, *templArgs, (yylsp[-3]));
              (yyval.expr) = new FunctionCallExpr(functionSymbolExpr, (yyvsp[-1].exprList), Union((yylsp[-3]),(yylsp[0])));
          } else {
              Error((yylsp[-3]), "No matching functions were declared.");
              (yyval.expr) = nullptr;
          }

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID((yyvsp[-3].simpleTemplateID));
      }
#line 4822 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 61: /* funcall_expression: simple_template_id '(' error ')'  */
#line 802 "src/parse.yy"
      {
          (yyval.expr) = nullptr;

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID((yyvsp[-3].simpleTemplateID));
      }
#line 4833 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 62: /* argument_expression_list: assignment_expression  */
#line 811 "src/parse.yy"
                                 { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 4839 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 63: /* argument_expression_list: argument_expression_list ',' assignment_expression  */
#line 813 "src/parse.yy"
      {
          ExprList *argList = llvm::dyn_cast<ExprList>((yyvsp[-2].exprList));
          if (argList == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              argList = new ExprList((yylsp[0]));
          }
          argList->exprs.push_back((yyvsp[0].expr));
          argList->pos = Union(argList->pos, (yylsp[0]));
          (yyval.exprList) = argList;
      }
#line 4854 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 67: /* unary_expression: TOKEN_INC_OP unary_expression  */
#line 830 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreInc, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 4860 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 68: /* unary_expression: TOKEN_DEC_OP unary_expression  */
#line 832 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::PreDec, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 4866 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 69: /* unary_expression: '&' unary_expression  */
#line 834 "src/parse.yy"
      { (yyval.expr) = new AddressOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 4872 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 70: /* unary_expression: '*' unary_expression  */
#line 836 "src/parse.yy"
      { (yyval.expr) = new PtrDerefExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 4878 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 71: /* unary_expression: '+' cast_expression  */
#line 838 "src/parse.yy"
      { (yyval.expr) = (yyvsp[0].expr); }
#line 4884 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 72: /* unary_expression: '-' cast_expression  */
#line 840 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::Negate, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 4890 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 73: /* unary_expression: '~' cast_expression  */
#line 842 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::BitNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 4896 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 74: /* unary_expression: '!' cast_expression  */
#line 844 "src/parse.yy"
      { (yyval.expr) = new UnaryExpr(UnaryExpr::LogicalNot, (yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 4902 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 75: /* unary_expression: TOKEN_SIZEOF unary_expression  */
#line 846 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[0].expr), Union((yylsp[-1]), (yylsp[0]))); }
#line 4908 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 76: /* unary_expression: TOKEN_SIZEOF '(' type_name ')'  */
#line 848 "src/parse.yy"
      { (yyval.expr) = new SizeOfExpr((yyvsp[-1].type), Union((yylsp[-3]), (yylsp[0]))); }
#line 4914 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 77: /* unary_expression: TOKEN_ALLOCA '(' assignment_expression ')'  */
#line 850 "src/parse.yy"
      {
          (yyval.expr) = new AllocaExpr((yyvsp[-1].expr), Union((yylsp[-3]), (yylsp[0])));
      }
#line 4922 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 79: /* cast_expression: '(' type_name ')' cast_expression  */
#line 858 "src/parse.yy"
      {
          (yyval.expr) = new TypeCastExpr((yyvsp[-2].type), (yyvsp[0].expr), Union((yylsp[-3]),(yylsp[0])));
      }
#line 4930 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 81: /* multiplicative_expression: multiplicative_expression '*' cast_expression  */
#line 866 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mul, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4936 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 82: /* multiplicative_expression: multiplicative_expression '/' cast_expression  */
#line 868 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Div, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4942 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 83: /* multiplicative_expression: multiplicative_expression '%' cast_expression  */
#line 870 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Mod, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4948 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 85: /* additive_expression: additive_expression '+' multiplicative_expression  */
#line 876 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Add, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4954 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 86: /* additive_expression: additive_expression '-' multiplicative_expression  */
#line 878 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Sub, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4960 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 88: /* shift_expression: shift_expression TOKEN_LEFT_OP additive_expression  */
#line 884 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shl, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4966 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 89: /* shift_expression: shift_expression TOKEN_RIGHT_OP additive_expression  */
#line 886 "src/parse.yy"
      { (yyval.expr) = MakeBinaryExpr(BinaryExpr::Shr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4972 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 91: /* relational_expression: relational_expression '<' shift_expression  */
#line 892 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Lt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4978 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 92: /* relational_expression: relational_expression '>' shift_expression  */
#line 894 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Gt, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4984 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 93: /* relational_expression: relational_expression TOKEN_LE_OP shift_expression  */
#line 896 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Le, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4990 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 94: /* relational_expression: relational_expression TOKEN_GE_OP shift_expression  */
#line 898 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Ge, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 4996 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 96: /* equality_expression: equality_expression TOKEN_EQ_OP relational_expression  */
#line 904 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Equal, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 5002 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 97: /* equality_expression: equality_expression TOKEN_NE_OP relational_expression  */
#line 906 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::NotEqual, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]),(yylsp[0]))); }
#line 5008 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 99: /* and_expression: and_expression '&' equality_expression  */
#line 912 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5014 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 101: /* exclusive_or_expression: exclusive_or_expression '^' and_expression  */
#line 918 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitXor, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5020 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 103: /* inclusive_or_expression: inclusive_or_expression '|' exclusive_or_expression  */
#line 924 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::BitOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5026 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 105: /* logical_and_expression: logical_and_expression TOKEN_AND_OP inclusive_or_expression  */
#line 930 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalAnd, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5032 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 107: /* logical_or_expression: logical_or_expression TOKEN_OR_OP logical_and_expression  */
#line 936 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::LogicalOr, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5038 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 109: /* conditional_expression: logical_or_expression '?' expression ':' conditional_expression  */
#line 942 "src/parse.yy"
      { (yyval.expr) = new SelectExpr((yyvsp[-4].expr), (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-4]),(yylsp[0]))); }
#line 5044 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 110: /* rate_qualified_new: TOKEN_NEW  */
#line 946 "src/parse.yy"
                { (yyval.intVal) = 0; }
#line 5050 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 111: /* rate_qualified_new: TOKEN_UNIFORM TOKEN_NEW  */
#line 947 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_UNIFORM; }
#line 5056 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 112: /* rate_qualified_new: TOKEN_VARYING TOKEN_NEW  */
#line 948 "src/parse.yy"
                              { (yyval.intVal) = TYPEQUAL_VARYING; }
#line 5062 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 113: /* rate_qualified_type_specifier: type_specifier  */
#line 952 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].type); }
#line 5068 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 114: /* rate_qualified_type_specifier: TOKEN_UNIFORM type_specifier  */
#line 954 "src/parse.yy"
    {
        if ((yyvsp[0].type) == nullptr)
            (yyval.type) = nullptr;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
            (yyval.type) = nullptr;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
    }
#line 5083 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 115: /* rate_qualified_type_specifier: TOKEN_VARYING type_specifier  */
#line 965 "src/parse.yy"
    {
        if ((yyvsp[0].type) == nullptr)
            (yyval.type) = nullptr;
        else if ((yyvsp[0].type)->IsVoidType()) {
            Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
            (yyval.type) = nullptr;
        }
        else
            (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
    }
#line 5098 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 116: /* rate_qualified_type_specifier: soa_width_specifier type_specifier  */
#line 976 "src/parse.yy"
    {
        if ((yyvsp[0].type) == nullptr)
            (yyval.type) = nullptr;
        else {
            int soaWidth = (int)(yyvsp[-1].intVal);
            const StructType *st = CastType<StructType>((yyvsp[0].type));
            if (st == nullptr) {
                Error((yylsp[-1]), "\"soa\" qualifier is illegal with non-struct type \"%s\".",
                      (yyvsp[0].type)->GetString().c_str());
                (yyval.type) = nullptr;
            }
            else if (soaWidth <= 0 || (soaWidth & (soaWidth - 1)) != 0) {
                Error((yylsp[-1]), "soa<%d> width illegal. Value must be positive power "
                      "of two.", soaWidth);
                (yyval.type) = nullptr;
            }
            else
                (yyval.type) = st->GetAsSOAType(soaWidth);
        }
    }
#line 5123 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 118: /* new_expression: rate_qualified_new rate_qualified_type_specifier  */
#line 1001 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-1].intVal), (yyvsp[0].type), nullptr, nullptr, (yylsp[-1]), Union((yylsp[-1]), (yylsp[0])));
    }
#line 5131 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 119: /* new_expression: rate_qualified_new rate_qualified_type_specifier '(' initializer_list ')'  */
#line 1005 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), (yyvsp[-1].exprList), nullptr, (yylsp[-4]), Union((yylsp[-4]), (yylsp[-3])));
    }
#line 5139 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 120: /* new_expression: rate_qualified_new rate_qualified_type_specifier '[' expression ']'  */
#line 1009 "src/parse.yy"
    {
        (yyval.expr) = new NewExpr((int32_t)(yyvsp[-4].intVal), (yyvsp[-3].type), nullptr, (yyvsp[-1].expr), (yylsp[-4]), Union((yylsp[-4]), (yylsp[-1])));
    }
#line 5147 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 122: /* assignment_expression: unary_expression '=' assignment_expression  */
#line 1017 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::Assign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5153 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 123: /* assignment_expression: unary_expression TOKEN_MUL_ASSIGN assignment_expression  */
#line 1019 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::MulAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5159 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 124: /* assignment_expression: unary_expression TOKEN_DIV_ASSIGN assignment_expression  */
#line 1021 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::DivAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5165 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 125: /* assignment_expression: unary_expression TOKEN_MOD_ASSIGN assignment_expression  */
#line 1023 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ModAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5171 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 126: /* assignment_expression: unary_expression TOKEN_ADD_ASSIGN assignment_expression  */
#line 1025 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AddAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5177 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 127: /* assignment_expression: unary_expression TOKEN_SUB_ASSIGN assignment_expression  */
#line 1027 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::SubAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5183 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 128: /* assignment_expression: unary_expression TOKEN_LEFT_ASSIGN assignment_expression  */
#line 1029 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShlAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5189 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 129: /* assignment_expression: unary_expression TOKEN_RIGHT_ASSIGN assignment_expression  */
#line 1031 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::ShrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5195 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 130: /* assignment_expression: unary_expression TOKEN_AND_ASSIGN assignment_expression  */
#line 1033 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::AndAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5201 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 131: /* assignment_expression: unary_expression TOKEN_XOR_ASSIGN assignment_expression  */
#line 1035 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::XorAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5207 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 132: /* assignment_expression: unary_expression TOKEN_OR_ASSIGN assignment_expression  */
#line 1037 "src/parse.yy"
      { (yyval.expr) = new AssignExpr(AssignExpr::OrAssign, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5213 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 133: /* assignment_expression: template_identifier  */
#line 1038 "src/parse.yy"
                          {
        // It looks like the proper place is under primary_expression, but
        // there are reduce/reduce conflicts there. So, we handle it here.
        const std::string name = (yyvsp[0].constCharPtr);
        std::vector<Symbol *> funcs;
        m->symbolTable->LookupFunction(name.c_str(), &funcs);
        std::vector<TemplateSymbol *> funcTempls;
        m->symbolTable->LookupFunctionTemplate(name, &funcTempls);
        if (funcs.size() > 0 || funcTempls.size() > 0) {
            (yyval.expr) = new FunctionSymbolExpr(name.c_str(), funcs, funcTempls, TemplateArgs(), (yylsp[0]));
        } else {
            Error((yylsp[0]), "No matching functions were declared.");
            (yyval.expr) = nullptr;
        }

        // deallocate template identifier str
        free((void*)(yyvsp[0].constCharPtr));
      }
#line 5236 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 135: /* expression: expression ',' assignment_expression  */
#line 1061 "src/parse.yy"
      { (yyval.expr) = new BinaryExpr(BinaryExpr::Comma, (yyvsp[-2].expr), (yyvsp[0].expr), Union((yylsp[-2]), (yylsp[0]))); }
#line 5242 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 137: /* declaration_statement: declaration  */
#line 1070 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) == nullptr) {
            AssertPos((yylsp[0]), m->errorCount > 0);
            (yyval.stmt) = nullptr;
        }
        else if ((yyvsp[0].declaration)->declSpecs->storageClass.IsTypedef()) {
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i) {
                if ((yyvsp[0].declaration)->declarators[i] == nullptr)
                    AssertPos((yylsp[0]), m->errorCount > 0);
                else
                    m->AddTypeDef((yyvsp[0].declaration)->declarators[i]->name,
                                  (yyvsp[0].declaration)->declarators[i]->type,
                                  (yyvsp[0].declaration)->declarators[i]->pos);
            }
            (yyval.stmt) = nullptr;
        }
        else {
            (yyvsp[0].declaration)->DeclareFunctions();
            std::vector<VariableDeclaration> vars = (yyvsp[0].declaration)->GetVariableDeclarations();
            (yyval.stmt) = new DeclStmt(vars, (yylsp[0]));
        }
    }
#line 5269 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 138: /* declaration: declaration_specifiers ';'  */
#line 1096 "src/parse.yy"
      {
          DeclSpecs *ds = (yyvsp[-1].declSpecs);
          if (ds && ds->attributeList && ds->attributeList->HasAttribute("aligned")) {

              std::string name;
              const Type *t = ds->baseType;
              if (CastType<StructType>(t)) {
                  name = CastType<StructType>(t)->GetStructName();
              } else if (CastType<UndefinedStructType>(t)) {
                  name = CastType<UndefinedStructType>(t)->GetStructName();
              }

              if (!name.empty()) {
                  Warning((yylsp[-1]), "attribute ignored in declaration of 'struct %s'. It must follow the 'struct' keyword.",
                          name.c_str());
              }
          }
          (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs));
      }
#line 5293 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 139: /* declaration: declaration_specifiers init_declarator_list ';'  */
#line 1116 "src/parse.yy"
      {
          (yyval.declaration) = new Declaration((yyvsp[-2].declSpecs), (yyvsp[-1].declarators));
          // init_declarator_list returns vector of declarators, its copy is
          // saved in Declaration constructor, so it is not needed anymore.
          delete (yyvsp[-1].declarators);
      }
#line 5304 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 140: /* soa_width_specifier: TOKEN_SOA '<' int_constant '>'  */
#line 1126 "src/parse.yy"
      { (yyval.intVal) = (yyvsp[-1].intVal); }
#line 5310 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 141: /* declspec_item: TOKEN_IDENTIFIER  */
#line 1131 "src/parse.yy"
    {
        std::pair<std::string, SourcePos> *p = new std::pair<std::string, SourcePos>;
        p->first = *(yyvsp[0].stringVal);
        p->second = (yylsp[0]);
        (yyval.declspecPair) = p;
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 5322 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 142: /* declspec_list: declspec_item  */
#line 1142 "src/parse.yy"
    {
        (yyval.declspecList) = new std::vector<std::pair<std::string, SourcePos> >;
        (yyval.declspecList)->push_back(*(yyvsp[0].declspecPair));
        // declspec_item returns pair that was copied so it is not needed anymore.
        delete (yyvsp[0].declspecPair);
    }
#line 5333 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 143: /* declspec_list: declspec_list ',' declspec_item  */
#line 1149 "src/parse.yy"
    {
        if ((yyvsp[-2].declspecList) != nullptr) {
            (yyvsp[-2].declspecList)->push_back(*(yyvsp[0].declspecPair));
            // declspec_item returns pair that was copied so it is not needed anymore.
            delete (yyvsp[0].declspecPair);
        }
        (yyval.declspecList) = (yyvsp[-2].declspecList);
    }
#line 5346 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 144: /* declspec_specifier: TOKEN_DECLSPEC '(' declspec_list ')'  */
#line 1161 "src/parse.yy"
    {
        // declspec_list returns heap allocated vector that passed up here.
        (yyval.declspecList) = (yyvsp[-1].declspecList);
    }
#line 5355 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 145: /* declaration_specifiers: storage_class_specifier  */
#line 1169 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(nullptr, *(yyvsp[0].storageClass));
          delete (yyvsp[0].storageClass);
      }
#line 5364 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 146: /* declaration_specifiers: storage_class_specifier declaration_specifiers  */
#line 1174 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != nullptr) {
              if (!ds->storageClass.IsNone())
                  Error((yylsp[-1]), "Multiple storage class specifiers in a declaration are illegal. "
                        "(Have provided both \"%s\" and \"%s\".)",
                        ds->storageClass.GetString().c_str(),
                        (yyvsp[-1].storageClass)->GetString().c_str());
              else
                  ds->storageClass = *(yyvsp[-1].storageClass);
          }
          (yyval.declSpecs) = ds;
          delete (yyvsp[-1].storageClass);
      }
#line 5383 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 147: /* declaration_specifiers: declspec_specifier  */
#line 1189 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs;
          if ((yyvsp[0].declspecList) != nullptr) {
              (yyval.declSpecs)->declSpecList = *(yyvsp[0].declspecList);
              // declspec_specifier returns a vector that was copied and it is not needed anymore.
              delete (yyvsp[0].declspecList);
          }
      }
#line 5396 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 148: /* declaration_specifiers: declspec_specifier declaration_specifiers  */
#line 1198 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          std::vector<std::pair<std::string, SourcePos> > *declSpecList = (yyvsp[-1].declspecList);
          if (ds != nullptr && declSpecList != nullptr) {
              for (int i = 0; i < (int)declSpecList->size(); ++i)
                  ds->declSpecList.push_back((*declSpecList)[i]);

              // declspec_specifier returns a vector that was copied and it is not needed anymore.
              delete declSpecList;
          }
          (yyval.declSpecs) = ds;
      }
#line 5413 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 149: /* declaration_specifiers: soa_width_specifier  */
#line 1211 "src/parse.yy"
      {
          DeclSpecs *ds = new DeclSpecs;
          ds->soaWidth = (int32_t)(yyvsp[0].intVal);
          (yyval.declSpecs) = ds;
      }
#line 5423 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 150: /* declaration_specifiers: soa_width_specifier declaration_specifiers  */
#line 1217 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != nullptr) {
              if (ds->soaWidth != 0)
                  Error((yylsp[-1]), "soa<> qualifier supplied multiple times in declaration.");
              else
                  ds->soaWidth = (int32_t)(yyvsp[-1].intVal);
          }
          (yyval.declSpecs) = ds;
      }
#line 5438 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 151: /* declaration_specifiers: type_specifier  */
#line 1228 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs((yyvsp[0].type));
      }
#line 5446 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 152: /* declaration_specifiers: type_specifier '<' int_constant '>'  */
#line 1232 "src/parse.yy"
    {
          DeclSpecs *ds = new DeclSpecs((yyvsp[-3].type));
          ds->vectorSize = (int32_t)(yyvsp[-1].intVal);
          (yyval.declSpecs) = ds;
    }
#line 5456 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 153: /* declaration_specifiers: type_specifier '<' TOKEN_IDENTIFIER '>'  */
#line 1238 "src/parse.yy"
    {
          DeclSpecs *ds = new DeclSpecs((yyvsp[-3].type));
          const char *name = (yyvsp[-1].stringVal)->c_str();
          Symbol *s = m->symbolTable->LookupVariable(name);
          if (s) {
            ds->vectorSize = s;
          } else {
            Error((yylsp[-1]), "Unknown identifier \"%s\" is used to specify the size of a vector type.", name);
          }
          (yyval.declSpecs) = ds;
          lCleanUpString((yyvsp[-1].stringVal));
    }
#line 5473 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 154: /* declaration_specifiers: type_specifier declaration_specifiers  */
#line 1251 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != nullptr) {
              if (ds->baseType != nullptr) {
                  if( ds->baseType->IsUnsignedType()) {
                      Error((yylsp[-1]), "Redefining uint8/uint16/uint32/uint64 type "
                      "which is part of ISPC language since version 1.13. "
                      "Remove this typedef or use ISPC_UINT_IS_DEFINED to "
                      "detect that these types are defined.");
                  } else if (CastType<StructType>(ds->baseType)) {
                      // Skip the error if the base type is a struct type to
                      // support typedef struct foo { } foo;
                      ;
                  } else
                      Error((yylsp[-1]), "Multiple types provided for declaration.");
              }
              ds->baseType = (yyvsp[-1].type);
          }
          (yyval.declSpecs) = ds;
      }
#line 5498 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 155: /* declaration_specifiers: type_qualifier  */
#line 1272 "src/parse.yy"
      {
          (yyval.declSpecs) = new DeclSpecs(nullptr, StorageClass::NONE, (yyvsp[0].typeQualifier));
      }
#line 5506 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 156: /* declaration_specifiers: type_qualifier declaration_specifiers  */
#line 1276 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          if (ds != nullptr)
              ds->typeQualifiers |= (yyvsp[-1].typeQualifier);
          (yyval.declSpecs) = ds;
      }
#line 5517 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 157: /* declaration_specifiers: attribute_specifier  */
#line 1283 "src/parse.yy"
      {
          AttributeList *al = (yyvsp[0].attributeList);
          DeclSpecs *ds = new DeclSpecs();
          if (al) {
              ds->AddAttrList(*al);
              delete al;
          }
          (yyval.declSpecs) = ds;
      }
#line 5531 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 158: /* declaration_specifiers: attribute_specifier declaration_specifiers  */
#line 1293 "src/parse.yy"
      {
          DeclSpecs *ds = (DeclSpecs *)(yyvsp[0].declSpecs);
          AttributeList *al = (yyvsp[-1].attributeList);
          if (ds && al) {
              ds->AddAttrList(*al);
              delete al;
          }
          (yyval.declSpecs) = ds;
      }
#line 5545 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 159: /* attribute_specifier: TOKEN_ATTRIBUTE '(' '(' attribute_list ')' ')'  */
#line 1306 "src/parse.yy"
      {
          (yyval.attributeList) = (yyvsp[-2].attributeList);
      }
#line 5553 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 160: /* attribute_list: attribute  */
#line 1313 "src/parse.yy"
      {
          Attribute *attr = (yyvsp[0].attr);
          AttributeList *al = new AttributeList;
          al->AddAttribute(*attr);
          (yyval.attributeList) = al;
          delete attr;
      }
#line 5565 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 161: /* attribute_list: attribute_list ',' attribute  */
#line 1321 "src/parse.yy"
      {
          Attribute *attr = (yyvsp[0].attr);
          AttributeList *al = (yyvsp[-2].attributeList);
          al->AddAttribute(*attr);
          (yyval.attributeList) = al;
          delete attr;
      }
#line 5577 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 162: /* attribute: TOKEN_IDENTIFIER  */
#line 1332 "src/parse.yy"
      {
          std::string *str = (yyvsp[0].stringVal);;
          (yyval.attr) = new Attribute(*str);
          // cleanup TOKEN_IDENTIFIER string
          lCleanUpString(str);
      }
#line 5588 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 163: /* attribute: TOKEN_IDENTIFIER '(' attribute_argument ')'  */
#line 1339 "src/parse.yy"
      {
          std::string *str = (yyvsp[-3].stringVal);;
          AttrArgument *arg = (yyvsp[-1].attrArg);
          (yyval.attr) = new Attribute(*str, *arg);
          delete arg;
          // cleanup TOKEN_IDENTIFIER string
          lCleanUpString(str);
      }
#line 5601 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 164: /* attribute_argument: int_constant  */
#line 1351 "src/parse.yy"
      {
          (yyval.attrArg) = new AttrArgument((yyvsp[0].intVal));
      }
#line 5609 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 165: /* attribute_argument: string_constant  */
#line 1355 "src/parse.yy"
      {
          std::string *str = (yyvsp[0].stringVal);;
          (yyval.attrArg) = new AttrArgument(*str);
          // deallocate std::string of string_constant
          lCleanUpString(str);
      }
#line 5620 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 166: /* init_declarator_list: init_declarator  */
#line 1365 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != nullptr)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 5631 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 167: /* init_declarator_list: init_declarator_list ',' init_declarator  */
#line 1372 "src/parse.yy"
      {
          std::vector<Declarator *> *dl = (std::vector<Declarator *> *)(yyvsp[-2].declarators);
          if (dl == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              dl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != nullptr)
              dl->push_back((yyvsp[0].declarator));
          (yyval.declarators) = dl;
      }
#line 5646 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 169: /* init_declarator: declarator '=' initializer  */
#line 1387 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != nullptr)
              (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
          (yyval.declarator) = (yyvsp[-2].declarator);
      }
#line 5656 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 170: /* storage_class_specifier: TOKEN_TYPEDEF  */
#line 1395 "src/parse.yy"
                    { (yyval.storageClass) = new StorageClass(StorageClass::TYPEDEF); }
#line 5662 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 171: /* storage_class_specifier: TOKEN_EXTERN  */
#line 1396 "src/parse.yy"
                   { (yyval.storageClass) = new StorageClass(StorageClass::EXT); }
#line 5668 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 172: /* storage_class_specifier: TOKEN_EXTERN TOKEN_STRING_C_LITERAL  */
#line 1397 "src/parse.yy"
                                           { (yyval.storageClass) = new StorageClass(StorageClass::EXT_C); }
#line 5674 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 173: /* storage_class_specifier: TOKEN_EXTERN TOKEN_STRING_SYCL_LITERAL  */
#line 1398 "src/parse.yy"
                                              { (yyval.storageClass) = new StorageClass(StorageClass::EXT_SYCL); }
#line 5680 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 174: /* storage_class_specifier: TOKEN_STATIC  */
#line 1399 "src/parse.yy"
                   { (yyval.storageClass) = new StorageClass(StorageClass::STATIC); }
#line 5686 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 175: /* type_specifier: atomic_var_type_specifier  */
#line 1403 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].type); }
#line 5692 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 176: /* type_specifier: TOKEN_TYPE_NAME  */
#line 1405 "src/parse.yy"
    {
        const Type *t = m->symbolTable->LookupType(yytext);
        (yyval.type) = t;
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 5702 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 177: /* type_specifier: struct_or_union_specifier  */
#line 1410 "src/parse.yy"
                                { (yyval.type) = (yyvsp[0].type); }
#line 5708 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 178: /* type_specifier: enum_specifier  */
#line 1411 "src/parse.yy"
                     { (yyval.type) = (yyvsp[0].enumType); }
#line 5714 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 179: /* type_specifier_list: type_specifier  */
#line 1416 "src/parse.yy"
    {
        if ((yyvsp[0].type) == nullptr)
            (yyval.typeList) = nullptr;
        else {
            std::vector<std::pair<const Type *, SourcePos> > *vec =
                new std::vector<std::pair<const Type *, SourcePos> >;
            vec->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
            (yyval.typeList) = vec;
        }
    }
#line 5729 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 180: /* type_specifier_list: type_specifier_list ',' type_specifier  */
#line 1427 "src/parse.yy"
    {
        (yyval.typeList) = (yyvsp[-2].typeList);
        if ((yyvsp[-2].typeList) == nullptr)
            Assert(m->errorCount > 0);
        else
            (yyval.typeList)->push_back(std::make_pair((yyvsp[0].type), (yylsp[0])));
    }
#line 5741 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 181: /* atomic_var_type_specifier: TOKEN_VOID  */
#line 1437 "src/parse.yy"
                 { (yyval.type) = AtomicType::Void; }
#line 5747 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 182: /* atomic_var_type_specifier: TOKEN_BOOL  */
#line 1438 "src/parse.yy"
                    { (yyval.type) = AtomicType::UniformBool->GetAsUnboundVariabilityType(); }
#line 5753 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 183: /* atomic_var_type_specifier: TOKEN_INT8  */
#line 1439 "src/parse.yy"
                    { (yyval.type) = AtomicType::UniformInt8->GetAsUnboundVariabilityType(); }
#line 5759 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 184: /* atomic_var_type_specifier: TOKEN_UINT8  */
#line 1440 "src/parse.yy"
                    { (yyval.type) = AtomicType::UniformUInt8->GetAsUnboundVariabilityType(); }
#line 5765 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 185: /* atomic_var_type_specifier: TOKEN_INT16  */
#line 1441 "src/parse.yy"
                    { (yyval.type) = AtomicType::UniformInt16->GetAsUnboundVariabilityType(); }
#line 5771 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 186: /* atomic_var_type_specifier: TOKEN_UINT16  */
#line 1442 "src/parse.yy"
                    { (yyval.type) = AtomicType::UniformUInt16->GetAsUnboundVariabilityType(); }
#line 5777 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 187: /* atomic_var_type_specifier: TOKEN_INT  */
#line 1443 "src/parse.yy"
                    { (yyval.type) = AtomicType::UniformInt32->GetAsUnboundVariabilityType(); }
#line 5783 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 188: /* atomic_var_type_specifier: TOKEN_UINT  */
#line 1444 "src/parse.yy"
                    { (yyval.type) = AtomicType::UniformUInt32->GetAsUnboundVariabilityType(); }
#line 5789 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 189: /* atomic_var_type_specifier: TOKEN_FLOAT16  */
#line 1445 "src/parse.yy"
                    { (yyval.type) = AtomicType::UniformFloat16->GetAsUnboundVariabilityType(); }
#line 5795 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 190: /* atomic_var_type_specifier: TOKEN_FLOAT  */
#line 1446 "src/parse.yy"
                    { (yyval.type) = AtomicType::UniformFloat->GetAsUnboundVariabilityType(); }
#line 5801 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 191: /* atomic_var_type_specifier: TOKEN_DOUBLE  */
#line 1447 "src/parse.yy"
                    { (yyval.type) = AtomicType::UniformDouble->GetAsUnboundVariabilityType(); }
#line 5807 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 192: /* atomic_var_type_specifier: TOKEN_INT64  */
#line 1448 "src/parse.yy"
                    { (yyval.type) = AtomicType::UniformInt64->GetAsUnboundVariabilityType(); }
#line 5813 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 193: /* atomic_var_type_specifier: TOKEN_UINT64  */
#line 1449 "src/parse.yy"
                    { (yyval.type) = AtomicType::UniformUInt64->GetAsUnboundVariabilityType(); }
#line 5819 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 194: /* short_vec_specifier: type_specifier '<' int_constant '>'  */
#line 1454 "src/parse.yy"
    {
        (yyval.type) = (yyvsp[-3].type) ? new VectorType((yyvsp[-3].type), (int32_t)(yyvsp[-1].intVal)) : nullptr;
    }
#line 5827 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 195: /* short_vec_specifier: type_specifier '<' TOKEN_IDENTIFIER '>'  */
#line 1458 "src/parse.yy"
    {
        Symbol* s = new Symbol(*(yyvsp[-1].stringVal), Union((yylsp[-3]), (yylsp[-1])), Symbol::SymbolKind::TemplateNonTypeParm, AtomicType::UniformInt32->GetAsConstType());
        lCleanUpString((yyvsp[-1].stringVal));
        (yyval.type) = (yyvsp[-3].type) ? new VectorType((yyvsp[-3].type), s) : nullptr;
    }
#line 5837 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 196: /* struct_or_union_name: TOKEN_IDENTIFIER  */
#line 1467 "src/parse.yy"
    {
        (yyval.constCharPtr) = strdup(yytext);
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 5846 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 197: /* struct_or_union_name: TOKEN_TYPE_NAME  */
#line 1472 "src/parse.yy"
    {
        (yyval.constCharPtr) = strdup(yytext);
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 5855 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 198: /* struct_or_union_and_name: struct_or_union struct_or_union_name  */
#line 1480 "src/parse.yy"
      {
          const Type *st = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (st == nullptr) {
              UndefinedStructType* ust = new UndefinedStructType((yyvsp[0].constCharPtr), Variability::Unbound, false, (yylsp[0]));
              ust->RegisterInStructTypeMap();
              m->symbolTable->AddType((yyvsp[0].constCharPtr), ust, (yylsp[0]));
              (yyval.type) = ust;
          } else {
              if (CastType<StructType>(st) == nullptr &&
                  CastType<UndefinedStructType>(st) == nullptr) {
                  Error((yylsp[0]), "Type \"%s\" is not a struct type! (%s)", (yyvsp[0].constCharPtr),
                        st->GetString().c_str());
                  (yyval.type) = nullptr;
              }
              else
                  (yyval.type) = st;
         }
         // allocated by strdup in struct_or_union_name
         free((char*)(yyvsp[0].constCharPtr));
      }
#line 5880 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 200: /* struct_or_union_specifier: struct_or_union_and_name '{' struct_declaration_list '}'  */
#line 1510 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != nullptr) {
              const std::string &name = CastType<StructType>((yyvsp[-3].type)) ? CastType<StructType>((yyvsp[-3].type))->GetStructName()
                                                                 : CastType<UndefinedStructType>((yyvsp[-3].type))->GetStructName();
              (yyval.type) = lCreateStructType(name, (yyvsp[-1].structDeclarationList), nullptr, (yylsp[-3]));
              // struct_declaration_list returns a vector that is not needed anymore.
              delete (yyvsp[-1].structDeclarationList);
          } else {
              (yyval.type) = nullptr;
          }
      }
#line 5896 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 201: /* struct_or_union_specifier: struct_or_union_and_name '{' struct_declaration_list '}' attribute_specifier  */
#line 1522 "src/parse.yy"
      {
          if ((yyvsp[-2].structDeclarationList) != nullptr) {
              const std::string &name = CastType<StructType>((yyvsp[-4].type)) ? CastType<StructType>((yyvsp[-4].type))->GetStructName()
                                                                 : CastType<UndefinedStructType>((yyvsp[-4].type))->GetStructName();
              (yyval.type) = lCreateStructType(name, (yyvsp[-2].structDeclarationList), (yyvsp[0].attributeList), (yylsp[-4]));
              // attribute_specifier returns an object that is not needed anymore.
              delete (yyvsp[0].attributeList);
          } else {
              (yyval.type) = nullptr;
          }
          // struct_declaration_list returns a vector that is not needed anymore.
          delete (yyvsp[-2].structDeclarationList);
      }
#line 5914 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 202: /* struct_or_union_specifier: struct_or_union '{' struct_declaration_list '}'  */
#line 1536 "src/parse.yy"
      {
          if ((yyvsp[-1].structDeclarationList) != nullptr) {
              (yyval.type) = lCreateStructType("", (yyvsp[-1].structDeclarationList), nullptr, (yylsp[-3]));
              // struct_declaration_list returns a vector that is not needed anymore.
              delete (yyvsp[-1].structDeclarationList);
          } else {
              (yyval.type) = nullptr;
          }
      }
#line 5928 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 203: /* struct_or_union_specifier: struct_or_union '{' struct_declaration_list '}' attribute_specifier  */
#line 1546 "src/parse.yy"
      {
          if ((yyvsp[-2].structDeclarationList) != nullptr) {
              (yyval.type) = lCreateStructType("", (yyvsp[-2].structDeclarationList), (yyvsp[0].attributeList), (yylsp[-4]));
              // struct_declaration_list returns a vector that is not needed anymore.
              delete (yyvsp[-2].structDeclarationList);
          } else {
              (yyval.type) = nullptr;
          }
          // attribute_specifier returns an object that is not needed anymore.
          delete (yyvsp[0].attributeList);
      }
#line 5944 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 204: /* struct_or_union_specifier: struct_or_union '{' '}'  */
#line 1558 "src/parse.yy"
      {
          (yyval.type) = lCreateStructType("", nullptr, nullptr, (yylsp[-2]));
      }
#line 5952 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 205: /* struct_or_union_specifier: struct_or_union '{' '}' attribute_specifier  */
#line 1562 "src/parse.yy"
      {
          (yyval.type) = lCreateStructType("", nullptr, (yyvsp[0].attributeList), (yylsp[-3]));
          // attribute_specifier returns an object that is not needed anymore.
          delete (yyvsp[0].attributeList);
      }
#line 5962 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 206: /* struct_or_union_specifier: struct_or_union_and_name '{' '}'  */
#line 1568 "src/parse.yy"
      {
          const std::string &name = CastType<StructType>((yyvsp[-2].type)) ? CastType<StructType>((yyvsp[-2].type))->GetStructName()
                                                             : CastType<UndefinedStructType>((yyvsp[-2].type))->GetStructName();
          (yyval.type) = lCreateStructType(name, nullptr, nullptr, (yylsp[-2]));
      }
#line 5972 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 207: /* struct_or_union_specifier: struct_or_union_and_name '{' '}' attribute_specifier  */
#line 1574 "src/parse.yy"
      {
          const std::string &name = CastType<StructType>((yyvsp[-3].type)) ? CastType<StructType>((yyvsp[-3].type))->GetStructName()
                                                             : CastType<UndefinedStructType>((yyvsp[-3].type))->GetStructName();
          (yyval.type) = lCreateStructType(name, nullptr, (yyvsp[0].attributeList), (yylsp[-3]));
          // attribute_specifier returns an object that is not needed anymore.
          delete (yyvsp[0].attributeList);
      }
#line 5984 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 209: /* struct_declaration_list: struct_declaration  */
#line 1589 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = new std::vector<StructDeclaration *>;
          if ((yyvsp[0].structDeclaration) != nullptr)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 5995 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 210: /* struct_declaration_list: struct_declaration_list struct_declaration  */
#line 1596 "src/parse.yy"
      {
          std::vector<StructDeclaration *> *sdl = (std::vector<StructDeclaration *> *)(yyvsp[-1].structDeclarationList);
          if (sdl == nullptr) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sdl = new std::vector<StructDeclaration *>;
          }
          if ((yyvsp[0].structDeclaration) != nullptr)
              sdl->push_back((yyvsp[0].structDeclaration));
          (yyval.structDeclarationList) = sdl;
      }
#line 6010 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 211: /* struct_declaration: specifier_qualifier_list struct_declarator_list ';'  */
#line 1610 "src/parse.yy"
      { (yyval.structDeclaration) = ((yyvsp[-2].type) != nullptr && (yyvsp[-1].structDeclaratorList) != nullptr) ? new StructDeclaration((yyvsp[-2].type), (yyvsp[-1].structDeclaratorList)) : nullptr; }
#line 6016 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 215: /* specifier_qualifier_list: type_qualifier specifier_qualifier_list  */
#line 1618 "src/parse.yy"
    {
        if ((yyvsp[0].type) != nullptr) {
            if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNIFORM) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"uniform\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = nullptr;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsUniformType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VARYING) {
                if ((yyvsp[0].type)->IsVoidType()) {
                    Error((yylsp[-1]), "\"varying\" qualifier is illegal with \"void\" type.");
                    (yyval.type) = nullptr;
                }
                else
                    (yyval.type) = (yyvsp[0].type)->GetAsVaryingType();
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_CONST)
                (yyval.type) = (yyvsp[0].type)->GetAsConstType();
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_SIGNED) {
                if ((yyvsp[0].type)->IsIntType() == false) {
                    Error((yylsp[-1]), "Can't apply \"signed\" qualifier to \"%s\" type.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNSIGNED) {
                const Type *t = (yyvsp[0].type)->GetAsUnsignedType();
                if (t)
                    (yyval.type) = t;
                else {
                    Error((yylsp[-1]), "Can't apply \"unsigned\" qualifier to \"%s\" type. Ignoring.",
                          (yyvsp[0].type)->ResolveUnboundVariability(Variability::Varying)->GetString().c_str());
                    (yyval.type) = (yyvsp[0].type);
                }
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_INLINE) {
                Error((yylsp[-1]), "\"inline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_NOINLINE) {
                Error((yylsp[-1]), "\"noinline\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_VECTORCALL) {
                Error((yylsp[-1]), "\"__vectorcall\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_REGCALL) {
                Error((yylsp[-1]), "\"__regcall\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_TASK) {
                Error((yylsp[-1]), "\"task\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_UNMASKED) {
                Error((yylsp[-1]), "\"unmasked\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else if ((yyvsp[-1].typeQualifier) == TYPEQUAL_EXPORT) {
                Error((yylsp[-1]), "\"export\" qualifier is illegal outside of "
                      "function declarations.");
                (yyval.type) = (yyvsp[0].type);
            }
            else
                FATAL("Unhandled type qualifier in parser.");
        }
        else {
            if (m->errorCount == 0)
                Error((yylsp[-1]), "Lost type qualifier in parser.");
            (yyval.type) = nullptr;
        }
    }
#line 6102 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 216: /* struct_declarator_list: struct_declarator  */
#line 1704 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = new std::vector<Declarator *>;
          if ((yyvsp[0].declarator) != nullptr)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 6113 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 217: /* struct_declarator_list: struct_declarator_list ',' struct_declarator  */
#line 1711 "src/parse.yy"
      {
          std::vector<Declarator *> *sdl = (std::vector<Declarator *> *)(yyvsp[-2].structDeclaratorList);
          if (sdl == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              sdl = new std::vector<Declarator *>;
          }
          if ((yyvsp[0].declarator) != nullptr)
              sdl->push_back((yyvsp[0].declarator));
          (yyval.structDeclaratorList) = sdl;
      }
#line 6128 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 218: /* struct_declarator: declarator  */
#line 1724 "src/parse.yy"
                 { (yyval.declarator) = (yyvsp[0].declarator); }
#line 6134 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 219: /* enum_identifier: TOKEN_IDENTIFIER  */
#line 1733 "src/parse.yy"
      {
          (yyval.constCharPtr) = strdup(yytext);
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 6143 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 220: /* enum_specifier: TOKEN_ENUM '{' enumerator_list '}'  */
#line 1741 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(nullptr, (yyvsp[-1].symbolList), (yylsp[-3]));
          // enumerator_list returns aux vector that is not needed anymore.
          delete (yyvsp[-1].symbolList);
      }
#line 6153 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 221: /* enum_specifier: TOKEN_ENUM enum_identifier '{' enumerator_list '}'  */
#line 1747 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-3].constCharPtr), (yyvsp[-1].symbolList), (yylsp[-3]));
          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[-3].constCharPtr));

          // enumerator_list returns aux vector that is not needed anymore.
          delete (yyvsp[-1].symbolList);
      }
#line 6166 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 222: /* enum_specifier: TOKEN_ENUM '{' enumerator_list ',' '}'  */
#line 1756 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType(nullptr, (yyvsp[-2].symbolList), (yylsp[-4]));
          // enumerator_list returns aux vector that is not needed anymore.
          delete (yyvsp[-2].symbolList);
      }
#line 6176 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 223: /* enum_specifier: TOKEN_ENUM enum_identifier '{' enumerator_list ',' '}'  */
#line 1762 "src/parse.yy"
      {
          (yyval.enumType) = lCreateEnumType((yyvsp[-4].constCharPtr), (yyvsp[-2].symbolList), (yylsp[-4]));
          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[-4].constCharPtr));

          // enumerator_list returns aux vector that is not needed anymore.
          delete (yyvsp[-2].symbolList);
      }
#line 6189 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 224: /* enum_specifier: TOKEN_ENUM enum_identifier  */
#line 1771 "src/parse.yy"
      {
          const Type *type = m->symbolTable->LookupType((yyvsp[0].constCharPtr));
          if (type == nullptr) {
              std::vector<std::string> alternates = m->symbolTable->ClosestEnumTypeMatch((yyvsp[0].constCharPtr));
              std::string alts = lGetAlternates(alternates);
              Error((yylsp[0]), "Enum type \"%s\" unknown.%s", (yyvsp[0].constCharPtr), alts.c_str());
              (yyval.enumType) = nullptr;
          }
          else {
              const EnumType *enumType = CastType<EnumType>(type);
              if (enumType == nullptr) {
                  Error((yylsp[0]), "Type \"%s\" is not an enum type (%s).", (yyvsp[0].constCharPtr),
                        type->GetString().c_str());
                  (yyval.enumType) = nullptr;
              }
              else
                  (yyval.enumType) = enumType;
          }
          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[0].constCharPtr));
      }
#line 6215 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 225: /* enumerator_list: enumerator  */
#line 1796 "src/parse.yy"
      {
          if ((yyvsp[0].symbol) == nullptr)
              (yyval.symbolList) = nullptr;
          else {
              std::vector<Symbol *> *el = new std::vector<Symbol *>;
              el->push_back((yyvsp[0].symbol));
              (yyval.symbolList) = el;
          }
      }
#line 6229 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 226: /* enumerator_list: enumerator_list ',' enumerator  */
#line 1806 "src/parse.yy"
      {
          std::vector<Symbol *> *symList = (yyvsp[-2].symbolList);
          if (symList == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              symList = new std::vector<Symbol *>;
          }
          if ((yyvsp[0].symbol) != nullptr)
              symList->push_back((yyvsp[0].symbol));
          (yyval.symbolList) = symList;
      }
#line 6244 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 227: /* enumerator: enum_identifier  */
#line 1820 "src/parse.yy"
      {
          (yyval.symbol) = new Symbol((yyvsp[0].constCharPtr), (yylsp[0]), Symbol::SymbolKind::Enumerator);
          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[0].constCharPtr));
      }
#line 6254 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 228: /* enumerator: enum_identifier '=' constant_expression  */
#line 1826 "src/parse.yy"
      {
          std::variant<std::monostate, int, Symbol*> value;
          if ((yyvsp[-2].constCharPtr) != nullptr && (yyvsp[0].expr) != nullptr &&
              lGetConstantIntOrSymbol((yyvsp[0].expr), &value, (yylsp[0]), "Enumerator value")) {
              Symbol *sym = new Symbol((yyvsp[-2].constCharPtr), (yylsp[-2]), Symbol::SymbolKind::Enumerator);

              // Check if value holds an int
              if (std::holds_alternative<int>(value)) {
                  int intValue = std::get<int>(value);
                  sym->constValue = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                                                  (uint32_t)intValue, (yylsp[0]));
              } else {
                  Error((yylsp[0]), "Enumerator value must be a compile-time constant.");
                  (yyval.symbol) = nullptr;
              }
              (yyval.symbol) = sym;
          }
          else {
              (yyval.symbol) = nullptr;
          }

          // allocated by strdup in enum_identifier
          free((char*)(yyvsp[-2].constCharPtr));
      }
#line 6283 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 229: /* type_qualifier: TOKEN_CONST  */
#line 1853 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_CONST; }
#line 6289 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 230: /* type_qualifier: TOKEN_UNIFORM  */
#line 1854 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_UNIFORM; }
#line 6295 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 231: /* type_qualifier: TOKEN_VARYING  */
#line 1855 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_VARYING; }
#line 6301 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 232: /* type_qualifier: TOKEN_TASK  */
#line 1856 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_TASK; }
#line 6307 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 233: /* type_qualifier: TOKEN_UNMASKED  */
#line 1857 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_UNMASKED; }
#line 6313 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 234: /* type_qualifier: TOKEN_EXPORT  */
#line 1858 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_EXPORT; }
#line 6319 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 235: /* type_qualifier: TOKEN_INLINE  */
#line 1859 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_INLINE; }
#line 6325 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 236: /* type_qualifier: TOKEN_NOINLINE  */
#line 1860 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_NOINLINE; }
#line 6331 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 237: /* type_qualifier: TOKEN_VECTORCALL  */
#line 1861 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_VECTORCALL; }
#line 6337 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 238: /* type_qualifier: TOKEN_REGCALL  */
#line 1862 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_REGCALL; }
#line 6343 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 239: /* type_qualifier: TOKEN_SIGNED  */
#line 1863 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_SIGNED; }
#line 6349 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 240: /* type_qualifier: TOKEN_UNSIGNED  */
#line 1864 "src/parse.yy"
                          { (yyval.typeQualifier) = TYPEQUAL_UNSIGNED; }
#line 6355 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 241: /* type_qualifier_list: type_qualifier  */
#line 1869 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[0].typeQualifier);
    }
#line 6363 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 242: /* type_qualifier_list: type_qualifier_list type_qualifier  */
#line 1873 "src/parse.yy"
    {
        (yyval.typeQualifier) = (yyvsp[-1].typeQualifier) | (yyvsp[0].typeQualifier);
    }
#line 6371 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 243: /* declarator: pointer direct_declarator  */
#line 1880 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != nullptr) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != nullptr)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = nullptr;
    }
#line 6387 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 244: /* declarator: reference direct_declarator  */
#line 1892 "src/parse.yy"
    {
        if ((yyvsp[-1].declarator) != nullptr) {
            Declarator *tail = (yyvsp[-1].declarator);
            while (tail->child != nullptr)
               tail = tail->child;
            tail->child = (yyvsp[0].declarator);
            (yyval.declarator) = (yyvsp[-1].declarator);
        }
        else
            (yyval.declarator) = nullptr;
    }
#line 6403 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 246: /* int_constant: TOKEN_INT8_CONSTANT  */
#line 1907 "src/parse.yy"
                          { (yyval.intVal) = yylval.intVal; }
#line 6409 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 247: /* int_constant: TOKEN_UINT8_CONSTANT  */
#line 1908 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 6415 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 248: /* int_constant: TOKEN_INT16_CONSTANT  */
#line 1909 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 6421 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 249: /* int_constant: TOKEN_UINT16_CONSTANT  */
#line 1910 "src/parse.yy"
                            { (yyval.intVal) = yylval.intVal; }
#line 6427 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 250: /* int_constant: TOKEN_INT32_CONSTANT  */
#line 1911 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 6433 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 251: /* int_constant: TOKEN_UINT32_CONSTANT  */
#line 1912 "src/parse.yy"
                            { (yyval.intVal) = yylval.intVal; }
#line 6439 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 252: /* int_constant: TOKEN_INT64_CONSTANT  */
#line 1913 "src/parse.yy"
                           { (yyval.intVal) = yylval.intVal; }
#line 6445 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 253: /* int_constant: TOKEN_UINT64_CONSTANT  */
#line 1914 "src/parse.yy"
                            { (yyval.intVal) = yylval.intVal; }
#line 6451 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 254: /* direct_declarator: TOKEN_IDENTIFIER  */
#line 1919 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = yytext;
          (yyval.declarator) = d;
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 6462 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 255: /* direct_declarator: TOKEN_TEMPLATE_NAME  */
#line 1928 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = yytext;
          (yyval.declarator) = d;
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 6473 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 256: /* direct_declarator: '(' declarator ')'  */
#line 1935 "src/parse.yy"
    {
        (yyval.declarator) = (yyvsp[-1].declarator);
    }
#line 6481 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 257: /* direct_declarator: direct_declarator '[' constant_expression ']'  */
#line 1939 "src/parse.yy"
    {
        std::variant<std::monostate, int, Symbol*> size;
        if ((yyvsp[-3].declarator) != nullptr && lGetConstantIntOrSymbol((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            // Check if size holds an int
            if (std::holds_alternative<int>(size)) {
                int intValue = std::get<int>(size);
                if (intValue < 0) {
                    Error((yylsp[-1]), "Array dimension must be non-negative.");
                    (yyval.declarator) = nullptr;
                } else {
                    Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                    d->arraySize = intValue;
                    d->child = (yyvsp[-3].declarator);
                    (yyval.declarator) = d;
                }
            } else if (std::holds_alternative<Symbol*>(size)) {
                // Handle the case where size holds a Symbol*
                Symbol* symbolValuePtr = std::get<Symbol*>(size);
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                d->arraySize = symbolValuePtr;
                d->child = (yyvsp[-3].declarator);
                (yyval.declarator) = d;
            } else {
                (yyval.declarator) = nullptr;    
            }
        }
        else {
            (yyval.declarator) = nullptr;
        }
    }
#line 6516 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 258: /* direct_declarator: direct_declarator '[' ']'  */
#line 1970 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != nullptr) {
            Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
            d->arraySize = 0; // unsize
            d->child = (yyvsp[-2].declarator);
            (yyval.declarator) = d;
        }
        else
            (yyval.declarator) = nullptr;
    }
#line 6531 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 259: /* direct_declarator: direct_declarator '[' error ']'  */
#line 1981 "src/parse.yy"
    {
         (yyval.declarator) = nullptr;
    }
#line 6539 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 260: /* direct_declarator: direct_declarator '(' parameter_type_list ')'  */
#line 1985 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) != nullptr) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != nullptr) {
                  d->functionParams = *(yyvsp[-1].declarationList);
                  // parameter_type_list returns vector of Declarations that is not needed anymore.
                  delete (yyvsp[-1].declarationList);
              }
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = nullptr;
      }
#line 6558 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 261: /* direct_declarator: direct_declarator '(' ')'  */
#line 2000 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) != nullptr) {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
          else
              (yyval.declarator) = nullptr;
      }
#line 6572 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 262: /* direct_declarator: direct_declarator '(' error ')'  */
#line 2010 "src/parse.yy"
    {
        (yyval.declarator) = nullptr;
    }
#line 6580 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 263: /* pointer: '*'  */
#line 2018 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_POINTER, (yylsp[0]));
    }
#line 6588 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 264: /* pointer: '*' type_qualifier_list  */
#line 2022 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[0].typeQualifier);
          (yyval.declarator) = d;
      }
#line 6598 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 265: /* pointer: '*' pointer  */
#line 2028 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 6608 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 266: /* pointer: '*' type_qualifier_list pointer  */
#line 2034 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-2]), (yylsp[0])));
          d->typeQualifiers = (yyvsp[-1].typeQualifier);
          d->child = (yyvsp[0].declarator);
          (yyval.declarator) = d;
      }
#line 6619 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 267: /* reference: '&'  */
#line 2045 "src/parse.yy"
    {
        (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
    }
#line 6627 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 268: /* parameter_type_list: parameter_list  */
#line 2052 "src/parse.yy"
                     { (yyval.declarationList) = (yyvsp[0].declarationList); }
#line 6633 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 269: /* parameter_list: parameter_declaration  */
#line 2057 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != nullptr)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 6644 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 270: /* parameter_list: parameter_list ',' parameter_declaration  */
#line 2064 "src/parse.yy"
    {
        std::vector<Declaration *> *dl = (std::vector<Declaration *> *)(yyvsp[-2].declarationList);
        if (dl == nullptr)
            dl = new std::vector<Declaration *>;
        if ((yyvsp[0].declaration) != nullptr)
            dl->push_back((yyvsp[0].declaration));
        (yyval.declarationList) = dl;
    }
#line 6657 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 271: /* parameter_list: error ','  */
#line 2073 "src/parse.yy"
    {
        lSuggestParamListAlternates();
        (yyval.declarationList) = nullptr;
    }
#line 6666 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 272: /* parameter_declaration: declaration_specifiers declarator  */
#line 2081 "src/parse.yy"
    {
        (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
    }
#line 6674 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 273: /* parameter_declaration: declaration_specifiers declarator '=' initializer  */
#line 2085 "src/parse.yy"
    {
        if ((yyvsp[-3].declSpecs) != nullptr && (yyvsp[-2].declarator) != nullptr) {
            (yyvsp[-2].declarator)->initExpr = (yyvsp[0].expr);
            (yyval.declaration) = new Declaration((yyvsp[-3].declSpecs), (yyvsp[-2].declarator));
        }
        else
            (yyval.declaration) = nullptr;
    }
#line 6687 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 274: /* parameter_declaration: declaration_specifiers abstract_declarator  */
#line 2094 "src/parse.yy"
    {
        if ((yyvsp[-1].declSpecs) != nullptr && (yyvsp[0].declarator) != nullptr)
            (yyval.declaration) = new Declaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        else
            (yyval.declaration) = nullptr;
    }
#line 6698 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 275: /* parameter_declaration: declaration_specifiers  */
#line 2101 "src/parse.yy"
    {
        if ((yyvsp[0].declSpecs) == nullptr)
            (yyval.declaration) = nullptr;
        else
            (yyval.declaration) = new Declaration((yyvsp[0].declSpecs));
    }
#line 6709 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 277: /* type_name: specifier_qualifier_list abstract_declarator  */
#line 2119 "src/parse.yy"
    {
        if ((yyvsp[-1].type) == nullptr || (yyvsp[0].declarator) == nullptr)
            (yyval.type) = nullptr;
        else {
            (yyvsp[0].declarator)->InitFromType((yyvsp[-1].type), nullptr);
            (yyval.type) = (yyvsp[0].declarator)->type;
        }
    }
#line 6722 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 278: /* abstract_declarator: pointer  */
#line 2131 "src/parse.yy"
      {
          (yyval.declarator) = (yyvsp[0].declarator);
      }
#line 6730 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 280: /* abstract_declarator: pointer direct_abstract_declarator  */
#line 2136 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_POINTER, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 6744 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 281: /* abstract_declarator: reference  */
#line 2146 "src/parse.yy"
      {
          (yyval.declarator) = new Declarator(DK_REFERENCE, (yylsp[0]));
      }
#line 6752 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 282: /* abstract_declarator: reference direct_abstract_declarator  */
#line 2150 "src/parse.yy"
      {
          if ((yyvsp[0].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_REFERENCE, Union((yylsp[-1]), (yylsp[0])));
              d->child = (yyvsp[0].declarator);
              (yyval.declarator) = d;
          }
      }
#line 6766 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 283: /* direct_abstract_declarator: '(' abstract_declarator ')'  */
#line 2163 "src/parse.yy"
      { (yyval.declarator) = (yyvsp[-1].declarator); }
#line 6772 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 284: /* direct_abstract_declarator: '[' ']'  */
#line 2165 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-1]), (yylsp[0])));
          d->arraySize = 0;
          (yyval.declarator) = d;
      }
#line 6782 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 285: /* direct_abstract_declarator: '[' constant_expression ']'  */
#line 2171 "src/parse.yy"
      {
        std::variant<std::monostate, int, Symbol*> size;
        if ((yyvsp[-1].expr) != nullptr && lGetConstantIntOrSymbol((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
            // Check if size holds an int
            if (std::holds_alternative<int>(size)) {
                int intValue = std::get<int>(size);
                if (intValue < 0) {
                    Error((yylsp[-1]), "Array dimension must be non-negative.");
                    (yyval.declarator) = nullptr;
                } else {
                    Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
                    d->arraySize = intValue;
                    (yyval.declarator) = d;
                }
            } else if (std::holds_alternative<Symbol*>(size)) {
                // Handle the case where size holds a Symbol*
                Symbol* symbolValuePtr = std::get<Symbol*>(size);
                Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
                d->arraySize = symbolValuePtr;
                (yyval.declarator) = d;
            } else {
                (yyval.declarator) = nullptr;    
            }
        }
        else {
            (yyval.declarator) = nullptr;
        }
      }
#line 6815 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 286: /* direct_abstract_declarator: direct_abstract_declarator '[' ']'  */
#line 2200 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-2]), (yylsp[0])));
              d->arraySize = 0;
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 6830 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 287: /* direct_abstract_declarator: direct_abstract_declarator '[' constant_expression ']'  */
#line 2211 "src/parse.yy"
      {
          std::variant<std::monostate, int, Symbol*> size;
          if ((yyvsp[-3].declarator) != nullptr && (yyvsp[-1].expr) != nullptr && lGetConstantIntOrSymbol((yyvsp[-1].expr), &size, (yylsp[-1]), "Array dimension")) {
              // Check if size holds an int
              if (std::holds_alternative<int>(size)) {
                  int intValue = std::get<int>(size);
                  if (intValue < 0) {
                      Error((yylsp[-1]), "Array dimension must be non-negative.");
                      (yyval.declarator) = nullptr;
                  } else {
                      Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                      d->arraySize = intValue;
                      d->child = (yyvsp[-3].declarator);
                      (yyval.declarator) = d;
                  }
              } else if (std::holds_alternative<Symbol*>(size)) {
                  // Handle the case where size holds a Symbol*
                  Symbol* symbolValuePtr = std::get<Symbol*>(size);
                  Declarator *d = new Declarator(DK_ARRAY, Union((yylsp[-3]), (yylsp[0])));
                  d->arraySize = symbolValuePtr;
                  d->child = (yyvsp[-3].declarator);
                  (yyval.declarator) = d;
              } else {
                  (yyval.declarator) = nullptr;  
              }
          }
          else {
              (yyval.declarator) = nullptr;
          }
      }
#line 6865 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 288: /* direct_abstract_declarator: '(' ')'  */
#line 2242 "src/parse.yy"
      { (yyval.declarator) = new Declarator(DK_FUNCTION, Union((yylsp[-1]), (yylsp[0]))); }
#line 6871 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 289: /* direct_abstract_declarator: '(' parameter_type_list ')'  */
#line 2244 "src/parse.yy"
      {
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
          if ((yyvsp[-1].declarationList) != nullptr) {
              d->functionParams = *(yyvsp[-1].declarationList);
              // parameter_type_list returns vector of Declarations that is not needed anymore.
              delete (yyvsp[-1].declarationList);
          }
          (yyval.declarator) = d;
      }
#line 6885 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 290: /* direct_abstract_declarator: direct_abstract_declarator '(' ')'  */
#line 2254 "src/parse.yy"
      {
          if ((yyvsp[-2].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-2]), (yylsp[0])));
              d->child = (yyvsp[-2].declarator);
              (yyval.declarator) = d;
          }
      }
#line 6899 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 291: /* direct_abstract_declarator: direct_abstract_declarator '(' parameter_type_list ')'  */
#line 2264 "src/parse.yy"
      {
          if ((yyvsp[-3].declarator) == nullptr)
              (yyval.declarator) = nullptr;
          else {
              Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-3]), (yylsp[0])));
              d->child = (yyvsp[-3].declarator);
              if ((yyvsp[-1].declarationList) != nullptr) {
                  d->functionParams = *(yyvsp[-1].declarationList);
                  // parameter_type_list returns vector of Declarations that is not needed anymore.
                  delete (yyvsp[-1].declarationList);
              }
              (yyval.declarator) = d;
          }
      }
#line 6918 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 293: /* initializer: '{' initializer_list '}'  */
#line 2282 "src/parse.yy"
                               { (yyval.expr) = (yyvsp[-1].exprList); }
#line 6924 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 294: /* initializer: '{' initializer_list ',' '}'  */
#line 2283 "src/parse.yy"
                                   { (yyval.expr) = (yyvsp[-2].exprList); }
#line 6930 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 295: /* initializer_list: initializer  */
#line 2288 "src/parse.yy"
      { (yyval.exprList) = new ExprList((yyvsp[0].expr), (yylsp[0])); }
#line 6936 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 296: /* initializer_list: initializer_list ',' initializer  */
#line 2290 "src/parse.yy"
      {
          ExprList *exprList = (yyvsp[-2].exprList);
          if (exprList == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              exprList = new ExprList((yylsp[0]));
          }
          exprList->exprs.push_back((yyvsp[0].expr));
          exprList->pos = Union(exprList->pos, (yylsp[0]));
          (yyval.exprList) = exprList;
      }
#line 6951 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 297: /* pragma: TOKEN_PRAGMA  */
#line 2304 "src/parse.yy"
    {
        (yyval.pragmaAttributes) = (yylval.pragmaAttributes);
    }
#line 6959 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 298: /* attributed_statement: pragma attributed_statement  */
#line 2311 "src/parse.yy"
    {
        if (((yyvsp[-1].pragmaAttributes)->aType == PragmaAttributes::AttributeType::pragmaloop) && ((yyvsp[0].stmt) != nullptr)) {
            std::pair<Globals::pragmaUnrollType, int> unrollVal = std::pair<Globals::pragmaUnrollType, int>((yyvsp[-1].pragmaAttributes)->unrollType, (yyvsp[-1].pragmaAttributes)->count);
            (yyvsp[0].stmt)->SetLoopAttribute(unrollVal);
        }
        (yyval.stmt) = (yyvsp[0].stmt);
        // deallocate yylval.pragmaAttributes returned from pragma and allocated in lPragmaUnroll
        delete (yyvsp[-1].pragmaAttributes);
    }
#line 6973 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 312: /* statement: error ';'  */
#line 2337 "src/parse.yy"
    {
        lSuggestBuiltinAlternates();
        (yyval.stmt) = nullptr;
    }
#line 6982 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 313: /* labeled_statement: goto_identifier ':' attributed_statement  */
#line 2345 "src/parse.yy"
    {
        (yyval.stmt) = new LabeledStmt((yyvsp[-2].constCharPtr), (yyvsp[0].stmt), (yylsp[-2]));
        // allocated by strdup in goto_identifier
        free((char*)(yyvsp[-2].constCharPtr));
    }
#line 6992 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 314: /* labeled_statement: TOKEN_CASE constant_expression ':' attributed_statement  */
#line 2351 "src/parse.yy"
      {
          std::variant<std::monostate, int, Symbol*> value;
          if ((yyvsp[-2].expr) != nullptr &&
              lGetConstantIntOrSymbol((yyvsp[-2].expr), &value, (yylsp[-2]), "Case statement value")) {
              // Check if value holds an int
              if (std::holds_alternative<int>(value)) {
                  int intValue = std::get<int>(value);
                  (yyval.stmt) = new CaseStmt(intValue, (yyvsp[0].stmt), Union((yylsp[-3]), (yylsp[-2])));
              } else {
                  Error((yylsp[-2]), "Case statement value must be a compile-time constant or template non-type parameter.");
                  (yyval.stmt) = nullptr;
              }
          }
          else {
              (yyval.stmt) = nullptr;
          }
      }
#line 7014 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 315: /* labeled_statement: TOKEN_DEFAULT ':' attributed_statement  */
#line 2369 "src/parse.yy"
      { (yyval.stmt) = new DefaultStmt((yyvsp[0].stmt), (yylsp[-2])); }
#line 7020 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 316: /* start_scope: '{'  */
#line 2373 "src/parse.yy"
          { m->symbolTable->PushScope(); }
#line 7026 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 317: /* end_scope: '}'  */
#line 2377 "src/parse.yy"
          { m->symbolTable->PopScope(); }
#line 7032 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 318: /* compound_statement: '{' '}'  */
#line 2381 "src/parse.yy"
              { (yyval.stmt) = nullptr; }
#line 7038 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 319: /* compound_statement: start_scope statement_list end_scope  */
#line 2382 "src/parse.yy"
                                           { (yyval.stmt) = (yyvsp[-1].stmt); }
#line 7044 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 320: /* statement_list: attributed_statement  */
#line 2387 "src/parse.yy"
      {
          StmtList *sl = new StmtList((yylsp[0]));
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 7054 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 321: /* statement_list: statement_list attributed_statement  */
#line 2393 "src/parse.yy"
      {
          StmtList *sl = (StmtList *)(yyvsp[-1].stmt);
          if (sl == nullptr) {
              AssertPos((yylsp[-1]), m->errorCount > 0);
              sl = new StmtList((yylsp[0]));
          }
          sl->Add((yyvsp[0].stmt));
          (yyval.stmt) = sl;
      }
#line 7068 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 322: /* expression_statement: ';'  */
#line 2405 "src/parse.yy"
          { (yyval.stmt) = nullptr; }
#line 7074 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 323: /* expression_statement: expression ';'  */
#line 2406 "src/parse.yy"
                     { (yyval.stmt) = (yyvsp[-1].expr) ? new ExprStmt((yyvsp[-1].expr), (yylsp[-1])) : nullptr; }
#line 7080 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 324: /* selection_statement: TOKEN_IF '(' expression ')' attributed_statement  */
#line 2411 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), nullptr, false, (yylsp[-4])); }
#line 7086 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 325: /* selection_statement: TOKEN_IF '(' expression ')' attributed_statement TOKEN_ELSE attributed_statement  */
#line 2413 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), false, (yylsp[-6])); }
#line 7092 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 326: /* selection_statement: TOKEN_CIF '(' expression ')' attributed_statement  */
#line 2415 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-2].expr), (yyvsp[0].stmt), nullptr, true, (yylsp[-4])); }
#line 7098 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 327: /* selection_statement: TOKEN_CIF '(' expression ')' attributed_statement TOKEN_ELSE attributed_statement  */
#line 2417 "src/parse.yy"
      { (yyval.stmt) = new IfStmt((yyvsp[-4].expr), (yyvsp[-2].stmt), (yyvsp[0].stmt), true, (yylsp[-6])); }
#line 7104 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 328: /* selection_statement: TOKEN_SWITCH '(' expression ')' attributed_statement  */
#line 2419 "src/parse.yy"
      { (yyval.stmt) = new SwitchStmt((yyvsp[-2].expr), (yyvsp[0].stmt), (yylsp[-4])); }
#line 7110 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 329: /* for_test: ';'  */
#line 2424 "src/parse.yy"
      { (yyval.expr) = nullptr; }
#line 7116 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 330: /* for_test: expression ';'  */
#line 2426 "src/parse.yy"
      { (yyval.expr) = (yyvsp[-1].expr); }
#line 7122 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 333: /* for_scope: TOKEN_FOR  */
#line 2435 "src/parse.yy"
                { m->symbolTable->PushScope(); }
#line 7128 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 334: /* cfor_scope: TOKEN_CFOR  */
#line 2439 "src/parse.yy"
                 { m->symbolTable->PushScope(); }
#line 7134 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 335: /* foreach_scope: TOKEN_FOREACH  */
#line 2443 "src/parse.yy"
                    { m->symbolTable->PushScope(); }
#line 7140 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 336: /* foreach_tiled_scope: TOKEN_FOREACH_TILED  */
#line 2447 "src/parse.yy"
                          { m->symbolTable->PushScope(); }
#line 7146 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 337: /* foreach_identifier: TOKEN_IDENTIFIER  */
#line 2452 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), Symbol::SymbolKind::Variable, AtomicType::VaryingInt32->GetAsConstType());
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 7155 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 338: /* foreach_active_scope: TOKEN_FOREACH_ACTIVE  */
#line 2459 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 7161 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 339: /* foreach_active_identifier: TOKEN_IDENTIFIER  */
#line 2464 "src/parse.yy"
    {
        (yyval.symbol) = new Symbol(yytext, (yylsp[0]), Symbol::SymbolKind::Variable, AtomicType::UniformInt64->GetAsConstType());
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 7170 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 340: /* integer_dotdotdot: TOKEN_INT32DOTDOTDOT_CONSTANT  */
#line 2471 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0]));
    }
#line 7179 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 341: /* integer_dotdotdot: TOKEN_UINT32DOTDOTDOT_CONSTANT  */
#line 2475 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0]));
    }
#line 7188 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 342: /* integer_dotdotdot: TOKEN_INT64DOTDOTDOT_CONSTANT  */
#line 2479 "src/parse.yy"
                                    {
        (yyval.expr) = new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0]));
    }
#line 7197 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 343: /* integer_dotdotdot: TOKEN_UINT64DOTDOTDOT_CONSTANT  */
#line 2483 "src/parse.yy"
                                     {
        (yyval.expr) = new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0]));
    }
#line 7206 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 344: /* foreach_dimension_specifier: foreach_identifier '=' assignment_expression TOKEN_DOTDOTDOT assignment_expression  */
#line 2491 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-4].symbol), (yyvsp[-2].expr), (yyvsp[0].expr));
    }
#line 7214 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 345: /* foreach_dimension_specifier: foreach_identifier '=' integer_dotdotdot assignment_expression  */
#line 2495 "src/parse.yy"
    {
        (yyval.foreachDimension) = new ForeachDimension((yyvsp[-3].symbol), (yyvsp[-1].expr), (yyvsp[0].expr));
    }
#line 7222 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 346: /* foreach_dimension_list: foreach_dimension_specifier  */
#line 2502 "src/parse.yy"
    {
        (yyval.foreachDimensionList) = new std::vector<ForeachDimension *>;
        (yyval.foreachDimensionList)->push_back((yyvsp[0].foreachDimension));
    }
#line 7231 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 347: /* foreach_dimension_list: foreach_dimension_list ',' foreach_dimension_specifier  */
#line 2507 "src/parse.yy"
    {
        std::vector<ForeachDimension *> *dv = (yyvsp[-2].foreachDimensionList);
        if (dv == nullptr) {
            AssertPos((yylsp[-2]), m->errorCount > 0);
            dv = new std::vector<ForeachDimension *>;
        }
        if ((yyvsp[0].foreachDimension) != nullptr)
            dv->push_back((yyvsp[0].foreachDimension));
        (yyval.foreachDimensionList) = dv;
    }
#line 7246 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 348: /* foreach_unique_scope: TOKEN_FOREACH_UNIQUE  */
#line 2520 "src/parse.yy"
                           { m->symbolTable->PushScope(); }
#line 7252 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 349: /* foreach_unique_identifier: TOKEN_IDENTIFIER  */
#line 2525 "src/parse.yy"
      {
          (yyval.constCharPtr) = strdup((yyvsp[0].stringVal)->c_str());
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 7261 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 350: /* iteration_statement: TOKEN_WHILE '(' expression ')' attributed_statement  */
#line 2533 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(nullptr, (yyvsp[-2].expr), nullptr, (yyvsp[0].stmt), false, (yylsp[-4])); }
#line 7267 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 351: /* iteration_statement: TOKEN_CWHILE '(' expression ')' attributed_statement  */
#line 2535 "src/parse.yy"
      { (yyval.stmt) = new ForStmt(nullptr, (yyvsp[-2].expr), nullptr, (yyvsp[0].stmt), true, (yylsp[-4])); }
#line 7273 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 352: /* iteration_statement: TOKEN_DO attributed_statement TOKEN_WHILE '(' expression ')' ';'  */
#line 2537 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), false, (yylsp[-6])); }
#line 7279 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 353: /* iteration_statement: TOKEN_CDO attributed_statement TOKEN_WHILE '(' expression ')' ';'  */
#line 2539 "src/parse.yy"
      { (yyval.stmt) = new DoStmt((yyvsp[-2].expr), (yyvsp[-5].stmt), true, (yylsp[-6])); }
#line 7285 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 354: /* iteration_statement: for_scope '(' for_init_statement for_test ')' attributed_statement  */
#line 2541 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), nullptr, (yyvsp[0].stmt), false, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 7293 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 355: /* iteration_statement: for_scope '(' for_init_statement for_test expression ')' attributed_statement  */
#line 2545 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), false, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 7301 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 356: /* iteration_statement: cfor_scope '(' for_init_statement for_test ')' attributed_statement  */
#line 2549 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-3].stmt), (yyvsp[-2].expr), nullptr, (yyvsp[0].stmt), true, (yylsp[-5]));
        m->symbolTable->PopScope();
      }
#line 7309 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 357: /* iteration_statement: cfor_scope '(' for_init_statement for_test expression ')' attributed_statement  */
#line 2553 "src/parse.yy"
      { (yyval.stmt) = new ForStmt((yyvsp[-4].stmt), (yyvsp[-3].expr), new ExprStmt((yyvsp[-2].expr), (yylsp[-2])), (yyvsp[0].stmt), true, (yylsp[-6]));
        m->symbolTable->PopScope();
      }
#line 7317 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 358: /* $@1: %empty  */
#line 2557 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == nullptr) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }
         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 7331 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 359: /* iteration_statement: foreach_scope '(' foreach_dimension_list ')' $@1 attributed_statement  */
#line 2567 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == nullptr) {
             AssertPos((yylsp[-3]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), false, (yylsp[-5]));
         m->symbolTable->PopScope();

         // deallocate ForeachDimension elements allocated in foreach_dimension_specifier
         for (unsigned int i = 0; i < dims->size(); ++i)
             delete (*dims)[i];

         // deallocate std::vector<ForeachDimension*> allocated in foreach_dimension_list
         delete dims;
     }
#line 7360 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 360: /* $@2: %empty  */
#line 2592 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-1].foreachDimensionList);
         if (dims == nullptr) {
             AssertPos((yylsp[-1]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         for (unsigned int i = 0; i < dims->size(); ++i)
             m->symbolTable->AddVariable((*dims)[i]->sym);
     }
#line 7375 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 361: /* iteration_statement: foreach_tiled_scope '(' foreach_dimension_list ')' $@2 attributed_statement  */
#line 2603 "src/parse.yy"
     {
         std::vector<ForeachDimension *> *dims = (yyvsp[-3].foreachDimensionList);
         if (dims == nullptr) {
             AssertPos((yylsp[-5]), m->errorCount > 0);
             dims = new std::vector<ForeachDimension *>;
         }

         std::vector<Symbol *> syms;
         std::vector<Expr *> begins, ends;
         for (unsigned int i = 0; i < dims->size(); ++i) {
             syms.push_back((*dims)[i]->sym);
             begins.push_back((*dims)[i]->beginExpr);
             ends.push_back((*dims)[i]->endExpr);
         }
         (yyval.stmt) = new ForeachStmt(syms, begins, ends, (yyvsp[0].stmt), true, (yylsp[-5]));
         m->symbolTable->PopScope();

         // deallocate ForeachDimension elements allocated in foreach_dimension_specifier
         for (unsigned int i = 0; i < dims->size(); ++i)
             delete (*dims)[i];

         // deallocate std::vector<ForeachDimension*> allocated in foreach_dimension_list
         delete dims;
     }
#line 7404 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 362: /* $@3: %empty  */
#line 2628 "src/parse.yy"
     {
         if ((yyvsp[-1].symbol) != nullptr)
             m->symbolTable->AddVariable((yyvsp[-1].symbol));
     }
#line 7413 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 363: /* iteration_statement: foreach_active_scope '(' foreach_active_identifier ')' $@3 attributed_statement  */
#line 2633 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachActiveStmt((yyvsp[-3].symbol), (yyvsp[0].stmt), Union((yylsp[-5]), (yylsp[-2])));
         m->symbolTable->PopScope();
     }
#line 7422 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 364: /* $@4: %empty  */
#line 2639 "src/parse.yy"
     {
         Expr *expr = (yyvsp[-1].expr);
         const Type *type;
         if (expr != nullptr &&
             (expr = TypeCheck(expr)) != nullptr &&
             (type = expr->GetType()) != nullptr) {
             const Type *iterType = type->GetAsUniformType()->GetAsConstType();
             Symbol *sym = new Symbol((yyvsp[-3].constCharPtr), (yylsp[-3]), Symbol::SymbolKind::Variable, iterType);
             m->symbolTable->AddVariable(sym);
         }
     }
#line 7438 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 365: /* iteration_statement: foreach_unique_scope '(' foreach_unique_identifier TOKEN_IN expression ')' $@4 attributed_statement  */
#line 2651 "src/parse.yy"
     {
         (yyval.stmt) = new ForeachUniqueStmt((yyvsp[-5].constCharPtr), (yyvsp[-3].expr), (yyvsp[0].stmt), (yylsp[-7]));
         m->symbolTable->PopScope();

         // allocated by strdup in foreach_unique_identifier
         free((char*)(yyvsp[-5].constCharPtr));
     }
#line 7450 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 366: /* goto_identifier: TOKEN_IDENTIFIER  */
#line 2662 "src/parse.yy"
      {
          (yyval.constCharPtr) = strdup((yyvsp[0].stringVal)->c_str());
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 7459 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 367: /* jump_statement: TOKEN_GOTO goto_identifier ';'  */
#line 2670 "src/parse.yy"
      {
          (yyval.stmt) = new GotoStmt((yyvsp[-1].constCharPtr), (yylsp[-2]), (yylsp[-1]));
          // allocated by strdup in goto_identifier
          free((char*)(yyvsp[-1].constCharPtr));
      }
#line 7469 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 368: /* jump_statement: TOKEN_CONTINUE ';'  */
#line 2676 "src/parse.yy"
      { (yyval.stmt) = new ContinueStmt((yylsp[-1])); }
#line 7475 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 369: /* jump_statement: TOKEN_BREAK ';'  */
#line 2678 "src/parse.yy"
      { (yyval.stmt) = new BreakStmt((yylsp[-1])); }
#line 7481 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 370: /* jump_statement: TOKEN_RETURN ';'  */
#line 2680 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt(nullptr, (yylsp[-1])); }
#line 7487 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 371: /* jump_statement: TOKEN_RETURN expression ';'  */
#line 2682 "src/parse.yy"
      { (yyval.stmt) = new ReturnStmt((yyvsp[-1].expr), (yylsp[-2])); }
#line 7493 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 372: /* sync_statement: TOKEN_SYNC ';'  */
#line 2687 "src/parse.yy"
      { (yyval.stmt) = new ExprStmt(new SyncExpr((yylsp[-1])), (yylsp[-1])); }
#line 7499 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 373: /* delete_statement: TOKEN_DELETE expression ';'  */
#line 2692 "src/parse.yy"
    {
        (yyval.stmt) = new DeleteStmt((yyvsp[-1].expr), Union((yylsp[-2]), (yylsp[-1])));
    }
#line 7507 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 374: /* unmasked_statement: TOKEN_UNMASKED '{' statement_list '}'  */
#line 2699 "src/parse.yy"
    {
        (yyval.stmt) = new UnmaskedStmt((yyvsp[-1].stmt), (yylsp[-3]));
    }
#line 7515 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 375: /* print_statement: TOKEN_PRINT '(' string_constant ')' ';'  */
#line 2706 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-2].stringVal), nullptr, (yylsp[-4]));
           // deallocate std::string of string_constant
           lCleanUpString((yyvsp[-2].stringVal));
      }
#line 7525 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 376: /* print_statement: TOKEN_PRINT '(' string_constant ',' argument_expression_list ')' ';'  */
#line 2712 "src/parse.yy"
      {
           (yyval.stmt) = new PrintStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].exprList), (yylsp[-6]));
           // deallocate std::string of string_constant
           lCleanUpString((yyvsp[-4].stringVal));
      }
#line 7535 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 377: /* assert_statement: TOKEN_ASSERT '(' string_constant ',' expression ')' ';'  */
#line 2721 "src/parse.yy"
      {
          (yyval.stmt) = new AssertStmt(*(yyvsp[-4].stringVal), (yyvsp[-2].expr), (yylsp[-6]));
          // deallocate std::string of string_constant
          lCleanUpString((yyvsp[-4].stringVal));
      }
#line 7545 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 387: /* external_declaration: TOKEN_EXPORT '{' type_specifier_list '}' ';'  */
#line 2742 "src/parse.yy"
    {
        if ((yyvsp[-2].typeList) != nullptr)
            m->AddExportedTypes(*(yyvsp[-2].typeList));
    }
#line 7554 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 388: /* external_declaration: declaration  */
#line 2747 "src/parse.yy"
    {
        if ((yyvsp[0].declaration) != nullptr)
            for (unsigned int i = 0; i < (yyvsp[0].declaration)->declarators.size(); ++i)
                lAddDeclaration((yyvsp[0].declaration)->declSpecs, (yyvsp[0].declaration)->declarators[i]);
    }
#line 7564 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 390: /* $@5: %empty  */
#line 2757 "src/parse.yy"
    {
        lAddDeclaration((yyvsp[-1].declSpecs), (yyvsp[0].declarator));
        m->symbolTable->PushScope();
        lAddFunctionParams((yyvsp[0].declarator));
        lAddMaskToSymbolTable((yylsp[0]));
        if ((yyvsp[-1].declSpecs)->typeQualifiers & TYPEQUAL_TASK)
            lAddThreadIndexCountToSymbolTable((yylsp[0]));
    }
#line 7577 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 391: /* function_definition: declaration_specifiers declarator $@5 compound_statement  */
#line 2766 "src/parse.yy"
    {
        if ((yyvsp[-2].declarator) != nullptr) {
            // FIXME: Next list is redundant, as it's done in lAddDeclaration()
            (yyvsp[-2].declarator)->InitFromDeclSpecs((yyvsp[-3].declSpecs));
            const FunctionType *funcType = CastType<FunctionType>((yyvsp[-2].declarator)->type);
            if (funcType == nullptr)
                AssertPos((yylsp[-3]), m->errorCount > 0);
            else if ((yyvsp[-3].declSpecs)->storageClass.IsTypedef())
                Error((yylsp[-3]), "Illegal \"typedef\" provided with function definition.");
            else {
                Stmt *code = (yyvsp[0].stmt);
                if (code == nullptr) code = new StmtList((yylsp[0]));
                m->AddFunctionDefinition((yyvsp[-2].declarator)->name, funcType, code);
            }
        }
        m->symbolTable->PopScope(); // push in lAddFunctionParams();
    }
#line 7599 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 392: /* template_type_parameter: TOKEN_TYPENAME TOKEN_IDENTIFIER  */
#line 2795 "src/parse.yy"
      {
          (yyval.templateTypeParm) = new TemplateTypeParmType(*(yyvsp[0].stringVal), Variability::VarType::Unbound, false, Union((yylsp[-1]), (yylsp[0])));
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 7608 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 393: /* template_type_parameter: TOKEN_TYPENAME TOKEN_IDENTIFIER '=' type_specifier  */
#line 2800 "src/parse.yy"
      {
          (yyval.templateTypeParm) = new TemplateTypeParmType(*(yyvsp[-2].stringVal), Variability::VarType::Unbound, false, Union((yylsp[-3]), (yylsp[-2])));
          lCleanUpString((yyvsp[-2].stringVal));
          // TODO: implement
          Error((yylsp[0]), "Default values for template type parameters are not yet supported.");
      }
#line 7619 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 394: /* int_constant_type: TOKEN_INT8  */
#line 2809 "src/parse.yy"
                   { (yyval.type) = AtomicType::UniformInt8->GetAsConstType(); }
#line 7625 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 395: /* int_constant_type: TOKEN_INT16  */
#line 2810 "src/parse.yy"
                   { (yyval.type) = AtomicType::UniformInt16->GetAsConstType(); }
#line 7631 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 396: /* int_constant_type: TOKEN_INT  */
#line 2811 "src/parse.yy"
                   { (yyval.type) = AtomicType::UniformInt32->GetAsConstType(); }
#line 7637 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 397: /* int_constant_type: TOKEN_INT64  */
#line 2812 "src/parse.yy"
                   { (yyval.type) = AtomicType::UniformInt64->GetAsConstType(); }
#line 7643 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 398: /* int_constant_type: TOKEN_UINT8  */
#line 2813 "src/parse.yy"
                   { (yyval.type) = AtomicType::UniformUInt8->GetAsConstType(); }
#line 7649 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 399: /* int_constant_type: TOKEN_UINT16  */
#line 2814 "src/parse.yy"
                   { (yyval.type) = AtomicType::UniformUInt16->GetAsConstType(); }
#line 7655 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 400: /* int_constant_type: TOKEN_UINT  */
#line 2815 "src/parse.yy"
                   { (yyval.type) = AtomicType::UniformUInt32->GetAsConstType(); }
#line 7661 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 401: /* int_constant_type: TOKEN_UINT64  */
#line 2816 "src/parse.yy"
                   { (yyval.type) = AtomicType::UniformUInt64->GetAsConstType(); }
#line 7667 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 402: /* int_constant_type: TOKEN_BOOL  */
#line 2817 "src/parse.yy"
                   { (yyval.type) = AtomicType::UniformBool->GetAsConstType(); }
#line 7673 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 403: /* template_int_constant_type: TOKEN_UNIFORM int_constant_type  */
#line 2821 "src/parse.yy"
                                      { (yyval.type) = (yyvsp[0].type); }
#line 7679 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 404: /* template_int_constant_type: int_constant_type  */
#line 2822 "src/parse.yy"
                        { (yyval.type) = (yyvsp[0].type);}
#line 7685 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 405: /* template_int_parameter: template_int_constant_type TOKEN_IDENTIFIER  */
#line 2827 "src/parse.yy"
      {
          (yyval.symbol) = new Symbol(*(yyvsp[0].stringVal), Union((yylsp[-1]), (yylsp[0])), Symbol::SymbolKind::TemplateNonTypeParm, (yyvsp[-1].type));
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 7694 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 406: /* template_int_parameter: template_int_constant_type TOKEN_IDENTIFIER '=' int_constant  */
#line 2832 "src/parse.yy"
      {
          (yyval.symbol) = new Symbol(*(yyvsp[-2].stringVal), Union((yylsp[-3]), (yylsp[-2])), Symbol::SymbolKind::TemplateNonTypeParm, (yyvsp[-3].type));
          lCleanUpString((yyvsp[-2].stringVal));
          // TODO: implement
          Error((yylsp[0]), "Default values for template non-type parameters are not yet supported.");
      }
#line 7705 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 407: /* template_enum_parameter: TOKEN_TYPE_NAME TOKEN_IDENTIFIER  */
#line 2842 "src/parse.yy"
      {
          const Type *type = m->symbolTable->LookupType((yyvsp[-1].stringVal)->c_str());
          const EnumType *enumType = CastType<EnumType>(type);
          if (enumType == nullptr) {
            Error((yylsp[-1]), "Only enum types and integral types are allowed as non-type template parameters.");
          }
          (yyval.symbol) = new Symbol(*(yyvsp[0].stringVal), Union((yylsp[-1]), (yylsp[0])), Symbol::SymbolKind::TemplateNonTypeParm, enumType->GetAsConstType()->GetAsUniformType());
          lCleanUpString((yyvsp[-1].stringVal));
          lCleanUpString((yyvsp[0].stringVal));
      }
#line 7720 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 408: /* template_parameter: template_type_parameter  */
#line 2855 "src/parse.yy"
    {
        if ((yyvsp[0].templateTypeParm) != nullptr) {
            (yyval.templateParm) = new TemplateParam((yyvsp[0].templateTypeParm));
        }
    }
#line 7730 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 409: /* template_parameter: template_int_parameter  */
#line 2861 "src/parse.yy"
    {
        if ((yyvsp[0].symbol) != nullptr) {
            (yyval.templateParm) = new TemplateParam((yyvsp[0].symbol));
        }
    }
#line 7740 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 410: /* template_parameter: template_enum_parameter  */
#line 2867 "src/parse.yy"
    {
        if ((yyvsp[0].symbol) != nullptr) {
            (yyval.templateParm) = new TemplateParam((yyvsp[0].symbol));
        }
    }
#line 7750 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 411: /* template_parameter_list: template_parameter  */
#line 2876 "src/parse.yy"
      {
          TemplateParms *list = new TemplateParms();
          if ((yyvsp[0].templateParm) != nullptr) {
              list->Add((yyvsp[0].templateParm));
          }
          (yyval.templateParmList) = list;
      }
#line 7762 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 412: /* template_parameter_list: template_parameter_list ',' template_parameter  */
#line 2884 "src/parse.yy"
      {
          TemplateParms *list = (TemplateParms *) (yyvsp[-2].templateParmList);
          if (list == nullptr) {
              AssertPos((yylsp[-2]), m->errorCount > 0);
              list = new TemplateParms();
          }
          if ((yyvsp[0].templateParm) != nullptr) {
              list->Add((yyvsp[0].templateParm));
          }
          (yyval.templateParmList) = list;
      }
#line 7778 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 413: /* template_head: TOKEN_TEMPLATE '<' template_parameter_list '>'  */
#line 2899 "src/parse.yy"
      {
          (yyval.templateParmList) = (yyvsp[-1].templateParmList);
      }
#line 7786 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 414: /* $@6: %empty  */
#line 2906 "src/parse.yy"
      {
          // Scope for template parameters definition
          m->symbolTable->PushScope();
          TemplateParms *list = (TemplateParms *) (yyvsp[0].templateParmList);
          for(size_t i = 0; i < list->GetCount(); i++) {
              std::string name = (*list)[i]->GetName();
              SourcePos pos = (*list)[i]->GetSourcePos();
              if ((*list)[i]->IsTypeParam()) {
                  m->AddTypeDef(name, (*list)[i]->GetTypeParam(), pos);
              } else if ((*list)[i]->IsNonTypeParam()) {
                  m->symbolTable->AddVariable((*list)[i]->GetNonTypeParam());
              }
          }
      }
#line 7805 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 415: /* template_declaration: template_head $@6 declaration_specifiers declarator  */
#line 2921 "src/parse.yy"
      {
          lAddTemplateDeclaration((yyvsp[-3].templateParmList), (yyvsp[-1].declSpecs), (yyvsp[0].declarator));
          lAddFunctionParams((yyvsp[0].declarator));
          lAddMaskToSymbolTable((yylsp[0]));
          const FunctionType *ft = CastType<FunctionType>((yyvsp[0].declarator)->type);
          // Creating a new TemplateSymbol just to pass it further seems to be a waste
          (yyval.functionTemplateSym) = new TemplateSymbol((yyvsp[-3].templateParmList), (yyvsp[0].declarator)->name, ft, (yyvsp[-1].declSpecs)->storageClass, (yylsp[0]), false /*not used*/, false /*not used*/);
      }
#line 7818 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 416: /* template_function_declaration_or_definition: template_declaration ';'  */
#line 2933 "src/parse.yy"
      {
          // deallocate TemplateSymbol created in template_declaration
          delete (yyvsp[-1].functionTemplateSym);
          // End templates parameters definition scope
          m->symbolTable->PopScope();
      }
#line 7829 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 417: /* template_function_declaration_or_definition: template_declaration compound_statement  */
#line 2940 "src/parse.yy"
      {
          if ((yyvsp[-1].functionTemplateSym) != nullptr) {
              Stmt *code = (yyvsp[0].stmt);
              if (code == nullptr) code = new StmtList((yylsp[0]));
              m->AddFunctionTemplateDefinition((yyvsp[-1].functionTemplateSym)->templateParms, (yyvsp[-1].functionTemplateSym)->name, (yyvsp[-1].functionTemplateSym)->type, code);
              // deallocate TemplateSymbol created in template_declaration
              delete (yyvsp[-1].functionTemplateSym);
          }

          // End templates parameters definition scope
          m->symbolTable->PopScope();
      }
#line 7846 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 418: /* template_argument: rate_qualified_type_specifier  */
#line 2956 "src/parse.yy"
    {
        (yyval.templateArg) = new TemplateArg((yyvsp[0].type), (yylsp[0]));
    }
#line 7854 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 419: /* template_argument: TOKEN_INT8_CONSTANT  */
#line 2962 "src/parse.yy"
                          {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformInt8->GetAsConstType(),
                           (int8_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 7863 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 420: /* template_argument: TOKEN_UINT8_CONSTANT  */
#line 2966 "src/parse.yy"
                           {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformUInt8->GetAsConstType(),
                           (uint8_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 7872 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 421: /* template_argument: TOKEN_INT16_CONSTANT  */
#line 2970 "src/parse.yy"
                           {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformInt16->GetAsConstType(),
                           (int16_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 7881 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 422: /* template_argument: TOKEN_UINT16_CONSTANT  */
#line 2974 "src/parse.yy"
                            {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformUInt16->GetAsConstType(),
                           (uint16_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 7890 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 423: /* template_argument: TOKEN_INT32_CONSTANT  */
#line 2978 "src/parse.yy"
                           {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformInt32->GetAsConstType(),
                           (int32_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 7899 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 424: /* template_argument: TOKEN_UINT32_CONSTANT  */
#line 2982 "src/parse.yy"
                            {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformUInt32->GetAsConstType(),
                           (uint32_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 7908 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 425: /* template_argument: TOKEN_INT64_CONSTANT  */
#line 2986 "src/parse.yy"
                           {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformInt64->GetAsConstType(),
                           (int64_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 7917 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 426: /* template_argument: TOKEN_UINT64_CONSTANT  */
#line 2990 "src/parse.yy"
                            {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformUInt64->GetAsConstType(),
                           (uint64_t)yylval.intVal, (yylsp[0])), (yylsp[0]));
    }
#line 7926 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 427: /* template_argument: TOKEN_TRUE  */
#line 2994 "src/parse.yy"
                 {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformBool->GetAsConstType(), true, (yylsp[0])), (yylsp[0]));
    }
#line 7934 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 428: /* template_argument: TOKEN_FALSE  */
#line 2997 "src/parse.yy"
                  {
        (yyval.templateArg) = new TemplateArg(new ConstExpr(AtomicType::UniformBool->GetAsConstType(), false, (yylsp[0])), (yylsp[0]));
    }
#line 7942 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 429: /* template_argument: TOKEN_IDENTIFIER  */
#line 3002 "src/parse.yy"
    {
        const char *name = (yyvsp[0].stringVal)->c_str();
        Symbol *s = m->symbolTable->LookupVariable(name);
        if (s) {
            if (s->GetSymbolKind() == Symbol::SymbolKind::Enumerator ||
                s->GetSymbolKind() == Symbol::SymbolKind::TemplateNonTypeParm) {
                (yyval.templateArg) = new TemplateArg(new SymbolExpr(s, (yylsp[0])), (yylsp[0]));
            } else {
                Error((yylsp[0]), "Only integral, enum types and non-type template parameters are allowed as template arguments.");
                (yyval.templateArg) = nullptr;
            }
        } else {
            Error((yylsp[0]), "Unknown identifier");
            (yyval.templateArg) = nullptr;
        }
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 7964 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 430: /* template_argument_list: template_argument  */
#line 3023 "src/parse.yy"
      {
          TemplateArgs *templArgs = new TemplateArgs();
          if ((yyvsp[0].templateArg) != nullptr) {
            templArgs->push_back(*(yyvsp[0].templateArg));
          }
          (yyval.templateArgs) = templArgs;

      }
#line 7977 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 431: /* template_argument_list: template_argument_list ',' template_argument  */
#line 3032 "src/parse.yy"
      {
          TemplateArgs *templArgs = (TemplateArgs *) (yyvsp[-2].templateArgs);
          if ((yyvsp[0].templateArg) != nullptr) {
            templArgs->push_back(*(yyvsp[0].templateArg));
          }
          (yyval.templateArgs) = templArgs;
      }
#line 7989 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 432: /* template_identifier: TOKEN_TEMPLATE_NAME  */
#line 3043 "src/parse.yy"
    {
        (yyval.constCharPtr) = strdup(yytext);
        lCleanUpString((yyvsp[0].stringVal));
    }
#line 7998 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 433: /* simple_template_id: template_identifier '<' template_argument_list '>'  */
#line 3051 "src/parse.yy"
      {
          // Template ID declartor
          Declarator *d = new Declarator(DK_BASE, (yylsp[-3]));
          d->name = (yyvsp[-3].constCharPtr);
          // allocated by strdup in template_identifier
          free((char*)(yyvsp[-3].constCharPtr));
          // Arguments vector
          TemplateArgs *templArgs = (TemplateArgs *) (yyvsp[-1].templateArgs);
          // Bundle template ID declarator and type list.
          (yyval.simpleTemplateID) = new std::pair(d, templArgs);
      }
#line 8014 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 434: /* simple_template_id: template_identifier  */
#line 3063 "src/parse.yy"
      {
          // Template ID declartor
          Declarator *d = new Declarator(DK_BASE, (yylsp[0]));
          d->name = (yyvsp[0].constCharPtr);
          // allocated by strdup in template_identifier
          free((char*)(yyvsp[0].constCharPtr));
          // Arguments vector
          TemplateArgs *templArgs = new TemplateArgs();
          // Bundle template ID declarator and empty type list.
          (yyval.simpleTemplateID) = new std::pair(d, templArgs);
      }
#line 8030 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 435: /* template_function_instantiation: TOKEN_TEMPLATE declaration_specifiers simple_template_id '(' parameter_type_list ')' ';'  */
#line 3080 "src/parse.yy"
      {
          SimpleTemplateIDType *simpleTemplID = (SimpleTemplateIDType *) (yyvsp[-4].simpleTemplateID);

          // Function declarator
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-6]), (yylsp[-1])));
          d->child = simpleTemplID->first;
          if ((yyvsp[-2].declarationList) != nullptr) {
              d->functionParams = *(yyvsp[-2].declarationList);
              // parameter_type_list returns vector of Declarations that is not needed anymore.
              delete (yyvsp[-2].declarationList);
          }

          d->InitFromDeclSpecs((yyvsp[-5].declSpecs));
          lCheckTemplateDeclSpecs((yyvsp[-5].declSpecs), d->pos, TemplateType::Instantiation, (yyvsp[-4].simpleTemplateID)->first->name.c_str());
          const FunctionType *ftype = CastType<FunctionType>(d->type);
          bool isInline = ((yyvsp[-5].declSpecs)->typeQualifiers & TYPEQUAL_INLINE);
          bool isNoInline = ((yyvsp[-5].declSpecs)->typeQualifiers & TYPEQUAL_NOINLINE);
          if ((yyvsp[-4].simpleTemplateID)->second->size() == 0) {
              Error(d->pos, "Template arguments deduction is not yet supported in explicit template instantiation.");
          }
          m->AddFunctionTemplateInstantiation((yyvsp[-4].simpleTemplateID)->first->name, *(yyvsp[-4].simpleTemplateID)->second, ftype, (yyvsp[-5].declSpecs)->storageClass, isInline, isNoInline, Union((yylsp[-6]), (yylsp[-1])));

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID(simpleTemplID);
      }
#line 8060 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 436: /* template_function_instantiation: TOKEN_TEMPLATE declaration_specifiers simple_template_id '(' ')' ';'  */
#line 3106 "src/parse.yy"
      {
          SimpleTemplateIDType *simpleTemplID = (SimpleTemplateIDType *) (yyvsp[-3].simpleTemplateID);

          // Function declarator
          Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-5]), (yylsp[-1])));
          d->child = simpleTemplID->first;

          d->InitFromDeclSpecs((yyvsp[-4].declSpecs));
          lCheckTemplateDeclSpecs((yyvsp[-4].declSpecs), d->pos, TemplateType::Instantiation, (yyvsp[-3].simpleTemplateID)->first->name.c_str());
          const FunctionType *ftype = CastType<FunctionType>(d->type);
          bool isInline = ((yyvsp[-4].declSpecs)->typeQualifiers & TYPEQUAL_INLINE);
          bool isNoInline = ((yyvsp[-4].declSpecs)->typeQualifiers & TYPEQUAL_NOINLINE);
          if ((yyvsp[-3].simpleTemplateID)->second->size() == 0) {
              Error(d->pos, "Template arguments deduction is not yet supported in explicit template instantiation.");
          }
          m->AddFunctionTemplateInstantiation((yyvsp[-3].simpleTemplateID)->first->name, *(yyvsp[-3].simpleTemplateID)->second, ftype, (yyvsp[-4].declSpecs)->storageClass, isInline, isNoInline, Union((yylsp[-5]), (yylsp[-1])));

          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID(simpleTemplID);
      }
#line 8085 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 437: /* template_function_instantiation: TOKEN_TEMPLATE declaration_specifiers simple_template_id '(' error ')' ';'  */
#line 3127 "src/parse.yy"
      {
          // deallocate SimpleTemplateIDType returned by simple_template_id
          lFreeSimpleTemplateID((yyvsp[-4].simpleTemplateID));
      }
#line 8094 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 438: /* template_function_specialization_declaration: TOKEN_TEMPLATE '<' '>' declaration_specifiers simple_template_id '(' parameter_type_list ')'  */
#line 3137 "src/parse.yy"
      {
        // Function declarator
        Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-7]), (yylsp[0])));
        d->child = (yyvsp[-3].simpleTemplateID)->first;

        if ((yyvsp[-1].declarationList) != nullptr) {
            d->functionParams = *(yyvsp[-1].declarationList);
            // parameter_type_list returns vector of Declarations that is not needed anymore.
            delete (yyvsp[-1].declarationList);
        }
        TemplateArgs *templArgs = new TemplateArgs(*(yyvsp[-3].simpleTemplateID)->second);
        Assert(templArgs);
        lAddTemplateSpecialization(*templArgs, (yyvsp[-4].declSpecs), d);
        m->symbolTable->PushScope();

        lAddFunctionParams(d);
        lAddMaskToSymbolTable((yylsp[-3]));
        // deallocate SimpleTemplateIDType returned by simple_template_id
        lFreeSimpleTemplateID((yyvsp[-3].simpleTemplateID));
        (yyval.simpleTemplateID) = new std::pair(d, templArgs);
      }
#line 8120 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 439: /* template_function_specialization_declaration: TOKEN_TEMPLATE '<' '>' declaration_specifiers simple_template_id '(' ')'  */
#line 3159 "src/parse.yy"
      {
        Declarator *d = new Declarator(DK_FUNCTION, Union((yylsp[-6]), (yylsp[-2])));
        d->child = (yyvsp[-2].simpleTemplateID)->first;
        TemplateArgs *templArgs = new TemplateArgs(*(yyvsp[-2].simpleTemplateID)->second);
        Assert(templArgs);
        lAddTemplateSpecialization(*templArgs, (yyvsp[-3].declSpecs), d);
        m->symbolTable->PushScope();

        lAddMaskToSymbolTable((yylsp[-2]));
        // deallocate SimpleTemplateIDType returned by simple_template_id
        lFreeSimpleTemplateID((yyvsp[-2].simpleTemplateID));
        (yyval.simpleTemplateID) = new std::pair(d, templArgs);
      }
#line 8138 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 440: /* template_function_specialization_declaration: TOKEN_TEMPLATE '<' '>' declaration_specifiers simple_template_id '(' error ')'  */
#line 3173 "src/parse.yy"
      {
        m->symbolTable->PushScope();
        // deallocate SimpleTemplateIDType returned by simple_template_id
        lFreeSimpleTemplateID((yyvsp[-3].simpleTemplateID));
        (yyval.simpleTemplateID) = nullptr;
      }
#line 8149 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 441: /* template_function_specialization: template_function_specialization_declaration ';'  */
#line 3183 "src/parse.yy"
      {
          if ((yyvsp[-1].simpleTemplateID) != nullptr) {
            // deallocate TemplateSymbol created in template_declaration
            lFreeSimpleTemplateID((yyvsp[-1].simpleTemplateID));
          }
          // End templates parameters definition scope
          m->symbolTable->PopScope();
      }
#line 8162 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;

  case 442: /* template_function_specialization: template_function_specialization_declaration compound_statement  */
#line 3192 "src/parse.yy"
      {
        if ((yyvsp[-1].simpleTemplateID) != nullptr) {
            Declarator *d = (yyvsp[-1].simpleTemplateID)->first;
            const FunctionType *ftype = CastType<FunctionType>(d->type);
            if (ftype == nullptr)
                AssertPos((yylsp[-1]), m->errorCount > 0);
            else {
                Stmt *code = (yyvsp[0].stmt);
                if (code == nullptr) code = new StmtList((yylsp[0]));
                m->AddFunctionTemplateSpecializationDefinition(d->name, ftype, *(yyvsp[-1].simpleTemplateID)->second, Union((yylsp[-1]), (yylsp[0])), code);
            }
           lFreeSimpleTemplateID((yyvsp[-1].simpleTemplateID));
        }
        m->symbolTable->PopScope();
      }
#line 8182 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"
    break;


#line 8186 "/builddir/build/BUILD/ispc-1.27.0-build/ispc-1.27.0/redhat-linux-build/./parse.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 3209 "src/parse.yy"



void yyerror(const char *s) {
    if (strlen(yytext) == 0)
        Error(yylloc, "Premature end of file: %s.", s);
    else
        Error(yylloc, "%s.", s);
}

void lCleanUpString(std::string *s) {
    if (s) {
         delete s;
    }
}

void lFreeSimpleTemplateID(void *p) {
    SimpleTemplateIDType *sid = (SimpleTemplateIDType*) p;
    TemplateArgs *templArgs = sid->second;
    if (templArgs) {
        delete templArgs;
    }
    if (sid) {
        delete sid;
    }
}

static int
lYYTNameErr (char *yyres, const char *yystr)
{
  extern std::map<std::string, std::string> tokenNameRemap;
  Assert(tokenNameRemap.size() > 0);
  if (tokenNameRemap.find(yystr) != tokenNameRemap.end()) {
      std::string n = tokenNameRemap[yystr];
      if (yyres == nullptr)
          return n.size();
      else
          return yystpcpy(yyres, n.c_str()) - yyres;
  }

  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}

static void
lSuggestBuiltinAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lBuiltinTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
         Error(yylloc, "%s", alts.c_str());
}


static void
lSuggestParamListAlternates() {
    std::vector<std::string> builtinTokens;
    const char **token = lParamListTokens;
    while (*token) {
        builtinTokens.push_back(*token);
        ++token;
    }
    std::vector<std::string> alternates = MatchStrings(yytext, builtinTokens);
    std::string alts = lGetAlternates(alternates);
    if (alts.size() > 0)
        Error(yylloc, "%s", alts.c_str());
}


static void
lAddDeclaration(DeclSpecs *ds, Declarator *decl) {
    if (ds == nullptr || decl == nullptr)
        // Error happened earlier during parsing
        return;

    decl->InitFromDeclSpecs(ds);
    if (ds->storageClass.IsTypedef()) {
        const StructType *st = CastType<StructType>(decl->type);
        if (st && st->IsAnonymousType()) {
            st = st->GetAsNamed(decl->name);
            m->AddTypeDef(decl->name, st, decl->pos);
        } else {
            AttributeList *attrs = decl->attributeList;
            if (attrs && attrs->HasAttribute("aligned")) {
                unsigned int alignment = attrs->GetAlignedAttrValue(decl->pos);
                const Type *aligned_type = decl->type->GetAsAlignedType(alignment);
                m->AddTypeDef(decl->name, aligned_type, decl->pos);
            } else {
                m->AddTypeDef(decl->name, decl->type, decl->pos);
            }
        }
    } else {
        if (decl->type == nullptr) {
            Assert(m->errorCount > 0);
            return;
        }

        decl->type = decl->type->ResolveUnboundVariability(Variability::Varying);

        const FunctionType *ft = CastType<FunctionType>(decl->type);
        if (ft != nullptr) {
            bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
            bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
            bool isVectorCall = (ds->typeQualifiers & TYPEQUAL_VECTORCALL);
            bool isRegCall = (ds->typeQualifiers & TYPEQUAL_REGCALL);
            Declarator *funcDecl = decl;

            // In a case when function return type is a pointer we have decl
            // with DK_POINTER kind. We need to traverse childs to get
            // DK_FUNCTION declarator.
            while (funcDecl && funcDecl->kind != DK_FUNCTION) {
                funcDecl = funcDecl->child;
            }
            Assert(funcDecl);

            // For pointer return type we have attributeList attached to decl
            // (DK_POINTER) whereas we need to pass DK_FUNCTION declarator to
            // AddFunctionDeclaration. Create a copy of DK_FUNCTION and attach
            // attributeList from DK_POINTER.
            Declarator funcDeclCopy = *funcDecl;
            if (decl->attributeList) {
                funcDeclCopy.attributeList = new AttributeList(*decl->attributeList);
            }

            m->AddFunctionDeclaration(decl->name, ft, ds->storageClass, &funcDeclCopy,
                                      isInline, isNoInline, isVectorCall, isRegCall, decl->pos);
        }
        else {
            bool isConst = (ds->typeQualifiers & TYPEQUAL_CONST) != 0;
            m->AddGlobalVariable(decl, isConst);
        }
    }
}

static void
lCheckTemplateDeclSpecs(DeclSpecs *ds, SourcePos pos, TemplateType type, const char* name) {
    std::string templateTypeStr;
    switch (type) {
        case TemplateType::Template:
            templateTypeStr = "function template";
            break;
        case TemplateType::Instantiation:
            templateTypeStr = "template instantiation";
            break;
        case TemplateType::Specialization:
            templateTypeStr = "template specialization";
            break;
        default:
            FATAL("Unhandled template type in lCheckTemplateDeclSpecs");
    }
    if (ds->typeQualifiers & TYPEQUAL_TASK){
        Error(pos, "'task' not supported for %s.", templateTypeStr.c_str());
        return;
    }
    if (ds->typeQualifiers & TYPEQUAL_EXPORT) {
        Error(pos, "'export' not supported for %s.", templateTypeStr.c_str());
        return;
    }
    if (ds->storageClass == StorageClass::TYPEDEF) {
        Error(pos, "Illegal \"typedef\" provided with %s.", templateTypeStr.c_str());
        return;
    }
    // We can't support extern "C"/extern "SYCL" for templates because
    // we need mangling information.
    if (ds->storageClass.IsExternC() || ds->storageClass.IsExternSYCL()) {
        Error(pos, "Illegal linkage provided with %s.", templateTypeStr.c_str());
        return;
    }
    Assert(ds->storageClass.IsNone() || ds->storageClass.IsStatic() || ds->storageClass.IsExtern());
    bool isVectorCall = (ds->typeQualifiers & TYPEQUAL_VECTORCALL);
    if (isVectorCall) {
        Error(pos, "Illegal to use \"__vectorcall\" qualifier on non-extern function \"%s\".", name);
    }
    bool isRegCall = (ds->typeQualifiers & TYPEQUAL_REGCALL);
    if (isRegCall) {
        Error(pos, "Illegal to use \"__regcall\" qualifier on non-extern function \"%s\".", name);
    }
}

static void
lAddTemplateDeclaration(TemplateParms *templateParmList, DeclSpecs *ds, Declarator *decl) {
    if (ds == nullptr || decl == nullptr) {
        // Error happened earlier during parsing
        return;
    }

    decl->InitFromDeclSpecs(ds);
    lCheckTemplateDeclSpecs(ds, decl->pos, TemplateType::Template, decl->name.c_str());

    if (decl->type == nullptr) {
        Assert(m->errorCount > 0);
        return;
    }

    const FunctionType *ft = CastType<FunctionType>(decl->type);
    if (ft != nullptr) {
        bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
        bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
        m->AddFunctionTemplateDeclaration(templateParmList, decl->name, ft, ds->storageClass,
                                          isInline, isNoInline, decl->pos);
    }
    else {
        Error(decl->pos, "Only function templates are supported.");
    }

}

static void
lAddTemplateSpecialization(const TemplateArgs &templArgs, DeclSpecs *ds, Declarator *decl) {
    if (ds == nullptr || decl == nullptr)
        // Error happened earlier during parsing
        return;

    decl->InitFromDeclSpecs(ds);
    lCheckTemplateDeclSpecs(ds, decl->pos, TemplateType::Specialization, decl->name.c_str());

    if (decl->type == nullptr) {
        Assert(m->errorCount > 0);
        return;
    }

    if (templArgs.size() == 0) {
        Error(decl->pos, "Template arguments deduction is not yet supported in template function specialization.");
        return;
    }

    const FunctionType *ftype = CastType<FunctionType>(decl->type);
    if (ftype != nullptr) {
        bool isInline = (ds->typeQualifiers & TYPEQUAL_INLINE);
        bool isNoInline = (ds->typeQualifiers & TYPEQUAL_NOINLINE);
        m->AddFunctionTemplateSpecializationDeclaration(decl->name, ftype, templArgs, ds->storageClass,
                                                        isInline, isNoInline, decl->pos);
    }
    else {
        Error(decl->pos, "Only function template specializations are supported.");
    }
}

/** We're about to start parsing the body of a function; add all of the
    parameters to the symbol table so that they're available.
*/
static void
lAddFunctionParams(Declarator *decl) {
    // It's responsibility of the caller to create a new symbol table scope.
    // For regular functions, the scope starts before function parameters.
    // For template functions, the scope starts before template parameters.
    if (decl == nullptr) {
        return;
    }

    // walk down to the declarator for the function itself
    while (decl->kind != DK_FUNCTION && decl->child != nullptr)
        decl = decl->child;
    if (decl->kind != DK_FUNCTION) {
        AssertPos(decl->pos, m->errorCount > 0);
        return;
    }

    // now loop over its parameters and add them to the symbol table
    for (unsigned int i = 0; i < decl->functionParams.size(); ++i) {
        Declaration *pdecl = decl->functionParams[i];
        Assert(pdecl != nullptr && pdecl->declarators.size() == 1);
        Declarator *declarator = pdecl->declarators[0];
        if (declarator == nullptr)
            AssertPos(decl->pos, m->errorCount > 0);
        else {
            Symbol *sym = new Symbol(declarator->name, declarator->pos, Symbol::SymbolKind::FunctionParm,
                                     declarator->type, declarator->storageClass);

            AttributeList *AL = declarator->attributeList;
            if (AL) {
                // Check for unknown attributes for parameters in function definitions.
                AL->CheckForUnknownAttributes(declarator->pos);
            }
#ifndef NDEBUG
            bool ok = m->symbolTable->AddVariable(sym);
            if (ok == false)
                AssertPos(decl->pos, m->errorCount > 0);
#else
            m->symbolTable->AddVariable(sym);
#endif
        }
    }

    // The corresponding pop scope happens in function_definition rules
    // above...
}


/** Add a symbol for the built-in mask variable to the symbol table */
static void lAddMaskToSymbolTable(SourcePos pos) {
    const Type *t = nullptr;
    switch (g->target->getMaskBitCount()) {
    case 1:
        t = AtomicType::VaryingBool;
        break;
    case 8:
        t = AtomicType::VaryingUInt8;
        break;
    case 16:
        t = AtomicType::VaryingUInt16;
        break;
    case 32:
        t = AtomicType::VaryingUInt32;
        break;
    case 64:
        t = AtomicType::VaryingUInt64;
        break;
    default:
        FATAL("Unhandled mask bitsize in lAddMaskToSymbolTable");
    }

    t = t->GetAsConstType();
    Symbol *maskSymbol = new Symbol("__mask", pos, Symbol::SymbolKind::Default, t);
    m->symbolTable->AddVariable(maskSymbol);
}


/** Add the thread index and thread count variables to the symbol table
    (this should only be done for 'task'-qualified functions. */
static void lAddThreadIndexCountToSymbolTable(SourcePos pos) {
    const Type *type = AtomicType::UniformUInt32->GetAsConstType();

    Symbol *threadIndexSym = new Symbol("threadIndex", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(threadIndexSym);

    Symbol *threadCountSym = new Symbol("threadCount", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(threadCountSym);

    Symbol *taskIndexSym = new Symbol("taskIndex", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskIndexSym);

    Symbol *taskCountSym = new Symbol("taskCount", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskCountSym);

    Symbol *taskIndexSym0 = new Symbol("taskIndex0", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskIndexSym0);
    Symbol *taskIndexSym1 = new Symbol("taskIndex1", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskIndexSym1);
    Symbol *taskIndexSym2 = new Symbol("taskIndex2", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskIndexSym2);


    Symbol *taskCountSym0 = new Symbol("taskCount0", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskCountSym0);
    Symbol *taskCountSym1 = new Symbol("taskCount1", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskCountSym1);
    Symbol *taskCountSym2 = new Symbol("taskCount2", pos, Symbol::SymbolKind::Default, type);
    m->symbolTable->AddVariable(taskCountSym2);
}


/** Small utility routine to construct a string for error messages that
    suggests alternate tokens for possibly-misspelled ones... */
static std::string lGetAlternates(std::vector<std::string> &alternates) {
    std::string alts;
    if (alternates.size()) {
        alts += " Did you mean ";
        for (unsigned int i = 0; i < alternates.size(); ++i) {
            alts += std::string("\"") + alternates[i] + std::string("\"");
            if (i < alternates.size() - 1) alts += ", or ";
        }
        alts += "?";
    }
    return alts;
}


/** Given an expression, see if it is equal to a compile-time constant
    integer value.  If so, return true and return the value in *value.
    If the expression isn't a compile-time constant or isn't an integer
    type, return false.
*/
static bool
lGetConstantIntOrSymbol(Expr *expr, std::variant<std::monostate, int, Symbol*> *value, SourcePos pos, const char *usage) {
    if (expr == nullptr)
        return false;
    expr = TypeCheck(expr);
    if (expr == nullptr)
        return false;
    expr = Optimize(expr);
    if (expr == nullptr)
        return false;
    const SymbolExpr* se= llvm::dyn_cast<SymbolExpr>(expr);
    if (se) {
        Symbol* s = se->GetBaseSymbol();
        if (s->GetSymbolKind() == Symbol::SymbolKind::TemplateNonTypeParm) {
            value->emplace<Symbol*>(s);
            return true;
        }
    }
    std::pair<llvm::Constant *, bool> cValPair = expr->GetConstant(expr->GetType());
    llvm::Constant *cval = cValPair.first;
    if (cval == nullptr) {
        Error(pos, "%s must be a compile-time constant or template non-type parameter.", usage);
        return false;
    }
    else {
        llvm::ConstantInt *ci = llvm::dyn_cast<llvm::ConstantInt>(cval);
        if (ci == nullptr) {
            Error(pos, "%s must be a compile-time integer constant.", usage);
            return false;
        }
        if ((int64_t)((int32_t)ci->getSExtValue()) != ci->getSExtValue()) {
            Error(pos, "%s must be representable with a 32-bit integer.", usage);
            return false;
        }
        const Type *type = expr->GetType();
        int resultValue = type->IsUnsignedType() ? (int)ci->getZExtValue() : (int)ci->getSExtValue();
        value->emplace<int>(resultValue);
        return true;
    }
}


static EnumType *
lCreateEnumType(const char *name, std::vector<Symbol *> *enums, SourcePos pos) {
    if (enums == nullptr)
        return nullptr;

    EnumType *enumType = name ? new EnumType(name, pos) : new EnumType(pos);
    if (name != nullptr)
        m->symbolTable->AddType(name, enumType, pos);

    lFinalizeEnumeratorSymbols(*enums, enumType);
    for (unsigned int i = 0; i < enums->size(); ++i)
        m->symbolTable->AddVariable((*enums)[i]);
    enumType->SetEnumerators(*enums);
    return enumType;
}

/* Create StructType and add it to the symbol table if it's not anonymous */
static StructType *lCreateStructType(const std::string &name, const std::vector<StructDeclaration *> *decl,
                                     AttributeList *attrs, SourcePos pos) {
    llvm::SmallVector<const Type *, 8> elementTypes;
    llvm::SmallVector<std::string, 8> elementNames;
    llvm::SmallVector<SourcePos, 8> elementPositions;
    unsigned int alignment = 0;

    if (attrs) {
        alignment = attrs->GetAlignedAttrValue(pos);
    }

    if (decl) {
        GetStructTypesNamesPositions(*decl, &elementTypes, &elementNames, &elementPositions);
    }

    StructType *st =
        new StructType(name, elementTypes, elementNames, elementPositions, false, Variability::Unbound, pos, alignment);
    st->RegisterInStructTypeMap();

    if (!name.empty()) {
        m->symbolTable->AddType(name.c_str(), st, pos);
    }

    return st;
}

/** Given an array of enumerator symbols, make sure each of them has a
    ConstExpr * in their Symbol::constValue member that stores their
    unsigned integer value.  Symbols that had values explicitly provided
    in the source file will already have ConstExpr * set; we just need
    to set the values for the others here.
*/
static void
lFinalizeEnumeratorSymbols(std::vector<Symbol *> &enums,
                           const EnumType *enumType) {
    const Type *constUniformType = enumType->GetAsConstType()->GetAsUniformType();

    /* nextVal tracks the value for the next enumerant.  It starts from
       zero and goes up with each successive enumerant.  If any of them
       has a value specified, then nextVal is ignored for that one and is
       set to one plus that one's value for the default value for the next
       one. */
    uint32_t nextVal = 0;

    for (unsigned int i = 0; i < enums.size(); ++i) {
        enums[i]->type = constUniformType;
        if (enums[i]->constValue != nullptr) {
            /* Already has a value, so first update nextVal with it. */
            int count = enums[i]->constValue->GetValues(&nextVal);
            AssertPos(enums[i]->pos, count == 1);
            ++nextVal;

            /* When the source file as being parsed, the ConstExpr for any
               enumerant with a specified value was set to have unsigned
               int32 type, since we haven't created the parent EnumType
               by then.  Therefore, add a little type cast from uint32 to
               the actual enum type here and optimize it, which will have
               us end up with a ConstExpr with the desired EnumType... */
            Expr *castExpr = new TypeCastExpr(constUniformType, enums[i]->constValue,
                                              enums[i]->pos);
            castExpr = Optimize(castExpr);
            enums[i]->constValue = llvm::dyn_cast<ConstExpr>(castExpr);
            AssertPos(enums[i]->pos, enums[i]->constValue != nullptr);
        }
        else {
            enums[i]->constValue = new ConstExpr(constUniformType, nextVal++,
                                                 enums[i]->pos);
        }
    }
}
